Attribute VB_Name = "TestIntersectCurvePlane"
Option Explicit

Sub TestIntersectCurvePlane()
    Dim oCurveElt As BsplineCurveElement
    Dim oEllipseElt As EllipseElement
    Dim oPoint As LineElement
    Dim oCurve As BsplineCurve
    Dim aPoles() As Point3d, aPoints() As Point3d
    Dim aParams() As Double
    Dim sPlane As Plane3d
    Dim sEllipse As Ellipse3d
    Dim i As Long

    'draw curve that intersects plane more than once
    Set oCurve = New BsplineCurve
    ReDim aPoles(1 To 5)
    aPoles(1) = Point3dFromXYZ(10#, 10#, 10#)
    aPoles(2) = Point3dFromXYZ(-10#, -10#, -10#)
    aPoles(3) = Point3dFromXYZ(5#, 10#, 7#)
    aPoles(4) = Point3dFromXYZ(-7#, -10#, 5#)
    aPoles(5) = Point3dFromXYZ(15#, 3#, 9#)
    oCurve.SetPoles aPoles
    Set oCurveElt = CreateBsplineCurveElement1(Nothing, oCurve)
    ActiveModelReference.AddElement oCurveElt
    oCurveElt.Redraw
    
    'set up plane
    sPlane.Origin = Point3dFromXYZ(0#, 0#, 1#)
    sPlane.normal = Point3dNormalize(Point3dOne)
    
    'visualize plane
    sEllipse.Center = sPlane.Origin
    sEllipse.Start = 0
    sEllipse.Sweep = 2 * Pi
    sEllipse.Vector0 = Point3dScale(Point3dNormalize(Point3dCrossProduct(sPlane.normal, Point3dFromXYZ(1, 0, 0))), 10)
    sEllipse.Vector90 = Point3dScale(Point3dNormalize(Point3dCrossProduct(sPlane.normal, sEllipse.Vector0)), 10)
    Set oEllipseElt = CreateEllipticalElement1(Nothing, sEllipse, msdFillModeFilled)
    ActiveModelReference.AddElement oEllipseElt
    oEllipseElt.Redraw
    
    'intersect curve and plane
    aPoints = oCurve.IntersectPlane3d(aParams, sPlane)
    
    For i = LBound(aPoints) To UBound(aPoints)
        Set oPoint = CreateLineElement2(Nothing, aPoints(i), aPoints(i))
        oPoint.LineWeight = 6
        ActiveModelReference.AddElement oPoint
        oPoint.Redraw
    Next i
    
    'draw curve translated beyond design cube
    Set oCurve = New BsplineCurve
    ReDim aPoles(1 To 2)
    aPoles(1) = Point3dFromXYZ(10000000000000#, 0#, 10#)
    aPoles(2) = Point3dFromXYZ(10000000000000#, 0#, -10#)
    oCurve.SetPoles aPoles
    Set oCurveElt = CreateBsplineCurveElement1(Nothing, oCurve)
    'ActiveModelReference.AddElement oCurveElt
    'oCurveElt.Redraw
    
    'set up xy-plane
    sPlane.Origin = Point3dZero
    sPlane.normal = Point3dFromXYZ(0#, 0#, 1#)
    
    'intersect curve and plane
    aPoints = oCurve.IntersectPlane3d(aParams, sPlane)
    
    For i = LBound(aPoints) To UBound(aPoints)
        Set oPoint = CreateLineElement2(Nothing, aPoints(i), aPoints(i))
        oPoint.LineWeight = 6
        'ActiveModelReference.AddElement oPoint
        'oPoint.Redraw
    Next i

End Sub
