Attribute VB_Name = "TestEllipticalElement"
Option Explicit

Sub TestEllipticalElement()
    Dim oElt As Element
    Dim oCurve As New BsplineCurve
    Dim oCurveElt As BsplineCurveElement
    Dim oArc As ArcElement
    Dim ellipse As Ellipse3d, ellipse2 As Ellipse3d
    Dim Tangent As Ray3d
    Dim Chord As Segment3d
    Dim StartPt As Point3d, EndPt As Point3d, PlanePt As Point3d
    Dim length As Double
    Dim color As Long
    
    StartPt = Point3dZero
    EndPt = Point3dFromXYZ(1#, 0#, 0#)
    PlanePt = Point3dFromXYZ(1#, 1#, 1#)
    
    ' CreateArcElement4 (point, tangent, point)
    Tangent.Origin = StartPt
    Tangent.Direction = Point3dSubtract(PlanePt, StartPt)
    Set oArc = CreateArcElement4(Nothing, Tangent, EndPt)
    oArc.color = 1
    ActiveModelReference.AddElement oArc
    oArc.Redraw
    
    ' Ellipse3dFromEllipticalElement, FromEllipse3d (open)
    ellipse = Ellipse3dFromEllipticalElement(oArc)
    oCurve.FromEllipse3d ellipse
    Set oCurveElt = CreateBsplineCurveElement1(oArc, oCurve)
    oCurveElt.LineStyle = ActiveDesignFile.LineStyles(2)
    oCurveElt.LineWeight = 3
    ActiveModelReference.AddElement oCurveElt
    oCurveElt.Redraw
    
    ' CreateArcElement5 (chord, arclength, plane pt)
    Chord.startPoint = StartPt
    Chord.EndPoint = EndPt
    length = 3#
    Set oArc = CreateArcElement5(oArc, Chord, length, PlanePt)
    oArc.color = oArc.color + 1
    ActiveModelReference.AddElement oArc
    oArc.Redraw
    
    ' CreateEllipticalElement (Ellipse)
    ellipse.Center = StartPt
    ellipse.Vector0 = EndPt
    ellipse.Vector90 = PlanePt
    ellipse.Start = 0#
    ellipse.Sweep = 2 * Pi
    Set oElt = CreateEllipticalElement1(Nothing, ellipse, msdFillModeFilled)
    color = oElt.AsClosedElement.fillColor
    oElt.color = oArc.color + 1     ' Setting element color also sets fill color!!!
    oElt.AsClosedElement.fillColor = color
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' Ellipse3dFromEllipticalElement, FromEllipse3d (closed)
    ellipse2 = Ellipse3dFromEllipticalElement(oElt)
    oCurve.FromEllipse3d ellipse2
    Set oCurveElt = CreateBsplineCurveElement1(oElt, oCurve)
    oCurveElt.LineStyle = ActiveDesignFile.LineStyles(2)
    oCurveElt.LineWeight = 3
    ActiveModelReference.AddElement oCurveElt
    oCurveElt.Redraw

    ' CreateEllipticalElement (Arc)
    ellipse.Vector0 = Point3dSubtract(PlanePt, EndPt)
    ellipse.Sweep = Pi * 2# / 3#
    Set oElt = CreateEllipticalElement1(oElt, ellipse)
    oElt.color = oElt.color + 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' ellipse -> Elt -> ellipse2 roundtrip (compare them)
    ellipse2 = Ellipse3dFromEllipticalElement(oElt)
    Set oElt = CreateEllipticalElement1(oElt, ellipse2)
    oElt.LineStyle = ActiveDesignFile.LineStyles(2)
    oElt.LineWeight = 3
    ActiveModelReference.AddElement oElt
    oElt.Redraw

End Sub
