Attribute VB_Name = "TestEvaluatePoint"
Option Explicit

Sub TestEvaluatePoint()
    Dim oElt As BsplineCurveElement
    Dim oPointString As PointStringElement
    Dim oCurve As BsplineCurve
    Dim aTangents() As Ray3d
    Dim aPoints() As Point3d, midPoint As Point3d, midPoint2 As Point3d
    Dim aParams() As Double, minError As Double, maxError As Double, length As Double, midParam As Double
    Dim i As Long, nPt As Long, nChord As Long, oops As Long
    
    Set oCurve = New BsplineCurve
    
    nPt = 4
    ReDim aTangents(1 To nPt)
    aTangents(1).Origin = Point3dFromXYZ(0#, 10#, 5#)
    'aTangents(1).Direction = Point3dFromXYZ(2#, 0#, 0#)  'linear segment: stroker fails
    aTangents(1).Direction = Point3dFromXYZ(2#, 0#, 1#)
    aTangents(2).Origin = Point3dFromXYZ(10#, 10#, 5#)
    aTangents(2).Direction = Point3dFromXYZ(2#, 0#, 0#)
    aTangents(3).Origin = Point3dFromXYZ(10#, 20#, 5#)
    aTangents(3).Direction = Point3dFromXYZ(-2#, 2#, 0#)
    aTangents(4).Origin = Point3dFromXYZ(0#, 20#, 5#)
    aTangents(4).Direction = Point3dFromXYZ(-2#, 0#, 0#)
    oCurve.FromTangents aTangents
    
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw

    ' points by EqualDeviationChords
    nChord = 5
    aPoints = oCurve.EvaluatePointsAtEqualDeviationChords(aParams, minError, maxError, nChord)
    
    Set oPointString = CreatePointStringElement1(Nothing, aPoints, False)
    oPointString.color = oElt.color + 1
    ActiveModelReference.AddElement oPointString
    oPointString.Redraw
    
    ' ComputeLength
    length = oCurve.ComputeLength(maxError)
    
    ' point at length
    midPoint = oCurve.EvaluatePointAtLength(midParam, maxError, length / 2#, , length)
    midPoint2 = oCurve.EvaluatePointAtLength(midParam, maxError, length / 2#)
    
    If Point3dDistance(midPoint, midPoint2) <> 0# Then
        oops = 1
    End If
    
    
End Sub

