Attribute VB_Name = "TestExtractPiece"
Option Explicit

Sub TestExtractPatch()
    Dim oSurfaceElt As BsplineSurfaceElement
    Dim oCurveElt As BsplineCurveElement
    Dim oSurface As New BsplineSurface, oSurfacePatch As BsplineSurface
    Dim aUCurves(0 To 1) As New BsplineCurve, aVCurves(0 To 1) As New BsplineCurve
    Dim sEllipse As Ellipse3d
    Dim sUSpan As Point2d, sVSpan As Point2d
    Dim aParams() As Point2d
    Dim i As Long
    
    ' UCurve0
    sEllipse.Center = Point3dFromXYZ(1, 0, 0)
    sEllipse.Start = Pi
    sEllipse.Sweep = Pi
    sEllipse.Vector0 = Point3dFromXYZ(1, 0, 0)
    sEllipse.Vector90 = Point3dFromXYZ(0, 0, 1)
    aUCurves(0).FromEllipse3d sEllipse
    
    ' UCurve1
    sEllipse.Center = Point3dFromXYZ(1, 2, 0)
    aUCurves(1).FromEllipse3d sEllipse
    
    ' VCurve0
    sEllipse.Center = Point3dFromXYZ(0, 1, 0)
    sEllipse.Start = 0
    sEllipse.Sweep = Pi
    sEllipse.Vector0 = Point3dFromXYZ(0, -1, 0)
    sEllipse.Vector90 = Point3dFromXYZ(0, 0, 1)
    aVCurves(0).FromEllipse3d sEllipse
    
    ' VCurve1
    sEllipse.Center = Point3dFromXYZ(2, 1, 0)
    aVCurves(1).FromEllipse3d sEllipse
    
    For i = 0 To 1
        Set oCurveElt = CreateBsplineCurveElement1(Nothing, aUCurves(i))
        ActiveModelReference.AddElement oCurveElt
        oCurveElt.Redraw
        Set oCurveElt = CreateBsplineCurveElement1(Nothing, aVCurves(i))
        ActiveModelReference.AddElement oCurveElt
        oCurveElt.Redraw
    Next

    ReDim aParams(0 To 1, 0 To 1)
    aParams(0, 0) = Point2dZero
    aParams(0, 1) = Point2dFromXY(1, 0)
    aParams(1, 0) = Point2dFromXY(0, 1)
    aParams(1, 1) = Point2dOne
    For i = 0 To 1
        aUCurves(i).Rebuild 3
        aVCurves(i).Rebuild 3
    Next
    oSurface.FromNetworkWithIntersections aUCurves, aVCurves, aParams, 3, 3, 3, 3
    'oSurface.FromNetwork aUCurves, aVCurves, Matrix3dIdentity
    Set oSurfaceElt = CreateBsplineSurfaceElement1(Nothing, oSurface)
    ActiveModelReference.AddElement oSurfaceElt
    oSurfaceElt.Redraw
    
    sUSpan = Point2dFromXY(0.1, 0.3)
    sVSpan = Point2dFromXY(0.5, 1)
    Set oSurfacePatch = oSurface.ExtractPatch(sUSpan, sVSpan)
    Set oSurfaceElt = CreateBsplineSurfaceElement1(Nothing, oSurfacePatch)
    oSurfaceElt.color = oSurfaceElt.color + 1
    ActiveModelReference.AddElement oSurfaceElt
    oSurfaceElt.Redraw
    
End Sub

Sub TestExtractSegment()
    Dim oCurveElt As BsplineCurveElement
    Dim oCurve As New BsplineCurve, oCurveSegment As BsplineCurve
    Dim sEllipse As Ellipse3d
    Dim sSpan As Point2d
    
    ' UCurve0
    sEllipse.Center = Point3dFromXYZ(1, 0, 0)
    sEllipse.Start = Pi
    sEllipse.Sweep = Pi
    sEllipse.Vector0 = Point3dFromXYZ(1, 0, 0)
    sEllipse.Vector90 = Point3dFromXYZ(0, 0, 1)
    oCurve.FromEllipse3d sEllipse
    
    Set oCurveElt = CreateBsplineCurveElement1(Nothing, oCurve)
    ActiveModelReference.AddElement oCurveElt
    oCurveElt.Redraw

    sSpan = Point2dFromXY(0.25, 0.5)
    Set oCurveSegment = oCurve.ExtractSegment(sSpan)
    Set oCurveElt = CreateBsplineCurveElement1(Nothing, oCurveSegment)
    oCurveElt.color = oCurveElt.color + 1
    ActiveModelReference.AddElement oCurveElt
    oCurveElt.Redraw
    
End Sub

