Attribute VB_Name = "TestFromTangents"
Option Explicit

Sub TestFromTangents()
    Dim oElt As BsplineCurveElement
    Dim oCurve As BsplineCurve
    Dim aTangents() As Ray3d
    Dim nPt As Long
    Dim i As Long
    
    ' Ctor
    Set oCurve = New BsplineCurve
    
    ' BsplineConstructCurveFromTangents (open)
    nPt = 5
    ReDim aTangents(1 To nPt)
    For i = LBound(aTangents) To UBound(aTangents)
        aTangents(i) = PointTangentOnXYCircle(i, nPt, 1# - 1# / CDbl(nPt))
    Next i
    oCurve.FromTangents aTangents
    
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw

    ' BsplineConstructCurveFromTangents (closed)
    nPt = 8
    ReDim aTangents(1 To nPt)
    For i = LBound(aTangents) To UBound(aTangents)
        aTangents(i) = PointTangentOnXYCircle(i, nPt, 1# - 1# / CDbl(nPt))
    Next i
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (open, linear mid segment)
    nPt = 4
    ReDim aTangents(1 To nPt)
    aTangents(1).Origin = Point3dFromXYZ(0, 0, 0)
    aTangents(1).Direction = Point3dFromXYZ(2, -1, 0)
    aTangents(2).Origin = Point3dFromXYZ(5, 0, 0)
    aTangents(2).Direction = Point3dFromXYZ(1, 2, 0)
    aTangents(3).Origin = Point3dFromXYZ(10, 10, 0)
    aTangents(3).Direction = Point3dFromXYZ(-2, 2, 0)
    aTangents(4).Origin = Point3dFromXYZ(0, 10, 0)
    aTangents(4).Direction = Point3dFromXYZ(-1, -2, 0)
    oCurve.FromTangents aTangents
    
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw

    ' BsplineConstructCurveFromTangents (open, linear end segment)
    aTangents(2).Direction = Point3dFromXYZ(2, 2, 0)
    aTangents(4).Direction = Point3dFromXYZ(-2, 0, 0)
    oCurve.FromTangents aTangents
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (open, linear start and end segments)
    aTangents(1).Direction = Point3dFromXYZ(2, 0, 0)
    oCurve.FromTangents aTangents
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (open, all linear segments)
    aTangents(3).Direction = Point3dFromXYZ(1, 2, 0)
    oCurve.FromTangents aTangents
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (closed, all linear segments)
    aTangents(1).Direction = Point3dFromXYZ(0, -2, 0)
    aTangents(2).Direction = Point3dFromXYZ(2, 0, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (closed, linear start and end segments)
    aTangents(3).Direction = Point3dFromXYZ(-1, 3, 0)
    aTangents(4).Direction = Point3dFromXYZ(-3, -1, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (closed, linear start segment)
    aTangents(1).Direction = Point3dFromXYZ(2, -1, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw

    ' BsplineConstructCurveFromTangents (closed, linear end segment)
    aTangents(1).Direction = Point3dFromXYZ(1, -2, 0)
    aTangents(2).Direction = Point3dFromXYZ(1, 1, 0)
    aTangents(4).Direction = Point3dFromXYZ(0, -2, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw

    ' BsplineConstructCurveFromTangents (closed, linear mid segment)
    aTangents(2).Direction = Point3dFromXYZ(1, 2, 0)
    aTangents(4).Direction = Point3dFromXYZ(-1, -2, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    
    ' BsplineConstructCurveFromTangents (closed, no linear segments)
    aTangents(2).Direction = Point3dFromXYZ(1, 1, 0)
    oCurve.FromTangents aTangents, , , , True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw

End Sub
