Attribute VB_Name = "TestHelix"
Option Explicit

Sub TestHelix()
    Dim oElt As BsplineCurveElement
    Dim oLine As LineElement
    Dim oCurve As New BsplineCurve
    Dim sAxis As Segment3d
    Dim sStartPt As Point3d, sAxisVector As Point3d
    Dim height As Double, width As Double
        
    sAxis.startPoint = Point3dFromXYZ(1#, 1#, 1#)
    sAxis.EndPoint = Point3dFromXYZ(0#, 0#, 7#)
    sAxisVector = Point3dSubtract(sAxis.EndPoint, sAxis.startPoint)
    height = Point3dMagnitude(sAxisVector)
    width = height * 2#
    
    ' Get a point on the local orthogonal x-axis
    sStartPt = Point3dFromXYZ(-1#, 0, -3#)
    sStartPt = Point3dCrossProduct(sAxisVector, sStartPt)
    sStartPt = Point3dNormalize(Point3dCrossProduct(sAxisVector, sStartPt))
    sStartPt = Point3dAddScaled(sAxis.startPoint, sStartPt, width)
    
    ' Visualize orthogonal axes of spirals
    Set oLine = CreateLineElement2(Nothing, sAxis.startPoint, sAxis.EndPoint)
    oLine.color = 3
    ActiveModelReference.AddElement oLine
    Set oLine = CreateLineElement2(oLine, sAxis.startPoint, sStartPt)
    ActiveModelReference.AddElement oLine
    Set oLine = CreateLineElement2(oLine, sAxis.startPoint, Point3dAddScaled(sAxis.startPoint, Point3dNormalize(Point3dCrossProduct3Points(sAxis.startPoint, sAxis.EndPoint, sStartPt)), width))
    ActiveModelReference.AddElement oLine
    
    ' Conical, right-handed, 3 turns
    oCurve.Helix width / 4#, width / 2#, sStartPt, sAxis, height / 3#
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' Cylindrical, left-handed, 2 turns
    oCurve.Helix width, width, sStartPt, sAxis, -2#, True
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 2
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' Non-orthogonal frame
    sStartPt = Point3dAddScaled(sAxis.startPoint, Point3dNormalize(Point3dFromXYZ(-1#, 0, -3#)), width)
    
    ' Visualize non-orthogonal axes of spiral
    Set oLine = CreateLineElement2(Nothing, sAxis.startPoint, sAxis.EndPoint)
    oLine.color = 4
    ActiveModelReference.AddElement oLine
    Set oLine = CreateLineElement2(oLine, sAxis.startPoint, Point3dAddScaled(sAxis.startPoint, Point3dNormalize(Point3dCrossProduct3Points(sAxis.startPoint, sAxis.EndPoint, sStartPt)), width))
    ActiveModelReference.AddElement oLine
    Set oLine = CreateLineElement2(oLine, sAxis.startPoint, sStartPt)
    oLine.LineWeight = 3
    ActiveModelReference.AddElement oLine

    ' Non-orthog Conical, right-handed, 5.5 turns
    oCurve.Helix width / 4#, width / 2#, sStartPt, sAxis, 5.5, True
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 5
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' Non-orthog Cylindrical, right-handed, 5.5 turns
    oCurve.Helix width, width, sStartPt, sAxis, 5.5, True
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 6
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
End Sub
