Attribute VB_Name = "TestLength"
Option Explicit

Sub TestLength()
    Dim oElt As BsplineCurveElement
    Dim oCurve As New BsplineCurve
    Dim aPoles() As Point3d
    Dim polyLength As Double, length As Double
    Dim returnedError As Double
    Dim i As Long, nPole As Long
    
    ' Create open curve
    nPole = 4
    ReDim aPoles(0 To nPole - 1)
    For i = LBound(aPoles) To UBound(aPoles)
        aPoles(i) = PointOnXYCircle(i, nPole, 1#)
        aPoles(i) = Point3dAdd(aPoles(i), Point3dFromXYZ(0#, 0#, i))
    Next i
    oCurve.SetPoles aPoles
    
    ' CreateBsplineCurveElement
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' ComputePolygonLength, ComputeLength
    polyLength = oCurve.ComputePolygonLength
    length = oCurve.ComputeLength(returnedError)
    
    ' ComputePolygonLength, ComputeLength on periodic curve
    oCurve.Closed = True
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    polyLength = oCurve.ComputePolygonLength
    length = oCurve.ComputeLength(returnedError)
    
    ' ComputePolygonLength, ComputeLength on closed curve (endpoints same)
    oCurve.Open (0.2)
    If (oCurve.KnotsCount >= 3) Then
        oCurve.Knot(oCurve.KnotsCount / 2) = (2 * oCurve.Knot(oCurve.KnotsCount / 2 - 1) + oCurve.Knot(oCurve.KnotsCount / 2 + 1)) / 3#
    End If
    oCurve.Close
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    polyLength = oCurve.ComputePolygonLength
    length = oCurve.ComputeLength(returnedError)
    
    ' ComputePolygonLength, ComputeLength on closed curve (endpoints same, endweights different)
    oCurve.weight(0) = 0.5
    oElt.color = oElt.color + 1
    oElt.UpdateFromBsplineCurve oCurve
    oElt.Redraw
    polyLength = oCurve.ComputePolygonLength    ' should be same as previous length
    length = oCurve.ComputeLength(returnedError)
    
    
    
End Sub


