Attribute VB_Name = "Util"
Option Explicit

Function PointOnXYCircle(Index As Long, NumPoints As Long, radius As Double) As Point3d
    Dim angle As Double
    angle = 2# * Pi * CDbl(Index) / CDbl(NumPoints)
    PointOnXYCircle = Point3dFromXYZ(radius * Cos(angle), radius * Sin(angle), 0#)
End Function

Function PointOnXZCircle(Index As Long, NumPoints As Long, radius As Double) As Point3d
    Dim angle As Double
    angle = 2# * Pi * CDbl(Index) / CDbl(NumPoints)
    PointOnXZCircle = Point3dFromXYZ(radius * Cos(angle), 0#, radius * Sin(angle))
End Function

Function PointOnXYCircleCW(Index As Long, NumPoints As Long, radius As Double) As Point3d
    Dim angle As Double
    angle = 2# * Pi * CDbl(Index) / CDbl(NumPoints)
    PointOnXYCircleCW = Point3dFromXYZ(radius * Cos(-angle), radius * Sin(-angle), 0#)
End Function

Function PointOnXZCircleCW(Index As Long, NumPoints As Long, radius As Double) As Point3d
    Dim angle As Double
    angle = 2# * Pi * CDbl(Index) / CDbl(NumPoints)
    PointOnXZCircleCW = Point3dFromXYZ(radius * Cos(-angle), 0#, radius * Sin(-angle))
End Function

Function PointTangentOnXYCircle(Index As Long, NumPoints As Long, radius As Double) As Ray3d
    Dim normal As Point3d
    Dim angle As Double
    
    normal = Point3dFromXYZ(0#, 0#, 1#)
    angle = 2# * Pi * CDbl(Index) / CDbl(NumPoints)
    
    PointTangentOnXYCircle.Origin = PointOnXYCircle(Index, NumPoints, radius)
    PointTangentOnXYCircle.Direction = Point3dCrossProduct(normal, PointTangentOnXYCircle.Origin)
End Function
        
Sub SetSurfaceDisplayFromToolSettings(oSurface As BsplineSurface)
    Dim polygonDisplay As Long, surfaceDisplay As Long
    
    polygonDisplay = GetCExpressionValue("tcb->ms3DToolSettings.surface.display.polygonDisplay")
    surfaceDisplay = GetCExpressionValue("tcb->ms3DToolSettings.surface.display.curveDisplay")
    If polygonDisplay = 0 Then
        oSurface.polygonDisplay = False
    Else
        oSurface.polygonDisplay = True
    End If
    If surfaceDisplay = 0 Then
        oSurface.surfaceDisplay = False
    Else
        oSurface.surfaceDisplay = True
    End If
    If polygonDisplay = 0 And surfaceDisplay = 0 Then
        oSurface.surfaceDisplay = True
    End If

    oSurface.URulesCount = GetCExpressionValue("tcb->ms3DToolSettings.surface.uParams.numRules")
    oSurface.VRulesCount = GetCExpressionValue("tcb->ms3DToolSettings.surface.vParams.numRules")
End Sub

    
    
    
    
    
    
    
    
