Attribute VB_Name = "TestMinimumDistance"
Option Explicit

Sub TestMinimumDistance()
    Dim oElt As BsplineCurveElement
    Dim oLine As LineElement
    Dim oView1 As View
    Dim oCurve As BsplineCurve
    Dim ViewRotation As Matrix3d
    Dim aPoles() As Point3d, Point As Point3d, Proj As Point3d
    Dim param As Double, dist As Double
    Dim i As Long, nPole As Long
    
    Set oCurve = New BsplineCurve
    
    nPole = 6
    ReDim aPoles(1 To nPole)
    For i = LBound(aPoles) To UBound(aPoles)
        aPoles(i) = PointOnXYCircle(i, nPole, Sin(Pi * CDbl(i) / CDbl(UBound(aPoles) + 1)))
        aPoles(i).Z = Cos(2 * Pi * CDbl(i) / CDbl(UBound(aPoles) + 1))
    Next i
    oCurve.SetPoles aPoles
    oCurve.Closed = True
        
    ' CreateBsplineCurveElement
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    ' ComputeMinimumDistance
    Point = Point3dFromXYZ(0#, 0#, 2#)
    dist = oCurve.ComputeMinimumDistance(Proj, param, Point, Matrix3dIdentity)
    
    Set oLine = CreateLineElement2(oElt, Point, Proj)
    oLine.color = oLine.color + 1
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    ' rotate view 1
    Set oView1 = ActiveDesignFile.Views(1)
    ViewRotation.RowX = Point3dFromXYZ(0.99627742098849, -0.086204990740257, 0#)
    ViewRotation.RowY = Point3dFromXYZ(0.085113113271978, 0.98365851274672, 0.15865587997315)
    ViewRotation.RowZ = Point3dFromXYZ(-0.013676928663972, -0.15806527092431, 0.98733394135416)
    oView1.Rotation = ViewRotation
    oView1.Redraw
    
    ' ComputeMinimumDistance in obliquely rotated View #1
    dist = oCurve.ComputeMinimumDistance(Proj, param, Point, ViewRotation)
    
    Set oLine = CreateLineElement2(oLine, Point, Proj)
    oLine.color = oLine.color + 1
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    ' Check mindist in identity matrix (top view) vs. mindist with zero matrix (true min dist)
    oView1.SetToTop
    oView1.Redraw
    
    Set oCurve = New BsplineCurve
    ReDim aPoles(0 To 1)
    aPoles(0) = Point3dZero
    aPoles(1) = Point3dOne
    oCurve.SetPoles aPoles
    Set oElt = CreateBsplineCurveElement1(Nothing, oCurve)
    oElt.color = 1
    ActiveModelReference.AddElement oElt
    oElt.Redraw
    
    Point = Point3dFromXYZ(1#, 1#, 0#)
    dist = oCurve.ComputeMinimumDistance(Proj, param, Point, Matrix3dIdentity)
    
    Set oLine = CreateLineElement2(oElt, Point, Proj)
    oLine.color = oLine.color + 1
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    dist = oCurve.ComputeMinimumDistance(Proj, param, Point, Matrix3dZero)
    
    Set oLine = CreateLineElement2(oLine, Point, Proj)
    oLine.color = oLine.color + 1
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
End Sub

