Attribute VB_Name = "TestOffset"
Option Explicit

Sub TestOffsetCurve()
    Dim aRegion() As Element, oEllipse As EllipseElement, oElement As Element, oOffsetElement As Element
    Dim oCurve As BsplineCurve, oOffsetCurve As BsplineCurve
    Dim sEllipse As Ellipse3d
    Dim sVec0 As Point3d, sVec90 As Point3d, sCross As Point3d
    Dim oEnumerator As ElementEnumerator, oOffsetEnumerator As ElementEnumerator
    'Dim sMatrix As Matrix3d
    Dim axis0 As Double, axis1 As Double
    Dim i As Long, color As Long, weight As Long
    
    'We're going to make a complex shape via region boolean, then we'll offset it
    color = 2
    weight = 3
    
    'Make arbitrary plane for geometry
    sVec0 = Point3dFromXYZ(1, 1, 0)
    sVec90 = Point3dFromXYZ(-1, 1, 1)
    sCross = Point3dCrossProduct(sVec0, sVec90)
    sVec90 = Point3dCrossProduct(sCross, sVec0)
    sVec0 = Point3dNormalize(sVec0)
    sVec90 = Point3dNormalize(sVec90)
    
    'Make closed element at origin
    sEllipse.Vector0 = sVec0
    sEllipse.Vector90 = sVec90
    sEllipse.Center = Point3dZero()
    sEllipse.Start = 0#
    sEllipse.Sweep = 2 * Pi
    Set oEllipse = CreateEllipticalElement1(Nothing, sEllipse, msdFillModeNotFilled)
    
    'sMatrix = Matrix3dRotationFromPoint3dOriginXY(sEllipse.Center, Point3dAdd(sEllipse.Center, sEllipse.Vector0), Point3dAdd(sEllipse.Center, sEllipse.Vector90))
    'sMatrix = Matrix3dInverse(sMatrix)

    'Make collection of coplanar elements
    ReDim aRegion(0 To 1)

    sEllipse.Center = Point3dAddScaled(Point3dZero(), sVec90, 3#)
    sEllipse.Vector90 = Point3dScale(sVec90, 2.5)
    Set aRegion(0) = CreateEllipticalElement1(Nothing, sEllipse, msdFillModeNotFilled)
    
    sEllipse.Center = Point3dAddScaled(Point3dZero(), sVec0, 5#)
    sEllipse.Vector0 = Point3dScale(sVec0, 5#)
    sEllipse.Vector90 = Point3dScale(sVec90, 3#)
    Set aRegion(1) = CreateEllipticalElement1(Nothing, sEllipse, msdFillModeNotFilled)

    'Union closed element with collection union
    Set oEnumerator = oEllipse.GetUnionShapesFromRegion(aRegion, Nothing, msdFillModeNotFilled)
    Do While oEnumerator.MoveNext
        Set oElement = oEnumerator.Current
        ActiveModelReference.AddElement oElement
        oElement.Redraw
        
        'Convert to B-spline curve
        Set oCurve = New BsplineCurve
        oCurve.FromElement oElement

        'Offset each component of region boolean
        Set oOffsetCurve = oCurve.Offset(-0.1, Matrix3dZero)
        Set oOffsetElement = CreateBsplineCurveElement1(Nothing, oOffsetCurve)
        oOffsetElement.color = oOffsetElement.color + 1
        ActiveModelReference.AddElement oOffsetElement
        oOffsetElement.Redraw
        
        'Offset each component of region boolean
        Set oOffsetCurve = oCurve.Offset(0.1, Matrix3dZero)
        Set oOffsetElement = CreateBsplineCurveElement1(Nothing, oOffsetCurve)
        oOffsetElement.color = oOffsetElement.color + 2
        ActiveModelReference.AddElement oOffsetElement
        oOffsetElement.Redraw
    Loop

End Sub

