Attribute VB_Name = "TestRebuild"
Option Explicit

Sub TestRebuild()
    Dim oElement As Element
    Dim oCurve As BsplineCurveElement
    Dim curve As BsplineCurve
    Dim aPoles() As Point3d
    Dim aWeights() As Double
    Dim nPole As Long
    
    nPole = 10
    ReDim aPoles(0 To nPole - 1)
    aPoles(0) = Point3dZero
    aPoles(1) = Point3dFromXYZ(1#, 0#, 0#)
    aPoles(2) = Point3dFromXYZ(2#, 1#, 3#)
    aPoles(3) = Point3dFromXYZ(1.5, 2#, 0#)
    aPoles(4) = Point3dFromXYZ(1#, 1.5, 2#)
    aPoles(5) = Point3dFromXYZ(0#, 1#, 0#)
    aPoles(6) = Point3dFromXYZ(-1#, 0#, -1#)
    aPoles(7) = Point3dFromXYZ(-2, -0.5, 0#)
    aPoles(8) = Point3dFromXYZ(-2.5, -1#, 1#)
    aPoles(9) = Point3dFromXYZ(-3#, -2#, 0#)
    
    ReDim aWeights(0 To nPole - 1)
    aWeights(0) = 1#
    aWeights(1) = 0.5
    aWeights(2) = 0.3
    aWeights(3) = 0.2
    aWeights(4) = 0.6
    aWeights(5) = 0.8
    aWeights(6) = 0.7
    aWeights(7) = 0.1
    aWeights(8) = 0.5
    aWeights(9) = 1#
    
    Set curve = New BsplineCurve
    curve.Order = 6
    curve.SetPoles aPoles
    curve.SetWeights aWeights
    
    Set oCurve = CreateBsplineCurveElement1(Nothing, curve)
    oCurve.color = 2
    ActiveModelReference.AddElement oCurve
    oCurve.Redraw
    
    ' Test rebuild
    curve.Rebuild , , msdBsplineParametrizationCentripetal
    Set oCurve = CreateBsplineCurveElement1(oCurve, curve)
    oCurve.color = oCurve.color + 1
    ActiveModelReference.AddElement oCurve
    oCurve.Redraw
    
    ' Test remove knots
    curve.RemoveKnots 0.1, , , False
    Set oCurve = CreateBsplineCurveElement1(oCurve, curve)
    oCurve.color = oCurve.color + 1
    ActiveModelReference.AddElement oCurve
    oCurve.Redraw
    
End Sub
