Attribute VB_Name = "TestSurfaceBoresite"
Option Explicit

Sub TestSurfaceBoresite()
    Dim oSurfaceElt As BsplineSurfaceElement
    Dim oCurveElt As BsplineCurveElement
    Dim oLineElt As LineElement
    Dim oSurface As New BsplineSurface
    Dim aUCurves(0 To 1) As New BsplineCurve, aVCurves(0 To 1) As New BsplineCurve
    Dim sEllipse As Ellipse3d
    Dim sPoint As Point3d
    Dim sParam As Point2d
    Dim sRay As Ray3d
    Dim i As Long
    
    ' UCurve0
    sEllipse.Center = Point3dFromXYZ(1, 0, 0)
    sEllipse.Start = Pi
    sEllipse.Sweep = Pi
    sEllipse.Vector0 = Point3dFromXYZ(1, 0, 0)
    sEllipse.Vector90 = Point3dFromXYZ(0, 0, 1)
    aUCurves(0).FromEllipse3d sEllipse
    
    ' UCurve1
    sEllipse.Center = Point3dFromXYZ(1, 2, 0)
    aUCurves(1).FromEllipse3d sEllipse
    
    ' VCurve0
    sEllipse.Center = Point3dFromXYZ(0, 1, 0)
    sEllipse.Start = 0
    sEllipse.Sweep = Pi
    sEllipse.Vector0 = Point3dFromXYZ(0, -1, 0)
    sEllipse.Vector90 = Point3dFromXYZ(0, 0, 1)
    aVCurves(0).FromEllipse3d sEllipse
    
    ' VCurve1
    sEllipse.Center = Point3dFromXYZ(2, 1, 0)
    aVCurves(1).FromEllipse3d sEllipse
    
    For i = 0 To 1
        Set oCurveElt = CreateBsplineCurveElement1(Nothing, aUCurves(i))
        ActiveModelReference.AddElement oCurveElt
        oCurveElt.Redraw
        Set oCurveElt = CreateBsplineCurveElement1(Nothing, aVCurves(i))
        ActiveModelReference.AddElement oCurveElt
        oCurveElt.Redraw
    Next
    
    oSurface.FromNetwork aUCurves, aVCurves, Matrix3dIdentity
    Set oSurfaceElt = CreateBsplineSurfaceElement1(Nothing, oSurface)
    oSurfaceElt.color = oSurfaceElt.color + 1
    ActiveModelReference.AddElement oSurfaceElt
    oSurfaceElt.Redraw
    
    sPoint = Point3dFromXYZ(0.3, 0.7, 0.8)
    Set oLineElt = CreateLineElement2(Nothing, sPoint, sPoint)
    oLineElt.color = oLineElt.color + 2
    oLineElt.LineWeight = 5
    ActiveModelReference.AddElement oLineElt
    oLineElt.Redraw
    
    sRay.Origin = sPoint
    sRay.Direction = Point3dNormalize(Point3dFromXYZ(3, 5, -10))
    Set oLineElt = CreateLineElement2(Nothing, sRay.Origin, Point3dAddScaled(sRay.Origin, sRay.Direction, 1))
    oLineElt.color = oLineElt.color + 3
    ActiveModelReference.AddElement oLineElt
    oLineElt.Redraw
    
    sPoint = oSurface.ComputeBoresite(sParam, sRay, 0.00001)    'default tolerance fails!
    Set oLineElt = CreateLineElement2(Nothing, sPoint, sPoint)
    oLineElt.color = oLineElt.color + 4
    oLineElt.LineWeight = 5
    ActiveModelReference.AddElement oLineElt
    oLineElt.Redraw
    
    oSurface.ComputeMinimumDistance sPoint, sParam, sRay.Origin
    Set oLineElt = CreateLineElement2(Nothing, sPoint, sPoint)
    oLineElt.color = oLineElt.color + 5
    oLineElt.LineWeight = 5
    ActiveModelReference.AddElement oLineElt
    oLineElt.Redraw
    
    Set oLineElt = CreateLineElement2(Nothing, sRay.Origin, Point3dAddScaled(sRay.Origin, Point3dNormalize(Point3dSubtract(sPoint, sRay.Origin)), 1))
    oLineElt.color = oLineElt.color + 6
    ActiveModelReference.AddElement oLineElt
    oLineElt.Redraw

End Sub
