Attribute VB_Name = "TestSurfaceFrom2Boundaries"
Option Explicit

Sub TestSurfaceFromTwoBoundaries()
    Dim oSurface As BsplineSurfaceElement, oCurve As BsplineCurveElement, oLine As LineElement
    Dim surface As BsplineSurface
    Dim fitCurve As InterpolationCurve
    Dim aFitPoints() As Point3d, aTmpPoints() As Point3d
    Dim aCurves() As BsplineCurve
    Dim nUCurve As Long, nVCurve As Long
    Dim i As Integer, j As Integer, k As Integer
    
    nUCurve = 3
    nVCurve = 4
    ReDim aFitPoints(0 To nUCurve - 1, 0 To nVCurve - 1)
    aFitPoints(0, 0) = Point3dFromXYZ(0, 20, -5)
    aFitPoints(0, 1) = Point3dFromXYZ(10, 30, 10)
    aFitPoints(0, 2) = Point3dFromXYZ(20, 27, 13)
    aFitPoints(0, 3) = Point3dFromXYZ(30, 22, 3)
    aFitPoints(1, 0) = Point3dFromXYZ(5, 10, 0)
    aFitPoints(1, 1) = Point3dFromXYZ(12, 18, 7)
    aFitPoints(1, 2) = Point3dFromXYZ(18, 20, 10)
    aFitPoints(1, 3) = Point3dFromXYZ(25, 13, -2)
    aFitPoints(2, 0) = Point3dFromXYZ(0, 0, 0)
    aFitPoints(2, 1) = Point3dFromXYZ(13, -1, 12)
    aFitPoints(2, 2) = Point3dFromXYZ(19, -3, 8)
    aFitPoints(2, 3) = Point3dFromXYZ(28, 2, 2)
    
    For i = LBound(aFitPoints) To UBound(aFitPoints)
        For j = LBound(aFitPoints, 2) To UBound(aFitPoints, 2)
            Set oLine = CreateLineElement2(Nothing, aFitPoints(i, j), aFitPoints(i, j))
            oLine.color = 2
            oLine.LineWeight = 5
            ActiveModelReference.AddElement oLine
        Next j
    Next i
    
    'Make UCurves
    ReDim aCurves(LBound(aFitPoints) To UBound(aFitPoints))
    ReDim aTmpPoints(LBound(aFitPoints, 2) To UBound(aFitPoints, 2))
    For i = LBound(aFitPoints) To UBound(aFitPoints)
        
        For j = LBound(aTmpPoints) To UBound(aTmpPoints)
            aTmpPoints(j) = aFitPoints(i, j)
        Next j
        
        Set fitCurve = New InterpolationCurve
        fitCurve.SetFitPoints aTmpPoints
        fitCurve.BesselTangents = True
        
        Set aCurves(i) = New BsplineCurve
        aCurves(i).FromInterpolationCurve fitCurve
        
        Set oCurve = CreateBsplineCurveElement1(Nothing, aCurves(i))
        oCurve.color = 1
        ActiveModelReference.AddElement oCurve
    Next i
    
    'Compute Ruled Surface (ruled in v)
    Set surface = New BsplineSurface
    surface.FromTwoBoundaryCurves aCurves(LBound(aCurves)), aCurves(UBound(aCurves))
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 3
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
    ' (ruled in u)
    surface.FromTwoBoundaryCurves aCurves(LBound(aCurves)), aCurves(UBound(aCurves)), msdBsplineSurfaceU
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 4
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
    'Make VCurves
    ReDim aCurves(LBound(aFitPoints, 2) To UBound(aFitPoints, 2))
    ReDim aTmpPoints(LBound(aFitPoints) To UBound(aFitPoints))
    For j = LBound(aFitPoints, 2) To UBound(aFitPoints, 2)
        
        For i = LBound(aTmpPoints) To UBound(aTmpPoints)
            aTmpPoints(i) = aFitPoints(i, j)
        Next i
        
        Set fitCurve = New InterpolationCurve
        fitCurve.SetFitPoints aTmpPoints
        fitCurve.BesselTangents = True

        Set aCurves(j) = New BsplineCurve
        aCurves(j).FromInterpolationCurve fitCurve
    
        Set oCurve = CreateBsplineCurveElement1(Nothing, aCurves(j))
        oCurve.color = 1
        ActiveModelReference.AddElement oCurve
    Next j
    
    For i = 1 To ActiveDesignFile.Views.Count
        ActiveDesignFile.Views.Item(i).Redraw
    Next i
    
    'Compute Ruled Surface (ruled in v)
    Set surface = New BsplineSurface
    surface.FromTwoBoundaryCurves aCurves(LBound(aCurves)), aCurves(UBound(aCurves))
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 5
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
    ' (ruled in u)
    surface.FromTwoBoundaryCurves aCurves(LBound(aCurves)), aCurves(UBound(aCurves)), msdBsplineSurfaceU
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 6
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
End Sub

