Attribute VB_Name = "TestSurfaceFrom4Boundaries"
Option Explicit

Sub TestSurfaceFromFourBoundaries()
    Dim oSurface As BsplineSurfaceElement, oCurve As BsplineCurveElement, oLine As LineElement
    Dim surface As BsplineSurface
    Dim fitCurve As InterpolationCurve
    Dim aFitPoints() As Point3d, aTmpPoints() As Point3d
    Dim aUCurves() As BsplineCurve, aVCurves() As BsplineCurve, trivialCurve As BsplineCurve, diagonalCurve As BsplineCurve
    Dim nUCurve As Long, nVCurve As Long
    Dim i As Integer, j As Integer, k As Integer
    
    nUCurve = 3
    nVCurve = 4
    ReDim aFitPoints(0 To nUCurve - 1, 0 To nVCurve - 1)
    aFitPoints(0, 0) = Point3dFromXYZ(0, 20, -5)
    aFitPoints(0, 1) = Point3dFromXYZ(10, 30, 10)
    aFitPoints(0, 2) = Point3dFromXYZ(20, 27, 13)
    aFitPoints(0, 3) = Point3dFromXYZ(30, 22, 3)
    aFitPoints(1, 0) = Point3dFromXYZ(5, 10, 0)
    aFitPoints(1, 1) = Point3dFromXYZ(12, 18, 7)
    aFitPoints(1, 2) = Point3dFromXYZ(18, 20, 10)
    aFitPoints(1, 3) = Point3dFromXYZ(25, 13, -2)
    aFitPoints(2, 0) = Point3dFromXYZ(0, 0, 0)
    aFitPoints(2, 1) = Point3dFromXYZ(13, -1, 12)
    aFitPoints(2, 2) = Point3dFromXYZ(19, -3, 8)
    aFitPoints(2, 3) = Point3dFromXYZ(28, 2, 2)
    
    For i = LBound(aFitPoints) To UBound(aFitPoints)
        For j = LBound(aFitPoints, 2) To UBound(aFitPoints, 2)
            Set oLine = CreateLineElement2(Nothing, aFitPoints(i, j), aFitPoints(i, j))
            oLine.color = 2
            oLine.LineWeight = 5
            ActiveModelReference.AddElement oLine
        Next j
    Next i
    
    'Make UCurves
    ReDim aUCurves(LBound(aFitPoints) To UBound(aFitPoints))
    ReDim aTmpPoints(LBound(aFitPoints, 2) To UBound(aFitPoints, 2))
    For i = LBound(aFitPoints) To UBound(aFitPoints)
        
        For j = LBound(aTmpPoints) To UBound(aTmpPoints)
            aTmpPoints(j) = aFitPoints(i, j)
        Next j
        
        Set fitCurve = New InterpolationCurve
        fitCurve.SetFitPoints aTmpPoints
        fitCurve.BesselTangents = True
        
        Set aUCurves(i) = New BsplineCurve
        aUCurves(i).FromInterpolationCurve fitCurve
        
        Set oCurve = CreateBsplineCurveElement1(Nothing, aUCurves(i))
        oCurve.color = 1
        ActiveModelReference.AddElement oCurve
    Next i
    
    'Make VCurves
    ReDim aVCurves(LBound(aFitPoints, 2) To UBound(aFitPoints, 2))
    ReDim aTmpPoints(LBound(aFitPoints) To UBound(aFitPoints))
    For j = LBound(aFitPoints, 2) To UBound(aFitPoints, 2)
        
        For i = LBound(aTmpPoints) To UBound(aTmpPoints)
            aTmpPoints(i) = aFitPoints(i, j)
        Next i
        
        Set fitCurve = New InterpolationCurve
        fitCurve.SetFitPoints aTmpPoints
        fitCurve.BesselTangents = True

        Set aVCurves(j) = New BsplineCurve
        aVCurves(j).FromInterpolationCurve fitCurve
    
        Set oCurve = CreateBsplineCurveElement1(Nothing, aVCurves(j))
        oCurve.color = 1
        ActiveModelReference.AddElement oCurve
    Next j
    
    For i = 1 To ActiveDesignFile.Views.Count
        ActiveDesignFile.Views.Item(i).Redraw
    Next i
    
    'Compute Coons Patch (4 boundaries)
    Set surface = New BsplineSurface
    surface.FromFourBoundaryCurves aUCurves(LBound(aUCurves)), aUCurves(UBound(aUCurves)), aVCurves(LBound(aVCurves)), aVCurves(UBound(aVCurves))
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 3
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
    ' trivial curve
    ReDim aTmpPoints(0 To 1)
    aTmpPoints(0) = aUCurves(LBound(aUCurves)).Pole(aUCurves(LBound(aUCurves)).PolesCount - 1)
    aTmpPoints(1) = aTmpPoints(0)
    Set trivialCurve = New BsplineCurve
    trivialCurve.SetPoles aTmpPoints
    
    ' diagonal curve
    ReDim aTmpPoints(0 To 3)
    aTmpPoints(0) = aFitPoints(nUCurve - 1, 0)
    aTmpPoints(1) = aFitPoints(1, 1)
    aTmpPoints(2) = aFitPoints(1, 2)
    aTmpPoints(3) = aFitPoints(0, nVCurve - 1)
    Set fitCurve = New InterpolationCurve
    fitCurve.SetFitPoints aTmpPoints
    fitCurve.BesselTangents = True
    Set diagonalCurve = New BsplineCurve
    diagonalCurve.FromInterpolationCurve fitCurve
    Set oCurve = CreateBsplineCurveElement1(Nothing, diagonalCurve)
    oCurve.color = 1
    ActiveModelReference.AddElement oCurve
    oCurve.Redraw
    
    'Compute Coons Patch (3 boundaries)
    surface.FromFourBoundaryCurves aUCurves(LBound(aUCurves)), diagonalCurve, aVCurves(LBound(aVCurves)), Nothing
    Set oSurface = CreateBsplineSurfaceElement1(Nothing, surface)
    oSurface.color = 4
    ActiveModelReference.AddElement oSurface
    oSurface.Redraw
    
End Sub

