Attribute VB_Name = "Cells"
Option Explicit

' This sub will change the color of the element passed
' to the fillColor passed.
Private Sub ChgColor(oElement As Element, fillColor As Long)
    oElement.Color = fillColor
    oElement.Rewrite
    oElement.Redraw msdDrawingModeNormal
End Sub

' This sub will change the fill color in an element.
' The elements in a cell are also scanned and changed.
Public Sub ChgFillColor(fillColor As Long)
    Dim oScanCriteria As New ElementScanCriteria
    Dim oElemEnum As ElementEnumerator      ' Enumerator for DGN Elements
    Dim oCellElemEnum As ElementEnumerator  ' Enumerator for Cell Elements
    Dim oElement As Element
    Dim cExtras As New Extras               ' Class Module
    Dim searchType As Long
    Dim elemCount As Long
    
    elemCount = 0
    searchType = cExtras.TypeName2Num(frmCellMod.cboElemNames.Text)
    
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType searchType
    
    ' If check box checked Cells are included in scan
    If frmCellMod.chkCellsIncluded Then
        oScanCriteria.IncludeType msdElementTypeCellHeader
    End If
    
    Set oElemEnum = ActiveModelReference.Scan(oScanCriteria)
    
    If frmCellMod.chkCellsIncluded Then
        Do While oElemEnum.MoveNext
            Set oElement = oElemEnum.Current
            If oElement.Type = msdElementTypeCellHeader Then
                ' Get sub elements from Cell
                Set oCellElemEnum = oElement.AsCellElement.GetSubElements
                Do While oCellElemEnum.MoveNext
                    Set oElement = oCellElemEnum.Current
                    If oElement.Type = searchType Then
                        elemCount = elemCount + 1
                        ChgColor oElement, fillColor
                    End If
                Loop
            Else
                elemCount = elemCount + 1
                ChgColor oElement, fillColor
            End If
        Loop
    Else
        Do While oElemEnum.MoveNext
            Set oElement = oElemEnum.Current
            elemCount = elemCount + 1
            ChgColor oElement, fillColor
        Loop
    End If
    ' Puts the number of elements change in a label.
    frmCellMod.Label2.Caption = elemCount
End Sub

' This function counts the number of cells in the active dgn.
Public Function CellDgnCount() As Long
    Dim oScanCriteria   As New ElementScanCriteria
    Dim oElementEnum      As ElementEnumerator
    'Dim oElement        As Element
    Dim cellCount       As Integer
    'Dim cellName        As String
  
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType msdElementTypeCellHeader
    cellCount = 0
    CellDgnCount = 0
    
    Set oElementEnum = ActiveModelReference.Scan(oScanCriteria)
    
    Do While oElementEnum.MoveNext
        'Set oElement = oElemeEnum.Current
        cellCount = cellCount + 1
        'cellName = oElement.AsCellElement.Name
    Loop
    CellDgnCount = cellCount
End Function

' This function will attache the Cell Library of the name
' passed and then count the number of cells in that
' Cell Library
Public Function CellLibCount(cellLib As String) As Long
    Dim oCIE As CellInformationEnumerator, oCellInfo As CellInformation
    
    CellLibCount = 0

    AttachCellLibrary cellLib, msdConversionModePrompt

    If IsCellLibraryAttached Then
        Set oCIE = GetCellInformationEnumerator(True, True)
        ' COUNT THE CELLS
        Do While oCIE.MoveNext
            CellLibCount = CellLibCount + 1
        Loop
    End If
End Function

Sub main()
    frmCellMod.Show
End Sub
