VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsPlaceCellAbsulate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'VERSION 1.0 CLASS
' This is an example to place a cell dynamiclly.
' It ask the 1st point, and then the 2nd point, from 1st point and the 2nd, get the angle
' as the active cell angle.

Implements IPrimitiveCommandEvents

  Private caeScale            As Point3d
  Private origin              As Point3d
  Private caeAngle            As Matrix3d
  Private sScale              As String
  Private oTemp               As CellElement
  Dim gsCell As String


'***** Cleanup Variables For Next Execution
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub

'***** Creates and Adds Elements to the DGN on Accept Event
Private Sub IPrimitiveCommandEvents_DataPoint(point As Point3d, ByVal View As View)
    Dim oFence As Fence
    Dim vertices(4) As Point2d
        
    If frmCookieCut.CheckBoxTrueScale = True Then
        Set oTemp = CreateCellElement2(gsCell, point, caeScale, True, Matrix3dIdentity)
    Else
        Set oTemp = CreateCellElement2(gsCell, point, caeScale, False, Matrix3dIdentity)
    End If
    
    If frmCookieCut.CheckBoxRelative = True Then
        oTemp.SetLevelRelative ' default is current active level.
    End If
    
    vertices(0).X = oTemp.Range.Low.X * ActiveModelReference.UORsPerMasterUnit
    vertices(0).Y = oTemp.Range.Low.Y * ActiveModelReference.UORsPerMasterUnit
    vertices(1) = vertices(0)
    vertices(3) = vertices(0)
    vertices(4) = vertices(0)
    
    vertices(2).X = oTemp.Range.High.X * ActiveModelReference.UORsPerMasterUnit
    vertices(2).Y = oTemp.Range.High.Y * ActiveModelReference.UORsPerMasterUnit
    
    vertices(1).X = oTemp.Range.High.X * ActiveModelReference.UORsPerMasterUnit
    vertices(3).Y = oTemp.Range.High.Y * ActiveModelReference.UORsPerMasterUnit
    Set oFence = ActiveDesignFile.Fence
    oFence.DefineFromPoints View, vertices
    
    oFence.Draw msdDrawingModeHilite
    Dim fenceMode
    'get the current fence clip mode
    fenceMode = ActiveSettings.FenceClip
    ActiveSettings.FenceClip = True
    CadInputQueue.SendCommand "fen del"
    CadInputQueue.SendDataPoint point
    oFence.Undefine
    ' restore the fence clip mode
    ActiveSettings.FenceClip = fenceMode
    
    ActiveModelReference.AddElement oTemp
    oTemp.Redraw msdDrawingModeNormal
    
    CommandState.StartPrimitive Me
End Sub

'***** Temporarily Displays Elements in View
Private Sub IPrimitiveCommandEvents_Dynamics(point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Set oTemp = CreateCellElement2(gsCell, point, caeScale, True, Matrix3dIdentity)
    oTemp.Redraw DrawMode
    
End Sub

Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

'***** Must Remain to Work Correctly

End Sub

'***** Handles Reset Event
Private Sub IPrimitiveCommandEvents_Reset()
    'CommandState.StartPrimitive Me
    CommandState.StartDefaultCommand
End Sub

Private Sub IPrimitiveCommandEvents_Start()
   
    gsCell = frmCookieCut.TextBoxCellName
    
    ' If check to see if the active cell was populated
    If gsCell = "" Then
        ' Cell not set, MsdError.msdErrorCellNotFound
        MsgBox "ActiveCellNotFound"
        End
    End If
    
  caeScale = ActiveSettings.Scale
    
  ShowCommand "Cookie cut a line when place a Cell> "
  ShowPrompt "Data point"
  CommandState.StartDynamics
End Sub

