Attribute VB_Name = "ScanModel"
Option Explicit

'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2003, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' formPosition
'
' Status: WORKING
'
' This example illustrates how to change a titleblock's text. The titleblock
' is a type 2 Cell and the text values are type 37 Tags attached to the cell.
' This example will scan the active model for only type 2 Cells then find and
' modify the wanted tag values through a form. When the form initially opens
' and the cell is in the active Model, push the form's 'Retrieve Text' button.
'
' Author: BSI                                                   10/2002
'
'-----------------------------------------------------------------------+
'-----------------------------------------------------------------------+
'
'   Public variables
'
'-----------------------------------------------------------------------+
Public oTagEl() As TagElement
Public count As Long
Public cellFound As Boolean
Public modifyTags As Boolean

'-----------------------------------------------------------------------+
'
'   name        clearFields
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub clearFields()
    TitleBlock.ContractNo.Text = ""
    TitleBlock.DrawnInt.Text = ""
    TitleBlock.DrawnDate.Text = ""
    TitleBlock.CheckedInt.Text = ""
    TitleBlock.CheckedDate.Text = ""
    TitleBlock.EngrInt.Text = ""
    TitleBlock.EngrDate.Text = ""
    TitleBlock.OwnerName.Text = ""
    TitleBlock.OwnerAddress.Text = ""
    TitleBlock.DwgTitle.Text = ""
    TitleBlock.DwgNo.Text = ""
    TitleBlock.RevNo.Text = ""
    TitleBlock.ScaleVal.Text = ""
    TitleBlock.ScaleVal.Text = ""
    TitleBlock.SheetNo.Text = ""
End Sub

'-----------------------------------------------------------------------+
'
'   name        TagValueChange
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub TagValueChange(oTagEl() As TagElement, count As Long)

    If oTagEl(count).TagDefinitionName = "%ContractNo%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.ContractNo.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.ContractNo.Text = oTagEl(count).Value
        End If
    End If

    If oTagEl(count).TagDefinitionName = "%DrawnInitials%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.DrawnInt.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.DrawnInt.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%DrawnDate%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.DrawnDate.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.DrawnDate.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%CheckedInitials%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.CheckedInt.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.CheckedInt.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%CheckedDate%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.CheckedDate.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.CheckedDate.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%EngrInitials%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.EngrInt.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.EngrInt.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%EngrDate%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.EngrDate.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.EngrDate.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%OwnerName%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.OwnerName.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.OwnerName.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%OwnerAddress%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.OwnerAddress.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.OwnerAddress.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%DwgTitle%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.DwgTitle.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.DwgTitle.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%DwgNo%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.DwgNo.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.DwgNo.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%RevNo%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.RevNo.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.RevNo.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%ScaleVal%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.ScaleVal.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.ScaleVal.Text = oTagEl(count).Value
        End If
    End If
    
    If oTagEl(count).TagDefinitionName = "%SheetNo%" Then
        If modifyTags = True Then
            oTagEl(count).Value = TitleBlock.SheetNo.Text
            oTagEl(count).Rewrite
        Else
            TitleBlock.SheetNo.Text = oTagEl(count).Value
        End If
    End If

End Sub

'-----------------------------------------------------------------------+
'
'   name        ModelScan
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub ModelScan()

    Dim oScanCriteria   As New ElementScanCriteria
    Dim oElEnum         As ElementEnumerator
    Dim oEl             As Element
    
    cellFound = False
    
    ' Scan only for type 2 Cells
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType msdElementTypeCellHeader
    
    Set oElEnum = ActiveModelReference.Scan(oScanCriteria)
    
    While oElEnum.MoveNext = True
        Set oEl = oElEnum.Current
        
        ' Process only the "titleblock" cell
        If oEl.AsCellElement.Name = "titleblock" Then
            cellFound = True
        
            ' Process the tags
            If oEl.HasAnyTags = True Then
                oTagEl() = oEl.GetTags
            
                ' Locate each tag by it's definition
                For count = 0 To UBound(oTagEl)
                    TagValueChange oTagEl(), count
                Next
            End If
        End If
    Wend
    
    If modifyTags = True Then
        If cellFound = True Then
            RedrawAllViews
        End If
    End If
    
End Sub
