Attribute VB_Name = "Module1"
'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2001, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' placeCell
'
' Status: WORKING
'
' Date: 01/09/02
'
' This is a simple example of placing a cell. No dynamics will be
' displayed
'
'-----------------------------------------------------------------------+
Option Explicit

'-----------------------------------------------------------------------+
'
'   name        GetInput
'
'   author      BSI                                          01/2002
'
'-----------------------------------------------------------------------+
Sub GetInput(cellName As String)

    Dim oMessage    As CadInputMessage
    Dim ViewWindow  As Integer
    Dim point       As Point3d
    Dim oCellElm    As CellElement

    ShowCommand "Running PlaceCell example"
    ShowPrompt "Place the cell. Enter reset to exit"
    ShowStatus ""

    Do While True
    
        Set oMessage = CadInputQueue.GetInput(msdCadInputTypeDataPoint, msdCadInputTypeReset)

            If oMessage.InputType = msdCadInputTypeDataPoint Then
                
                ' Gets the point clicked in the view window
                point = oMessage.point
                
                'TCB variable that gets the last active View Window
                'ViewWindow = GetCExpressionValue("tcb->lstvw") + 1
                
                'Use the datapoint location to place the cell
                Set oCellElm = CreateCellElement3(cellName, point, False)
                
                ' Write the element to the model
                ActiveModelReference.AddElement oCellElm
                
                ' Redraw the element
                oCellElm.Redraw
                
            ElseIf oMessage.InputType = msdCadInputTypeReset Then
            
                ShowStatus "got reset, will exit now"
                CommandState.StartDefaultCommand
                Exit Sub
            Else
                Exit Sub
            End If
    Loop
End Sub
    
'-----------------------------------------------------------------------+
'
'   name        Main
'
'   author      BSI                                          01/2002
'
'-----------------------------------------------------------------------+
Sub Main()

' The below "On Error" statement will prevent the app from crashing if the
' cell or cell library could not be found
On Error GoTo errorHandler

    'Attach Cell Library
    AttachCellLibrary "sample2.cel", msdConversionModeNever
    
    If IsCellLibraryAttached Then

        'Select the desired cell and envoke the Place Cell command
        ActiveSettings.cellName = "ARRO"
        GetInput "ARRO"
        Exit Sub
    Else
        MsgBox "Cell Library could not be Attached"
        Exit Sub
    End If
    
errorHandler:
    MsgBox "Cell or cell library could not be found"
    
End Sub

