Attribute VB_Name = "Module1"
Sub ScanExample()
    
    Dim scanCriteria As New ElementScanCriteria
    Dim i As Long
    Dim enumerator As ElementEnumerator
    Dim cellEnumerator As ElementEnumerator
    Dim cellElm As CellElement
    
    ' Terminate any active commands
    CadInputQueue.SendCommand "NULL"
    
    ' Set the undo marker
    CadInputQueue.SendCommand "Mark"
    
    '  Initially, the scan criteria is set up to handle all types.
    '  First, exclude all and then just include the ones we want
    scanCriteria.ExcludeAllColors
    scanCriteria.IncludeColor (0)

    Set enumerator = ActiveModelReference.Scan(scanCriteria)
    ShowStatus "Updating elements"
    
    '  Step through the scan results
    Do While enumerator.MoveNext
        With enumerator.Current
        
            ' If a cell element then change elements with in
            If enumerator.Current.IsCellElement Then
                
                Set cellElm = enumerator.Current
                Set cellEnumerator = cellElm.GetSubElements
                
                 Do While cellEnumerator.MoveNext
                    With cellEnumerator.Current
                        If .Color = 0 Then
                            .Color = 2 Mod 10
                            .Rewrite
                        End If
                    End With
                Loop
            End If
            .Color = 2 Mod 10
            .Rewrite
            .Redraw
            
        End With
        
        i = i + 1
        If (i Mod 50) = 0 Then
            ShowStatus "Updated element number " & i
        End If
    Loop
    
    ' Set MicroStation back to normal state
    CommandState.StartDefaultCommand
    ShowStatus "Updated element number " & i
    
End Sub

