Attribute VB_Name = "ChangeColor"
Option Explicit
'-----------------------------------------------------------------------+
'
'   name        elemNameFromNumber
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Public Function elementNumberFromName(elemName As String) As Integer
    
    Select Case elemName
    
        Case "All Elements": elementNumberFromName = 100
        Case "Arc": elementNumberFromName = 16
        Case "Complex Chain": elementNumberFromName = 12
        Case "Curve": elementNumberFromName = 11
        Case "Dimension": elementNumberFromName = 33
        Case "Ellipse": elementNumberFromName = 15
        Case "Library Cell": elementNumberFromName = 1
        Case "Line": elementNumberFromName = 3
        Case "Line String": elementNumberFromName = 4
        Case "Multi Line": elementNumberFromName = 36
        Case "Shape": elementNumberFromName = 6
        Case "Shared Cell": elementNumberFromName = 35
        Case "Surface": elementNumberFromName = 18
        Case "Tag": elementNumberFromName = 37
        Case "Text": elementNumberFromName = 17
        Case "Text Node": elementNumberFromName = 7
        Case Else: elementNumberFromName = 0
    
    End Select
    
End Function

'-----------------------------------------------------------------------+
'
'   name        scanFile
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Sub scanFile(elementType As Integer, chgFromColor As Long, chgToColor As Long, textField As String)
    
    Dim oScanCriteria          As New ElementScanCriteria
    Dim oEnumerator            As ElementEnumerator
    Dim ElementCounter         As Integer
    Dim ElementCriteria        As Integer
    
    CadInputQueue.SendCommand "Mark"
       
    'Counts the number of elements of the "Type" that meets the criteria
    ElementCounter = 0
    
    'Counts the number of elements that meets the criteria and are modified
    ElementCriteria = 0
        
    'Clear out any previous scans
    oScanCriteria.Reset
    
    '100 will pass all elements though the scanner. All that needs to be done
    'is to exclude the next 2 statements
    If elementType <> 100 Then
     
        'Initially, the scan criteria is set up to handle all types.
        'First, exclude all and then just include the ones we want
        oScanCriteria.ExcludeAllTypes
    
        'scanning for type 3 line elements only
        oScanCriteria.IncludeType elementType
    Else
        textField = "element"
    End If
    
    'Set enumerator
        Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)
    
    'Step through every element in the file
    Do While oEnumerator.MoveNext
        With oEnumerator.Current
            
            ElementCounter = ElementCounter + 1
            If (.Type <> 0) Then
            
                If (.IsGraphical) Then
                    If (.Color = -1) Then
                        If .Level.ElementColor = chgFromColor Then
                            ElementCriteria = ElementCriteria + 1
                            .Color = chgToColor
                            .Rewrite
                            .Redraw msdDrawingModeNormal
                        End If
                    ElseIf .Color = chgFromColor Then
                        ElementCriteria = ElementCriteria + 1
                        .Color = chgToColor
                        .Rewrite
                        .Redraw msdDrawingModeNormal
                    End If
                End If
            End If
        End With
    Loop
    
    If ElementCounter = 0 Then
    
        ShowPrompt ""
        ShowStatus "No Elements of the Element Type Specified are in the Active File"
    Else
        ShowPrompt ""
        ShowStatus CStr(ElementCounter) + " " + textField + "(s) Found, " + CStr(ElementCriteria) + " Changed"
    
    End If
    
End Sub
