Attribute VB_Name = "XMLSnippets"
'----------------------------------------------------------------------+
' Module:   XMLSnippets.bas
'
' Status: WORKING
'
' Date:  03/12/04
'
' This example snippets illustrates using Microsoft's XML
' 4.0 Object model
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+
Option Explicit

'-----------------------------------------------------------------------+
'
'   Name        XMLNodeCreate
'
'   Author      BSI - Developer Support                 02/2004
'
'-----------------------------------------------------------------------+
Public Function XMLNodeCreate(ByVal xmlParentNode As IXMLDOMNode, ByVal strNodeName As String, ByVal strNodeValue As String)

    Dim xmlNewNode As IXMLDOMNode

    ' Create the new node
    Set xmlNewNode = xmlParentNode.ownerDocument.CreateElement(strNodeName)

    ' Set the node's value
    xmlNewNode.Text = strNodeValue + vbCrLf
    
    ' Add the node to the parent node
    xmlParentNode.appendChild xmlNewNode
    
    ' Return the node to the caller
'    XMLCreateNode = xmlNewNode
    
End Function
'-----------------------------------------------------------------------+
'
'   Name        main
'
'   Author      BSI - Developer Support                 02/2004
'
'-----------------------------------------------------------------------+
Public Sub XMLSavedocument(xmlDocument As DOMDocument, strFileName As String)
    
    ' Save the XML document.
    xmlDocument.Save strFileName
        
End Sub

'-----------------------------------------------------------------------+
'
'   Name        XMLDocumentLoad
'
'   Author      BSI - Developer Support                 03/2004
'
'   Returns     True if XML document is loaded otherwise False.
'-----------------------------------------------------------------------+
Public Function XMLDocumentLoad(xmlDocument As DOMDocument, strFileName As String) As Boolean
    
    ' Check to see if file name is provided
    If strFileName = "" Then
        XMLDocumentLoad = False
        Exit Function
    End If
    
    ' Load the XML document.
    Set xmlDocument = New DOMDocument
    xmlDocument.Load strFileName
    
    If xmlDocument.documentElement Is Nothing Then
        'Failed to load
        XMLDocumentLoad = False
    Else
        XMLDocumentLoad = True
    End If
    
End Function

'-----------------------------------------------------------------------+
'
'   Name        XMLNodeValueGet
'
'   Author      BSI - Developer Support                 03/2004
'
'   Returns     The node's value otherwise NULL
'-----------------------------------------------------------------------+
Public Function XMLNodeValueGet(ByVal xmlNode As IXMLDOMNode, ByVal xmlNodeName As String) As String

    Dim xmlNodeVale As IXMLDOMNode

'   Match mnemonic
'   ==============
'   / Root or Note
'   . This
'   // Any

    Set xmlNodeVale = xmlNode.selectSingleNode(".//" & xmlNodeName)
        
    If xmlNodeVale Is Nothing Then
        XMLNodeValueGet = vbNullString
    Else
        XMLNodeValueGet = xmlNodeVale.Text
    End If
    
End Function
