Attribute VB_Name = "DBGetSetRcds"
Option Explicit

'*----------------------------------------------------------------------+
'
' Copyright 1993-2002, Bentley Systems, Incorporated
' All rights reserved.
'
' Limited permission is hereby granted to reproduce and modify this
' copyrighted material provided that the resulting code is used only in
' conjunction with Bentley Systems products under the terms of the
' license agreement provided therein, and that this notice is retained
' in its entirety in any such reproduction or modification.
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' DBGetSet
'
' Status: WORKING
'
' This example illustrates how get a specific database records value and
' change them by using the mslink value stored on the element selected,
' and in the Access database.
'
' Author: BSI                                               12/03/02
'
'----------------------------------------------------------------------*/

Public linkCounter      As Long
Public totLinkCounter   As Long

'-----------------------------------------------------------------------+
'
'   name        recordInfoSet
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Public Sub recordInfoSet(oDatabaseLink() As DatabaseLink)

    Dim mslinkNum       As Long
    Dim tableColumn     As Variant
    Dim sqlStatement    As String
    
    ' Opens the database table
    tableOpen
    
    ' Gets the mslink number from the element
    mslinkNum = oDatabaseLink(linkCounter).Mslink
    
    ' Populates a variant with all the table info
    tableColumn = myTable.GetRows(mslinkNum)
    
    ' Sets the unit_type field
    sqlStatement = "UPDATE " & myTableName & " SET unit_type = '" & _
        DBForm.unitType.Value & "' WHERE mslink = " & CStr(mslinkNum)
        
    dbConnection.Execute sqlStatement
    
    ' Sets the material field
    sqlStatement = "UPDATE " & myTableName & " SET material = '" & _
        DBForm.material.Value & "' WHERE mslink = " & CStr(mslinkNum)
        
    dbConnection.Execute sqlStatement
    
    ' Sets the opening_size field
    sqlStatement = "UPDATE " & myTableName & " SET opening_size = '" & _
        DBForm.openingSize.Value & "' WHERE mslink = " & CStr(mslinkNum)
        
    dbConnection.Execute sqlStatement
    
    ' Sets the notes field
    sqlStatement = "UPDATE " & myTableName & " SET notes = '" & _
        DBForm.notes.Value & "' WHERE mslink = " & CStr(mslinkNum)
        
    dbConnection.Execute sqlStatement
    
    ' Blanks out the message fields on the form
    msgProcess "", ""
    Exit Sub
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        recordGet
'
'   Author      BSI                                         12/2002
'
'-----------------------------------------------------------------------+
Function recordGet(tableColumn As Variant, mslinkNum As Long) As Long
    Dim i As Long
    
On Error GoTo Failed
    
    For i = 1 To mslinkNum
        If mslinkNum = (tableColumn(0, i)) Then
            recordGet = i
            mslinkNotExist = False
            Exit Function
        End If
    Next i
Failed:
    mslinkNotExist = True
End Function

'-----------------------------------------------------------------------+
'
'   name        recordInfoGet
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Public Sub recordInfoGet(oDatabaseLink() As DatabaseLink)

    Dim tableColumn As Variant
    Dim mslinkNum   As Long
    Dim arrayCntr   As Long
    
    ' Opens the database table
    tableOpen
    
    ' Gets the mslink value from the array
    mslinkNum = oDatabaseLink(linkCounter).Mslink
    
    ' Populates a variant with all the table info
    tableColumn = myTable.GetRows()
    
    ' Determines which array the mslink numbers are in
    arrayCntr = recordGet(tableColumn, mslinkNum)
    
    ' Checks if the mslink value exists in the table
    If mslinkNotExist = True Then GoTo Failed
    
On Error GoTo Failed
    
        ' Gets the Mslink number
        DBForm.mslinkNum.Value = (tableColumn(0, arrayCntr))
        
        ' Gets the material field
        DBForm.material.Value = (tableColumn(2, arrayCntr))
        
        ' Gets the unit_type field
        DBForm.unitType.Value = (tableColumn(3, arrayCntr))
        
        ' Gets the opening_size field
        DBForm.openingSize.Value = (tableColumn(1, arrayCntr))
        
        ' Gets the notes field
        DBForm.notes.Value = (tableColumn(4, arrayCntr))
        
        ' Blanks out the message fields on the form
        msgProcess "", ""
        
        ' Make sure the Change Data button is enabled to change the valid record
        DBForm.changeBtn.Enabled = True
        
        Exit Sub
    
Failed:

    ' Null out all the textboxes
    DBForm.mslinkNum.Value = ""
    DBForm.unitType.Value = ""
    DBForm.material.Value = ""
    DBForm.openingSize.Value = ""
    DBForm.notes.Value = ""
    
    ' Populates the message fields on the form
    msgProcess "Mslink no: " & CStr(mslinkNum) & " not found in database", "Error Found:"
    
    ' Disable the Change Data button since the mslink is invalid
    DBForm.changeBtn.Enabled = False

End Sub


