Attribute VB_Name = "DBInitialize"
Option Explicit

'*----------------------------------------------------------------------+
'
' Copyright 1993-2002, Bentley Systems, Incorporated
' All rights reserved.
'
' Limited permission is hereby granted to reproduce and modify this
' copyrighted material provided that the resulting code is used only in
' conjunction with Bentley Systems products under the terms of the
' license agreement provided therein, and that this notice is retained
' in its entirety in any such reproduction or modification.
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' DBGetSet
'
' Status: WORKING
'
' This example illustrates how get a specific database records value and
' change them by using the mslink value stored on the element selected,
' and in the Access database.
'
' Author: BSI                                               12/03/02
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------
' SQLDataSources Windows API function - needed for ODBCDataSourceExist
' function
'-----------------------------------------------------------------------
Private Declare Function SQLDataSources Lib "ODBC32.DLL" _
        (ByVal henv&, ByVal fDirection%, ByVal szDSN$, ByVal cbDSNMax%, _
         pcbDSN%, ByVal szDescription$, ByVal cbDescriptionMax%, _
         pcbDescription%) As Integer

Private Declare Function SQLAllocEnv% Lib "ODBC32.DLL" (env&)
Const SQL_FETCH_NEXT As Long = 1
Const SQL_SUCCESS As Long = 0

Public dbConnection     As New ADODB.Connection
Public myTable          As ADODB.Recordset
Public oDatabaseLink()  As New DatabaseLink
Public mslinkNotExist   As Boolean
Public myTableName      As String

'-----------------------------------------------------------------------+
'
'   name        tableOpen
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Sub tableOpen()

    ' Open employee table
    myTableName = "openings_schedule"
    Set myTable = New ADODB.Recordset
    myTable.CursorLocation = adUseClient
    myTable.Open myTableName, dbConnection, adOpenKeyset, adLockOptimistic, adCmdTable
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        dbClose
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Sub dbClose()

    dbConnection.Close
    Set dbConnection = Nothing
    Set myTable = Nothing
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        msgProcess
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Sub msgProcess(errorMsg As String, errorStatus As String)

    DBForm.errorFieldLbl.Caption = errorMsg
    DBForm.errorLbl.Caption = errorStatus
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        msLinkCntr
'
'   Author      BSI                                         12/2002
'
'-----------------------------------------------------------------------+
Function msLinkCntr(oDatabaseLink() As DatabaseLink) As Long

    Dim count   As Long
    Dim i       As Long

    For count = 0 To UBound(oDatabaseLink)
        i = i + 1
    Next
    msLinkCntr = i
    
End Function

'-----------------------------------------------------------------------+
'
'   name        ODBCdataSourceExist
'
'   Author      BSI                                         12/2002
'
'-----------------------------------------------------------------------+
Public Function ODBCdataSourceExist(DSname As String) As Boolean
    
    Dim sDSNItem    As String * 1024
    Dim sDRVItem    As String * 1024
    Dim sDSN        As String
    Dim i           As Integer
    Dim iDSNLen     As Integer
    Dim iDRVLen     As Integer
    Dim lHenv       As Long
        
    'Loop through the Data Source Names
    If SQLAllocEnv(lHenv) <> -1 Then
        Do Until i <> SQL_SUCCESS
            sDSNItem = Space$(1024)
            sDRVItem = Space$(1024)
            i = SQLDataSources(lHenv, SQL_FETCH_NEXT, sDSNItem, 1024, _
                iDSNLen, sDRVItem, 1024, iDRVLen)
            sDSN = Left$(sDSNItem, iDSNLen)
                            
            If sDSN <> Space(iDSNLen) Then
                'Test to see if the Data Source Name exists
                If sDSN = DSname Then
                    ODBCdataSourceExist = True
                    Exit Function
                End If
            End If
        Loop
    End If

    'If this point is reached, Data Source Name does not exists
    ODBCdataSourceExist = False

End Function

'-----------------------------------------------------------------------+
'
'   name        argumentsGet
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Public Function argumentsGet() As String

    argumentsGet = KeyinArguments
    
End Function

'-----------------------------------------------------------------------+
'
'   name        StartApp
'
'   Author      BSI                                         11/2002
'
'-----------------------------------------------------------------------+
Sub StartApp()

    Dim dataSourceName As String
   
    ' Place the keyed-in argument into a variable
    dataSourceName = argumentsGet
    
    ' If no argument was keyed-in, exit the app
    If dataSourceName <> "" Then
    
        ' If the data source name exists on this computer, continue
        If ODBCdataSourceExist(dataSourceName) Then
        
            ' Connect and open the database
            dbConnection.ConnectionString = "Data Source=" & dataSourceName
            dbConnection.Open
            
            ' Opens the database table
            tableOpen
            
            ' Adds the database path and file name to the form
            DBForm.databaseLbl.Caption = dbConnection.DefaultDatabase
        
            ShowPrompt "The Database: " & dataSourceName & " is Connected"
            
            ' Display the form
            DBForm.Show
        Else
            ShowMessage "Data Source Name " & dataSourceName & " is Invalid"
        End If
    Else
        ShowMessage "Please load this example using the keyin: vba run StartApp <dataSourceName>"
    End If
End Sub
