VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBLocate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents


Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
    
    ' Reinitialize the link counter
    linkCounter = 0
    
    ' Extracts the ODBC links from the element into an array
    oDatabaseLink() = Element.GetDatabaseLinks(msdDatabaseLinkageOdbc)
    
    ' Gets the total number of links from the element
    totLinkCounter = msLinkCntr(oDatabaseLink())
    
    ' If there is more then 1 link, enable the plus button
    If totLinkCounter > 1 Then
        DBForm.plusBtn.Enabled = True
    Else
        DBForm.plusBtn.Enabled = False
    End If
    
    ' This button should always be initially disabled when a new element
    ' is selected
    DBForm.minusBtn.Enabled = False
    
    recordInfoGet oDatabaseLink()
        
    ' Restarts the locate command
    CommandState.StartLocate Me
    
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)

    If Element.HasAnyDatabaseLinks = True Then
        Accepted = True
    Else
        Accepted = False
    End If

End Sub

Private Sub ILocateCommandEvents_LocateReset()

    CommandState.StartDefaultCommand
    ShowError "Command Aborted"

End Sub

Private Sub ILocateCommandEvents_Start()

    Dim oLocateCriteria As LocateCriteria
    Set oLocateCriteria = CommandState.CreateLocateCriteria(False)
    CommandState.SetLocateCriteria oLocateCriteria

    ShowCommand "Database Example"
    ShowPrompt "Select Element"
    
End Sub
