VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DbElementLocate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'-----------------------------------------------------------------------+
'
'   DbElementLocate.cls
'   1.0
'   09.23.2003
'
'   Copyright: (c) 2003 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+

Implements ILocateCommandEvents

Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
            
    DbLinkAdd Element
    Element.Redraw msdDrawingModeNormal
    
    CommandState.StartLocate New DbElementLocate
      
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)

    ' Only proceed if an element has been selected
    If Element.IsGraphical = True Then
        Accepted = True
    Else
        Accepted = False
        ShowMessage "Please re-select an element"
        Beep
    End If

End Sub

Private Sub ILocateCommandEvents_LocateReset()
    
    ShowMessage "Command Aborted"
    
    ' Start the element selection tool command
    CommandState.StartDefaultCommand

End Sub

Private Sub ILocateCommandEvents_Start()

    Dim oLocateCriteria As LocateCriteria
    
    ' Set the locate criteria to not accept read-only elements
    Set oLocateCriteria = CommandState.CreateLocateCriteria(True)
    CommandState.SetLocateCriteria oLocateCriteria
    
    ShowCommand "Attach OleDb Linkage Example"
    ShowPrompt "Select Element"
    
End Sub
