VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} MyColorPicker 
   Caption         =   "MyColorPicker"
   ClientHeight    =   1260
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2880
   OleObjectBlob   =   "MyColorPicker.frx":0000
   ShowModal       =   0   'False
End
Attribute VB_Name = "MyColorPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------------+
' colorPicker
'
' Status: WORKING
'
' Date: 05/13/02
'
' This example illustrates how to use the MicroStations color picker
' in MSVBA.
'
' Author: BSI                                                   05/13/02
'
'-----------------------------------------------------------------------+
'-----------------------------------------------------------------------+
'
'   name        cfgVarGet
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Function cfgVarGet(cfgVarName As String, expand As Boolean) As String
        
    cfgVarGet = ActiveWorkspace.ConfigurationVariableValue(cfgVarName, expand)
    
End Function
'-----------------------------------------------------------------------+
'
'   name        BTN_COLORPICKER_Click
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub BTN_COLORPICKER_Click()
    Dim cPickerValue As String
    Dim color As Long
    Dim nResult As Integer

    ' Hide dialog box
    MyColorPicker.Hide
    
    ' Call the mdl helper to bring up the color picker
    CadInputQueue.SendCommand "mdl load colorP" & IIf(CHK_ACTIVECOLOR.Value = True, "", " 1")
    
    ' Display dialog box
    MyColorPicker.Show
    
    ' Get the value of the color choosen
    cPickerValue = cfgVarGet("CPICKER", True)

    ' Get RGB from index
      nResult = GetCExpressionValue("mdlColor_elementColorToRGB (" & VarPtr(color) & ", 0, 0," & cPickerValue & ", 0 )")
    
    If cPickerValue = -1 Then
        BTN_COLORPICKER.BackColor = &H80000000
        
        'Display by level
        EDT_COLORVAL.Text = "By Level"
    Else
        ' Set color
        BTN_COLORPICKER.BackColor = color
        
        'Display color index value
        EDT_COLORVAL.Text = cPickerValue
    End If
      
 End Sub
'-----------------------------------------------------------------------+
'
'   name        UserForm_Initialize
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub UserForm_Initialize()
    Dim cPickerValue As Long
    Dim color As Long
    Dim nResult As Integer
    
    ' Get the active color index
    nResult = GetCExpressionValue("mdlParams_getActive (" & VarPtr(cPickerValue) & ",1)")
      
    ' Get RGB from index
    nResult = GetCExpressionValue("mdlColor_elementColorToRGB (" & VarPtr(color) & ", 0, 0," & cPickerValue & ", 0 )")
    
    ' Check to see if active settings is By Level
    If cPickerValue = -1 Then
        BTN_COLORPICKER.BackColor = &H80000000
        
        'Display by level
        EDT_COLORVAL.Text = "By Level"
    Else
        ' Set color
        BTN_COLORPICKER.BackColor = color
        
        'Display color index value
        EDT_COLORVAL.Text = cPickerValue
    End If


End Sub
'-----------------------------------------------------------------------+
'
'   name        UserForm_Terminate
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub UserForm_Terminate()

' Unload the form
Unload MyColorPicker

End Sub
