/*----------------------------------------------------------------------+
|
|   colorp.mc
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   STATUS: WORKING
|   DATE:   5/10/2002 3:48:26 PM
|
|   This example illustrates how to reuse the color picker.
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   Include Files
|
+----------------------------------------------------------------------*/
#include <mdl.h>
#include <mdlerrs.h>
#include <cexpr.h>
#include <cmdlist.h>
#include <stdlib.h>
#include <string.h>
#include <dlogids.h>
#include <dlogitem.h>
#include <dlogbox.h>
#include "colorp.h"

#include <dlogman.fdf>
#include <msmisc.fdf>
#include <msinput.fdf>
#include <msoutput.fdf>
#include <msrsrc.fdf>
#include <msstate.fdf>
#include <mssystem.fdf>
#include <msvar.fdf>

#if defined (MSVERSION)  (MSVERSION >= 0x790)

#else

#endif

/*----------------------------------------------------------------------+
|
|   Public variables
|
+----------------------------------------------------------------------*/
DialogItem *cPicker;
int         oldColor = 0;
int         activeColor = TRUE;

/*----------------------------------------------------------------------+
|
|   External variables
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   Function Definitions
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   Function Declarations
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   name        exitApplication
|
|   author      BSI                                         12/1998
|
+----------------------------------------------------------------------*/
Private void exitApplication
(
boolean silently /* => Unload this application silently */
)
    {

    /*-----------------------------------------------------------
    Queue a command to unload the application with/without displaying
    a notification message.
    -----------------------------------------------------------*/
    mdlDialog_cmdNumberQueue (FALSE,
                             (silently) ? CMD_MDL_SILENTUNLOAD : CMD_MDL_UNLOAD,
                              mdlSystem_getCurrTaskID (), TRUE);

    /* Start the default command */
    mdlState_startDefaultCommand ();
    }

/*----------------------------------------------------------------------+
|
|   name        openResources
|
|   author      BSI                                         12/1998
|
+----------------------------------------------------------------------*/
Private void openResources
(
void
)
    {
    RscFileHandle rscH;  /* A resource file handle */

    if (mdlResource_openFile (&rscH, NULL, RSC_READONLY) != SUCCESS)
        {
        mdlOutput_error ("Unable to load Resource File.");
        }
    }

/*----------------------------------------------------------------------+
|                                      
| name          colorPicker            
|                                      
| author        BSI                    
|                                      
+----------------------------------------------------------------------*/
Private void    colorPicker
(
DialogMessage   *dmP    /* => a ptr to a dialog message */
)
    {
    char data [MAXFILELENGTH];

    dmP->msgUnderstood = TRUE;

    switch (dmP->messageType)
        {
        case DIALOG_MESSAGE_BEFOREDESTROY:
            {
            int     newColor;
            int     status = -1;

            // Get the new value
            mdlParams_getActive ((void *)&newColor, ACTIVEPARAM_COLOR );

            // Set a system configuration variable.
            sprintf (data, "%d", newColor);
            status = mdlSystem_defineCfgVar ("CPICKER", data, CFGVAR_LEVEL_USER);

            break;
            }
        case DIALOG_MESSAGE_DESTROY:
            {

            if (activeColor == FALSE)
                // Reject the value
                mdlParams_setActive ((void *)oldColor, ACTIVEPARAM_COLOR);

            break;
            }

        case DIALOG_MESSAGE_INIT:
            {

            // Get the original value and store off in a global
            mdlParams_getActive ((void *)&oldColor, ACTIVEPARAM_COLOR );

            break;
            }

        default:
            dmP->msgUnderstood = FALSE;

            break;
        }
    }

/*----------------------------------------------------------------------+
|                                   
|   name        uHooks                                
|
|   author      BSI                                         12/1998
|                                   
+----------------------------------------------------------------------*/
Private DialogHookInfo uHooks[]=
    {
    {HOOK_CPICKER,         colorPicker},
    };

/*----------------------------------------------------------------------+
|                                   
|   name        main                                
|
|   author      BSI                                         12/1998
|                                   
+----------------------------------------------------------------------*/
Private int main 
(
int     argc,   /* => Number of arguments passed in argv */
char    *argv[] /* => Array of pointers to arguments */
)   
    {
    /* Open our application for use with the Resource Manager */
    openResources ();

    /* 
        If an argument is passed set the flag to FALSE to reject 
        setting the active settings
    */
    if (argv[2])
        activeColor = FALSE;
               
    /*-----------------------------------------------------------------+
    | mdlDialog_hookPublish:
    |
    | To make the Dialog Box Manager aware of the function pointers
    | that we have equated to our hook ids we need to publish the
    | DialogHookInfo structure, uHooks (declared at the top of this file).
    +-----------------------------------------------------------------*/
    mdlDialog_hookPublish (sizeof (uHooks)/sizeof (DialogHookInfo), uHooks);
    
    // Open the dialogbox.
    mdlDialog_openModal (NULL, NULL, DIALOGID_MSColorPicker);

    /* Exit the current MDL application */
    exitApplication (FALSE);
    return SUCCESS;
    }
