VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDimensionStyle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
'  Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
Option Explicit

Private m_pDimStyle As Long
Private m_overridesWorking As Long
Private m_overridesFinal As Long

Private Const DIMSTYLE_PROP_BallAndChain_Alignment_INTEGER                        As Long = 101
Private Const DIMSTYLE_PROP_BallAndChain_ChainTerminator_INTEGER                  As Long = 102
Private Const DIMSTYLE_PROP_BallAndChain_ChainType_INTEGER                        As Long = 103
Private Const DIMSTYLE_PROP_BallAndChain_IsActive_BOOLINT                         As Long = 104
Private Const DIMSTYLE_PROP_BallAndChain_ShowTextLeader_BOOLINT                   As Long = 105
Private Const DIMSTYLE_PROP_BallAndChain_NoDockOnDimLine_BOOLINT                  As Long = 106
Private Const DIMSTYLE_PROP_MLNote_ElbowLength_DOUBLE                             As Long = 108
Private Const DIMSTYLE_PROP_ExtensionLine_Color_COLOR                             As Long = 201
Private Const DIMSTYLE_PROP_ExtensionLine_Extend_DOUBLE                           As Long = 202
Private Const DIMSTYLE_PROP_ExtensionLine_Join_BOOLINT                            As Long = 203
Private Const DIMSTYLE_PROP_ExtensionLine_Left_TEMPLATEFLAG                       As Long = 204
Private Const DIMSTYLE_PROP_ExtensionLine_LineStyle_LINESTYLE                     As Long = 205
Private Const DIMSTYLE_PROP_ExtensionLine_Offset_DOUBLE                           As Long = 206
Private Const DIMSTYLE_PROP_ExtensionLine_OverrideColor_BOOLINT                   As Long = 207
Private Const DIMSTYLE_PROP_ExtensionLine_OverrideLineStyle_BOOLINT               As Long = 208
Private Const DIMSTYLE_PROP_ExtensionLine_OverrideWeight_BOOLINT                  As Long = 209
Private Const DIMSTYLE_PROP_ExtensionLine_Right_TEMPLATEFLAG                      As Long = 210
Private Const DIMSTYLE_PROP_ExtensionLine_ShowAny_BOOLINT                         As Long = 211
Private Const DIMSTYLE_PROP_ExtensionLine_Weight_WEIGHT                           As Long = 212
Private Const DIMSTYLE_PROP_ExtensionLine_AngleChordAlign_TEMPLATEFLAG            As Long = 213
Private Const DIMSTYLE_PROP_General_Alignment_INTEGER                             As Long = 301
Private Const DIMSTYLE_PROP_General_CenterMarkSize_DOUBLE                         As Long = 302
Private Const DIMSTYLE_PROP_General_Color_COLOR                                   As Long = 303
Private Const DIMSTYLE_PROP_General_DimensionScale_DOUBLE                         As Long = 304
Private Const DIMSTYLE_PROP_General_DimStyleDescription_MSWCHAR                   As Long = 305
Private Const DIMSTYLE_PROP_General_DimStyleName_MSWCHAR                          As Long = 306
Private Const DIMSTYLE_PROP_General_Font_FONT                                     As Long = 307
Private Const DIMSTYLE_PROP_General_IgnoreLevelSymbology_BOOLINT                  As Long = 308
Private Const DIMSTYLE_PROP_General_LineStyle_LINESTYLE                           As Long = 309
Private Const DIMSTYLE_PROP_General_OverrideColor_BOOLINT                         As Long = 310
Private Const DIMSTYLE_PROP_General_OverrideLineStyle_BOOLINT                     As Long = 311
Private Const DIMSTYLE_PROP_General_OverrideWeight_BOOLINT                        As Long = 312
Private Const DIMSTYLE_PROP_General_RadialMode_INTEGER                            As Long = 313
Private Const DIMSTYLE_PROP_General_RelativeDimLine_BOOLINT                       As Long = 314
Private Const DIMSTYLE_PROP_General_ShowCenterMark_TEMPLATEFLAG                   As Long = 315
Private Const DIMSTYLE_PROP_General_Stacked_TEMPLATEFLAG                          As Long = 316
Private Const DIMSTYLE_PROP_General_StackOffset_DOUBLE                            As Long = 317
Private Const DIMSTYLE_PROP_General_Weight_WEIGHT                                 As Long = 318
Private Const DIMSTYLE_PROP_MLNote_FrameType_INTEGER                              As Long = 401
Private Const DIMSTYLE_PROP_MLNote_Justification_INTEGER                          As Long = 402
Private Const DIMSTYLE_PROP_MLNote_ShowLeader_BOOLINT                             As Long = 403
Private Const DIMSTYLE_PROP_MLNote_VerticalJustification_INTEGER                  As Long = 404
Private Const DIMSTYLE_PROP_MLNote_LeaderType_BOOLINT                             As Long = 405
Private Const DIMSTYLE_PROP_MLNote_TextRotation_INTEGER                           As Long = 406
Private Const DIMSTYLE_PROP_MLNote_HorAttachment_INTEGER                          As Long = 407
Private Const DIMSTYLE_PROP_MLNote_VerLeftAttachment_INTEGER                      As Long = 408
Private Const DIMSTYLE_PROP_MLNote_VerRightAttachment_INTEGER                     As Long = 409
Private Const DIMSTYLE_PROP_MLNote_LeftMargin_DOUBLE                              As Long = 410
Private Const DIMSTYLE_PROP_MLNote_LowerMargin_DOUBLE                             As Long = 411
Private Const DIMSTYLE_PROP_Placement_CompatibleV3_BOOLINT                        As Long = 501
Private Const DIMSTYLE_PROP_Placement_Level_LEVEL                                 As Long = 502
Private Const DIMSTYLE_PROP_Placement_OverrideLevel_BOOLINT                       As Long = 503
Private Const DIMSTYLE_PROP_Placement_TextPosition_INTEGER                        As Long = 504
Private Const DIMSTYLE_PROP_Placement_UseReferenceScale_BOOLINT                   As Long = 505
Private Const DIMSTYLE_PROP_Placement_NotUseModelAnnotationScale_BOOLINT          As Long = 506
Private Const DIMSTYLE_PROP_Placement_AnnotationScale_DOUBLE                      As Long = 507
Private Const DIMSTYLE_PROP_Symbol_DiameterChar_CHAR                              As Long = 601
Private Const DIMSTYLE_PROP_Symbol_DiameterFont_FONT                              As Long = 602
Private Const DIMSTYLE_PROP_Symbol_DiameterType_INTEGER                           As Long = 603
Private Const DIMSTYLE_PROP_Symbol_LowerPrefixChar_CHAR                           As Long = 604
Private Const DIMSTYLE_PROP_Symbol_LowerSuffixChar_CHAR                           As Long = 605
Private Const DIMSTYLE_PROP_Symbol_MainPrefixChar_CHAR                            As Long = 606
Private Const DIMSTYLE_PROP_Symbol_MainSuffixChar_CHAR                            As Long = 607
Private Const DIMSTYLE_PROP_Symbol_PlusMinusChar_CHAR                             As Long = 608
Private Const DIMSTYLE_PROP_Symbol_PlusMinusType_INTEGER                          As Long = 609
Private Const DIMSTYLE_PROP_Symbol_Prefix_TEMPLATEFLAG                            As Long = 610
Private Const DIMSTYLE_PROP_Symbol_PrefixCellName_MSWCHAR                         As Long = 611
Private Const DIMSTYLE_PROP_Symbol_PrefixChar_CHAR                                As Long = 612
Private Const DIMSTYLE_PROP_Symbol_PrefixFont_FONT                                As Long = 613
Private Const DIMSTYLE_PROP_Symbol_PrefixType_INTEGER                             As Long = 614
Private Const DIMSTYLE_PROP_Symbol_Suffix_TEMPLATEFLAG                            As Long = 615
Private Const DIMSTYLE_PROP_Symbol_SuffixCellName_MSWCHAR                         As Long = 616
Private Const DIMSTYLE_PROP_Symbol_SuffixChar_CHAR                                As Long = 617
Private Const DIMSTYLE_PROP_Symbol_SuffixFont_FONT                                As Long = 618
Private Const DIMSTYLE_PROP_Symbol_SuffixType_INTEGER                             As Long = 619
Private Const DIMSTYLE_PROP_Symbol_TolPrefixChar_CHAR                             As Long = 620
Private Const DIMSTYLE_PROP_Symbol_TolSuffixChar_CHAR                             As Long = 621
Private Const DIMSTYLE_PROP_Symbol_UpperPrefixChar_CHAR                           As Long = 622
Private Const DIMSTYLE_PROP_Symbol_UpperSuffixChar_CHAR                           As Long = 623
Private Const DIMSTYLE_PROP_Terminator_ArrowCellName_MSWCHAR                      As Long = 701
Private Const DIMSTYLE_PROP_Terminator_ArrowChar_CHAR                             As Long = 702
Private Const DIMSTYLE_PROP_Terminator_ArrowFont_FONT                             As Long = 703
Private Const DIMSTYLE_PROP_Terminator_ArrowType_INTEGER                          As Long = 704
Private Const DIMSTYLE_PROP_Terminator_Color_COLOR                                As Long = 705
Private Const DIMSTYLE_PROP_Terminator_DotCellName_MSWCHAR                        As Long = 706
Private Const DIMSTYLE_PROP_Terminator_DotChar_CHAR                               As Long = 707
Private Const DIMSTYLE_PROP_Terminator_DotFont_FONT                               As Long = 708
Private Const DIMSTYLE_PROP_Terminator_DotType_INTEGER                            As Long = 709
Private Const DIMSTYLE_PROP_Terminator_First_TEMPLATEFLAG                         As Long = 710
Private Const DIMSTYLE_PROP_Terminator_Height_DOUBLE                              As Long = 711
Private Const DIMSTYLE_PROP_Terminator_Joint_TEMPLATEFLAG                         As Long = 712
Private Const DIMSTYLE_PROP_Terminator_Left_TEMPLATEFLAG                          As Long = 713
Private Const DIMSTYLE_PROP_Terminator_LineStyle_LINESTYLE                        As Long = 714
Private Const DIMSTYLE_PROP_Terminator_MinLeader_DOUBLE                           As Long = 715
Private Const DIMSTYLE_PROP_Terminator_Mode_INTEGER                               As Long = 716
Private Const DIMSTYLE_PROP_Terminator_NoLineThruArrow_BOOLINT                    As Long = 717
Private Const DIMSTYLE_PROP_Terminator_NoLineThruDot_BOOLINT                      As Long = 718
Private Const DIMSTYLE_PROP_Terminator_NoLineThruOrigin_BOOLINT                   As Long = 719
Private Const DIMSTYLE_PROP_Terminator_NoLineThruStroke_BOOLINT                   As Long = 720
Private Const DIMSTYLE_PROP_Terminator_OriginCellName_MSWCHAR                     As Long = 721
Private Const DIMSTYLE_PROP_Terminator_OriginChar_CHAR                            As Long = 722
Private Const DIMSTYLE_PROP_Terminator_OriginFont_FONT                            As Long = 723
Private Const DIMSTYLE_PROP_Terminator_OriginType_INTEGER                         As Long = 724
Private Const DIMSTYLE_PROP_Terminator_OverrideColor_BOOLINT                      As Long = 725
Private Const DIMSTYLE_PROP_Terminator_OverrideLineStyle_BOOLINT                  As Long = 726
Private Const DIMSTYLE_PROP_Terminator_OverrideWeight_BOOLINT                     As Long = 727
Private Const DIMSTYLE_PROP_Terminator_Right_TEMPLATEFLAG                         As Long = 728
Private Const DIMSTYLE_PROP_Terminator_Arrowhead_INTEGER                          As Long = 729
Private Const DIMSTYLE_PROP_Terminator_StrokeCellName_MSWCHAR                     As Long = 730
Private Const DIMSTYLE_PROP_Terminator_StrokeChar_CHAR                            As Long = 731
Private Const DIMSTYLE_PROP_Terminator_StrokeFont_FONT                            As Long = 732
Private Const DIMSTYLE_PROP_Terminator_StrokeType_INTEGER                         As Long = 733
Private Const DIMSTYLE_PROP_Terminator_Weight_WEIGHT                              As Long = 734
Private Const DIMSTYLE_PROP_Terminator_Width_DOUBLE                               As Long = 735
Private Const DIMSTYLE_PROP_Terminator_Note_INTEGER                               As Long = 736
Private Const DIMSTYLE_PROP_Terminator_NoteType_INTEGER                           As Long = 737
Private Const DIMSTYLE_PROP_Terminator_NoteCellName_MSWCHAR                       As Long = 738
Private Const DIMSTYLE_PROP_Terminator_NoteChar_CHAR                              As Long = 739
Private Const DIMSTYLE_PROP_Terminator_NoteFont_FONT                              As Long = 740
Private Const DIMSTYLE_PROP_Text_ArcLengthSymbol_TEMPLATEFLAG                     As Long = 801
Private Const DIMSTYLE_PROP_Text_AutoLift_BOOLINT                                 As Long = 802
Private Const DIMSTYLE_PROP_Text_Color_COLOR                                      As Long = 805
Private Const DIMSTYLE_PROP_Text_DecimalComma_BOOLINT                             As Long = 806
Private Const DIMSTYLE_PROP_Text_Embed_BOOLINT                                    As Long = 807
Private Const DIMSTYLE_PROP_Text_Font_BOOLINT                                     As Long = 808
Private Const DIMSTYLE_PROP_Text_Height_DOUBLE                                    As Long = 809
Private Const DIMSTYLE_PROP_Text_Horizontal_BOOLINT                               As Long = 810
Private Const DIMSTYLE_PROP_Text_HorizontalMargin_DOUBLE                          As Long = 811
Private Const DIMSTYLE_PROP_Text_Justification_INTEGER                            As Long = 812
Private Const DIMSTYLE_PROP_Text_LeadingZero_BOOLINT                              As Long = 813
Private Const DIMSTYLE_PROP_Text_OmitLeadingDelimiter_BOOLINT                     As Long = 815
Private Const DIMSTYLE_PROP_Text_OverrideColor_BOOLINT                            As Long = 816
Private Const DIMSTYLE_PROP_Text_OverrideHeight_BOOLINT                           As Long = 817
Private Const DIMSTYLE_PROP_Text_OverrideWeight_BOOLINT                           As Long = 818
Private Const DIMSTYLE_PROP_Text_OverrideWidth_BOOLINT                            As Long = 819
Private Const DIMSTYLE_PROP_Text_SecLeadingZero_BOOLINT                           As Long = 820
Private Const DIMSTYLE_PROP_Text_ShowSecondary_BOOLINT                            As Long = 821
Private Const DIMSTYLE_PROP_Text_Underline_BOOLINT                                As Long = 822
Private Const DIMSTYLE_PROP_Text_VerticalMargin_DOUBLE                            As Long = 824
Private Const DIMSTYLE_PROP_Text_Weight_WEIGHT                                    As Long = 825
Private Const DIMSTYLE_PROP_Text_Width_DOUBLE                                     As Long = 826
Private Const DIMSTYLE_PROP_Text_TextStyle_TEXTSTYLE                              As Long = 827
Private Const DIMSTYLE_PROP_Text_TextStyleID_INTEGER                              As Long = 828
Private Const DIMSTYLE_PROP_Text_StackedFractionAlignment_INTEGER                 As Long = 829
Private Const DIMSTYLE_PROP_Text_StackedFractions_BOOLINT                         As Long = 830
Private Const DIMSTYLE_PROP_Text_StackedFractionType_INTEGER                      As Long = 831
Private Const DIMSTYLE_PROP_Text_StackedFractionScale_DOUBLE                      As Long = 832
Private Const DIMSTYLE_PROP_Text_OverrideStackedFractions_BOOLINT                 As Long = 833
Private Const DIMSTYLE_PROP_Text_OverrideUnderline_BOOLINT                        As Long = 834
Private Const DIMSTYLE_PROP_Text_Location_INTEGER                                 As Long = 835
Private Const DIMSTYLE_PROP_Text_VerticalOpts_TEMPLATEFLAG                        As Long = 836
Private Const DIMSTYLE_PROP_Text_FrameType_INTEGER                                As Long = 837
Private Const DIMSTYLE_PROP_Tolerance_LowerValue_DOUBLE                           As Long = 901
Private Const DIMSTYLE_PROP_Tolerance_Mode_BOOLINT                                As Long = 902
Private Const DIMSTYLE_PROP_Tolerance_Show_BOOLINT                                As Long = 903
Private Const DIMSTYLE_PROP_Tolerance_StackEqual_BOOLINT                          As Long = 904
Private Const DIMSTYLE_PROP_Tolerance_TextHorizontalMargin_DOUBLE                 As Long = 905
Private Const DIMSTYLE_PROP_Tolerance_TextScale_DOUBLE                            As Long = 906
Private Const DIMSTYLE_PROP_Tolerance_TextVerticalMargin_DOUBLE                   As Long = 907
Private Const DIMSTYLE_PROP_Tolerance_TextVerticalSeparation_DOUBLE               As Long = 908
Private Const DIMSTYLE_PROP_Tolerance_UpperValue_DOUBLE                           As Long = 909
Private Const DIMSTYLE_PROP_Tolerance_Accuracy_ACCURACY                           As Long = 910
Private Const DIMSTYLE_PROP_Tolerance_SecAccuracy_ACCURACY                        As Long = 911
Private Const DIMSTYLE_PROP_Value_Accuracy_ACCURACY                               As Long = 1001
Private Const DIMSTYLE_PROP_Value_AltAccuracy_ACCURACY                            As Long = 1002
Private Const DIMSTYLE_PROP_Value_AltIsActive_BOOLINT                             As Long = 1003
Private Const DIMSTYLE_PROP_Value_AltSecAccuracy_ACCURACY                         As Long = 1004
Private Const DIMSTYLE_PROP_Value_AltSecIsActive_BOOLINT                          As Long = 1005
Private Const DIMSTYLE_PROP_Value_AltSecShowWhenThresholdLess_BOOLINT             As Long = 1011
Private Const DIMSTYLE_PROP_Value_AltSecShowZeroMasterUnit_BOOLINT                As Long = 1012
Private Const DIMSTYLE_PROP_Value_AltSecThreshold_DOUBLE                          As Long = 1013
Private Const DIMSTYLE_PROP_Value_AltShowZeroMasterUnit_BOOLINT                   As Long = 1020
Private Const DIMSTYLE_PROP_Value_AltThreshold_DOUBLE                             As Long = 1021
Private Const DIMSTYLE_PROP_Value_AngleFormat_INTEGER                             As Long = 1023
Private Const DIMSTYLE_PROP_Value_AngleLeadingZero_BOOLINT                        As Long = 1024
Private Const DIMSTYLE_PROP_Value_AngleMeasure_BOOLINT                            As Long = 1025
Private Const DIMSTYLE_PROP_Value_AnglePrecision_INTEGER                          As Long = 1026
Private Const DIMSTYLE_PROP_Value_AngleTrailingZeros_BOOLINT                      As Long = 1027
Private Const DIMSTYLE_PROP_Value_RoundLSD_BOOLINT                                As Long = 1028
Private Const DIMSTYLE_PROP_Value_SecAccuracy_ACCURACY                            As Long = 1029
Private Const DIMSTYLE_PROP_Value_SecShowTrailingZeros_BOOLINT                    As Long = 1033
Private Const DIMSTYLE_PROP_Value_SecShowZeroMasterUnit_BOOLINT                   As Long = 1035
Private Const DIMSTYLE_PROP_Value_ShowTrailingZeros_BOOLINT                       As Long = 1039
Private Const DIMSTYLE_PROP_Value_ShowZeroMasterUnit_BOOLINT                      As Long = 1041
Private Const DIMSTYLE_PROP_Value_NoReduceFraction_BOOLINT                        As Long = 1042
Private Const DIMSTYLE_PROP_Value_NoReduceAltFraction_BOOLINT                     As Long = 1043
Private Const DIMSTYLE_PROP_Value_NoReduceTolFraction_BOOLINT                     As Long = 1044
Private Const DIMSTYLE_PROP_Value_SuperscriptLSD_BOOLINT                          As Long = 1045
Private Const DIMSTYLE_PROP_Value_Unit_UNITS                                      As Long = 1048
Private Const DIMSTYLE_PROP_Value_UnitLabelMaster_MSWCHAR                         As Long = 1049
Private Const DIMSTYLE_PROP_Value_UnitLabelSecMaster_MSWCHAR                      As Long = 1050
Private Const DIMSTYLE_PROP_Value_UnitLabelSecSub_MSWCHAR                         As Long = 1051
Private Const DIMSTYLE_PROP_Value_UnitLabelSub_MSWCHAR                            As Long = 1052
Private Const DIMSTYLE_PROP_Value_UnitSec_UNITS                                   As Long = 1053
Private Const DIMSTYLE_PROP_Value_UseWorkingUnits_BOOLINT                         As Long = 1054
Private Const DIMSTYLE_PROP_Value_OrdDecrementReverse_BOOLINT                     As Long = 1055
Private Const DIMSTYLE_PROP_Value_OrdUseDatumValue_BOOLINT                        As Long = 1056
Private Const DIMSTYLE_PROP_Value_OrdDatumValue_DOUBLE                            As Long = 1057
Private Const DIMSTYLE_PROP_Value_NoReduceSecFraction_BOOLINT                     As Long = 1061
Private Const DIMSTYLE_PROP_Value_NoReduceAltSecFraction_BOOLINT                  As Long = 1062
Private Const DIMSTYLE_PROP_Value_NoReduceTolSecFraction_BOOLINT                  As Long = 1063
Private Const DIMSTYLE_PROP_Value_OrdFreeLocation_BOOLINT                         As Long = 1065
Private Const DIMSTYLE_PROP_Value_Format_INTEGER                                  As Long = 1066
Private Const DIMSTYLE_PROP_Value_AltFormat_INTEGER                               As Long = 1067
Private Const DIMSTYLE_PROP_Value_SecFormat_INTEGER                               As Long = 1068
Private Const DIMSTYLE_PROP_Value_AltSecFormat_INTEGER                            As Long = 1069
Private Const DIMSTYLE_PROP_Value_AltThresholdComparison_INTEGER                  As Long = 1070
Private Const DIMSTYLE_PROP_Value_AltSecThresholdComparison_INTEGER               As Long = 1071
Private Const DIMSTYLE_PROP_Value_ThousandsOpts_INTEGER                           As Long = 1072
Private Const DIMSTYLE_PROP_Value_UnitMaster_ONEUNIT                              As Long = 1073
Private Const DIMSTYLE_PROP_Value_UnitSub_ONEUNIT                                 As Long = 1074
Private Const DIMSTYLE_PROP_Value_SecUnitMaster_ONEUNIT                           As Long = 1075
Private Const DIMSTYLE_PROP_Value_SecUnitSub_ONEUNIT                              As Long = 1076
Private Const DIMSTYLE_PROP_Value_LabelLineFormat_INTEGER                         As Long = 1077
Private Const DIMSTYLE_PROP_Value_ShowZeroSubUnit_BOOLINT                         As Long = 1078
Private Const DIMSTYLE_PROP_Value_AltShowZeroSubUnit_BOOLINT                      As Long = 1079
Private Const DIMSTYLE_PROP_Value_SecShowZeroSubUnit_BOOLINT                      As Long = 1080
Private Const DIMSTYLE_PROP_Value_AltSecShowZeroSubUnit_BOOLINT                   As Long = 1081

Private Sub ClearOverrides()
    If m_overridesWorking Then
        mdlDimStylePropMask_free m_overridesWorking
    End If
    If m_overridesFinal Then
        mdlDimStylePropMask_free m_overridesFinal
    End If
End Sub
Private Sub Class_Initialize()
    '
    '  Allocate the memory and initialize it from the active dimension style
    '
    m_pDimStyle = modUtility.mdlDimStyle_create
    CopyFromActiveStyle
End Sub
Private Sub Class_Terminate()
    '
    '  Free the memory that holds the text style
    '
    modUtility.mdlDimStyle_free m_pDimStyle
    ClearOverrides
End Sub
Private Sub CheckStatus(status As Long, strType As String)
    If status <> 0 Then Err.Raise &H80040004, strType
End Sub
Private Sub SetOverride(ID As Long)
    If m_overridesWorking = 0 Then Exit Sub
    
    mdlDimStylePropMask_setPropertyBit m_overridesWorking, ID, 0
    mdlDimStylePropMask_setPropertyBit m_overridesFinal, ID, 1
End Sub
'
'
'   General Routines for the Implementation of Properties
'
'
Private Function GetBooleanProperty(ID As Long) As Boolean
    Dim status As Long
    Dim result As Long
    status = modGetMethods.mdlDimStyle_getBoolIntProp(m_pDimStyle, result, ID)
    CheckStatus status, "BooleanProperty"
    GetBooleanProperty = result <> 0
End Function
Private Sub SetBooleanProperty(NewValue As Boolean, ID As Long)
    Dim status As Long
    Dim lNewValue As Long
    
    SetOverride ID
    
    If NewValue Then lNewValue = 1
    status = modSetMethods.mdlDimStyle_setBoolIntProp(m_pDimStyle, lNewValue, ID)
    CheckStatus status, "BooleanProperty"
End Sub
Private Function GetDoubleProperty(ID As Long) As Double
    Dim status As Long

    status = modGetMethods.mdlDimStyle_getDoubleProp(m_pDimStyle, GetDoubleProperty, ID)
    CheckStatus status, "DoubleProperty"
End Function
Private Sub SetDoubleProperty(NewValue As Double, ID As Long)
    Dim status As Long

    SetOverride ID
    status = modSetMethods.mdlDimStyle_setDoubleProp(m_pDimStyle, NewValue, ID)
    
    CheckStatus status, "DoubleProperty"
End Sub
Private Function GetFontProperty(ID As Long) As Font
    Dim status As Long
    Dim result As Long
    Dim oFont As Font
    
    status = modGetMethods.mdlDimStyle_getFontProp(m_pDimStyle, result, ID)
    CheckStatus status, "FontProperty"
    For Each oFont In ActiveDesignFile.Fonts
        If oFont.ID = result Then
            Set GetFontProperty = oFont
            Exit Function
        End If
    Next
End Function
Private Sub SetFontProperty(NewValue As Font, ID As Long)
    Dim status As Long
    
    SetOverride ID
    status = modSetMethods.mdlDimStyle_setFontProp(m_pDimStyle, NewValue.ID, ID)
    CheckStatus status, "FontProperty"
End Sub
'
''  Level Property
'
Private Function GetLevelProperty(ID As Long) As Level
    Dim status As Long
    Dim result As Long
    Dim oLevel As Level
    
    status = modGetMethods.mdlDimStyle_getLevelProp(m_pDimStyle, result, ID)
    CheckStatus status, "LevelProperty"
    For Each oLevel In ActiveDesignFile.Levels
        If oLevel.ID = result Then
            Set GetLevelProperty = oLevel
            Exit Function
        End If
    Next
End Function
Private Sub SetLevelProperty(NewValue As Level, ID As Long)
    Dim status As Long
    
    SetOverride ID
    
    status = modSetMethods.mdlDimStyle_setLevelProp(m_pDimStyle, NewValue.ID, ID)
    CheckStatus status, "LevelProperty"
End Sub
'
''  LineStyle
'
Private Function GetLineStyleProperty(ID As Long) As LineStyle
    Dim status As Long
    Dim result As Long
    Dim oLineStyle As LineStyle
    
    status = modGetMethods.mdlDimStyle_getLineStyleProp(m_pDimStyle, result, ID)
    CheckStatus status, "LineStyleProperty"
    For Each oLineStyle In ActiveDesignFile.LineStyles
        If oLineStyle.Number = result Then
            Set GetLineStyleProperty = oLineStyle
            Exit Function
        End If
    Next
End Function
Private Sub SetLineStyleProperty(NewValue As LineStyle, ID As Long)
    Dim status As Long
    
    SetOverride ID
    
    status = modSetMethods.mdlDimStyle_setLineStyleProp(m_pDimStyle, NewValue.Number, ID)
    CheckStatus status, "LineStyleProperty"
End Sub

Private Function GetCharProperty(ID As Long) As String
    Dim status As Long
    
    GetCharProperty = Space(1)
    
    status = modGetMethods.mdlDimStyle_getCharProp(m_pDimStyle, StrPtr(GetCharProperty), ID)
    CheckStatus status, "CharProperty"
End Function
Private Sub SetCharProperty(NewValue As String, ID As Long)
    Dim status As Long
    
    SetOverride ID
    
    status = modSetMethods.mdlDimStyle_setCharProp(m_pDimStyle, Asc(NewValue), ID)
    CheckStatus status, "CharProperty"
End Sub
Private Function GetWeightProperty(ID As Long) As Long
    Dim status As Long
    
    status = modGetMethods.mdlDimStyle_getWeightProp(m_pDimStyle, GetWeightProperty, ID)
    CheckStatus status, "WeightProperty"
End Function
Private Sub SetWeightProperty(NewValue As Long, ID As Long)
    Dim status As Long
    
    SetOverride ID
    status = modSetMethods.mdlDimStyle_setWeightProp(m_pDimStyle, NewValue, ID)
    CheckStatus status, "WeightProperty"
End Sub
'
'' Color
'
Private Function GetColorProperty(ID As Long) As Long
    Dim status As Long
    
    status = modGetMethods.mdlDimStyle_getColorProp(m_pDimStyle, GetColorProperty, ID)
    CheckStatus status, "ColorProperty"
End Function
Private Sub SetColorProperty(NewValue As Long, ID As Long)
    Dim status As Long
    
    SetOverride ID
    status = modSetMethods.mdlDimStyle_setColorProp(m_pDimStyle, NewValue, ID)
    CheckStatus status, "ColorProperty"
End Sub

Private Function GetIntegerProperty(ID As Long) As Long
    Dim status As Long
    
    status = modGetMethods.mdlDimStyle_getIntegerProp(m_pDimStyle, GetIntegerProperty, ID)
    CheckStatus status, "GetIntegerProperty"
End Function
Private Sub SetIntegerProperty(NewValue As Long, ID As Long)
    Dim status As Long
    
    SetOverride ID
    status = modSetMethods.mdlDimStyle_setIntegerProp(m_pDimStyle, NewValue, ID)
    CheckStatus status, "SetIntegerProperty"
End Sub
Private Function GetStringProperty(ID As Long) As String
    Dim status As Long
    Dim result As String
    Dim maxChars As Long
    
    maxChars = 1024
    
    result = Space(maxChars)
    
    status = modGetMethods.mdlDimStyle_getMSWCharProp(m_pDimStyle, StrPtr(result), maxChars, ID)
    CheckStatus status, "StringProperty"
    
    If result <> "" Then  ' This test avoids exception on zero-length string
        GetStringProperty = Left$(result, InStr(1, result, vbNullChar) - 1)
    Else
        GetStringProperty = ""
    End If
End Function
Private Sub SetStringProperty(NewValue As String, ID As Long)
    Dim status As Long
    
    SetOverride ID
    status = modSetMethods.mdlDimStyle_setMSWCharProp(m_pDimStyle, StrPtr(NewValue), ID)
    CheckStatus status, "StringProperty"
End Sub
'
'   Public Methods
'   ====== =======
'
Sub CopyFromElement(ele As element)
    Dim status As Long
    
    '  Verify that this is a dimension element
    If ele.Type <> msdElementTypeDimension Then Err.Raise &H80040005, "CopyFromElement", "The element is not a dimension element"
    
    '  Use MDL to copy the text style from the element to the allocated data structure
    status = modElementAccess.mdlDimStyle_setFromDimension(m_pDimStyle, modElmdscr.GetMSElementFromElement(ele))
    
    ClearOverrides ' Clear existing override masks

    mdlDimStylePropMask_create m_overridesWorking
    mdlDim_getOverrides m_overridesWorking, modElmdscr.GetMSElementFromElement(ele)
    

    mdlDimStylePropMask_create m_overridesFinal
    mdlDim_getOverrides m_overridesFinal, modElmdscr.GetMSElementFromElement(ele)
    
    If status <> 0 Then Err.Raise &H80040005, "CopyFromElement", "MDL Error"
End Sub
Sub CopyToElement(ele As element)
    Dim status As Long
    Dim elDescr As Long
    Dim oModel As Long
    
    '  Verify that this is a dimension element
    If ele.Type <> msdElementTypeDimension Then Err.Raise &H80040005, "CopyToElement", "The element is not a dimension element"
    
    oModel = ele.ModelReference.MdlModelRefP
    '
    '  Assign the element descriptor to a long and detach the desciptor from the element. Often it
    '  is sufficient to just pass the value of MdlElementDescrP without detaching it from the Element object,
    '  but that does not work in this case because either mdlDim_applyDimStyle or mdlDim_setOverrides
    '  may replace the element descriptor. Therefore, we pass True telling to detach the element
    '  descriptor from the element.  After calling the MDL functions that may reallocate the
    '  element descriptor, we call MdlSetElementDescrP to associate the possibly changed element
    '  descriptor with the Element object.
    '
    elDescr = ele.MdlElementDescrP(True)
    
    If m_overridesWorking Then
        mdlDim_setOverrides elDescr, m_overridesWorking, oModel
    End If
    
    status = mdlDim_applyDimStyle(elDescr, m_pDimStyle, oModel)
    
    If m_overridesFinal Then
        mdlDim_setOverrides elDescr, m_overridesFinal, oModel
    End If
    
    If status <> 0 Then Err.Raise &H80040005, "CopyToElement", "MDL Error from mdlDim_applyDimStyle"
    
    ele.MdlSetElementDescrP elDescr
End Sub
Sub CopyFromActiveStyle()
    Dim tcbDimensionStyle As Long
    
    tcbDimensionStyle = modUtility.mdlDimStyle_getActive
    
    ClearOverrides
    '  Copy the TCB style to the class's copy
    modUtility.mdlDimStyle_copy m_pDimStyle, tcbDimensionStyle
End Sub
Sub CopyToActiveStyle()
    modUtility.mdlDimStyle_setActive m_pDimStyle
End Sub
Sub CopyFromFile(strName As String, IncludeDGNLIBs As Boolean)
    Dim status As Long
    Dim searchType As Long
    
    If IncludeDGNLIBs Then
        searchType = 1
    Else
        searchType = 2
    End If
    
    ClearOverrides
    status = modUtility.mdlDimStyle_getByName(m_pDimStyle, StrPtr(strName), _
                                ActiveModelReference.MdlModelRefP, searchType)
                                
    If status <> 0 Then Err.Raise &H80040005, "CopyFromFile", "MDL Error"
End Sub
Sub CopyToFile()
    Dim status As Long
    Dim strName As String
    Dim lMdlModelRef As Long
    
    lMdlModelRef = modUtility.mdlDimStyle_getModelRef(m_pDimStyle)
    ' Try to add it.  If it is a duplicate name, it will fail
    status = modUtility.mdlDimStyle_add(m_pDimStyle, lMdlModelRef)
    If status <> 0 Then
        '  Not able to add.  Try replacing an existing style
        status = modUtility.mdlDimStyle_replace(m_pDimStyle, StrPtr(strName), lMdlModelRef)
        If status <> 0 Then Err.Raise &H80040005, "CopyToFile", "Could not save or add style"
    End If
End Sub
'
'
'   Public Properties
'   ====== ==========
'
'

Property Get EnableDimWithLeader() As Boolean
    EnableDimWithLeader = GetBooleanProperty(DIMSTYLE_PROP_BallAndChain_IsActive_BOOLINT)
End Property
    
Property Let EnableDimWithLeader(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_BallAndChain_IsActive_BOOLINT)
End Property

Property Get DisplayInlineLeader() As Boolean
    DisplayInlineLeader = GetBooleanProperty(DIMSTYLE_PROP_BallAndChain_ShowTextLeader_BOOLINT)
End Property
    
Property Let DisplayInlineLeader(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_BallAndChain_ShowTextLeader_BOOLINT)
End Property

Property Get UndockTextOnDimensionLine() As Boolean
    UndockTextOnDimensionLine = GetBooleanProperty(DIMSTYLE_PROP_BallAndChain_NoDockOnDimLine_BOOLINT)
End Property
    
Property Let UndockTextOnDimensionLine(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_BallAndChain_NoDockOnDimLine_BOOLINT)
End Property

Property Get JoinExtensionLines() As Boolean
    JoinExtensionLines = GetBooleanProperty(DIMSTYLE_PROP_ExtensionLine_Join_BOOLINT)
End Property
    
Property Let JoinExtensionLines(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_Join_BOOLINT)
End Property

Property Get OverrideExtensionLineColor() As Boolean
    OverrideExtensionLineColor = GetBooleanProperty(DIMSTYLE_PROP_ExtensionLine_OverrideColor_BOOLINT)
End Property
    
Property Let OverrideExtensionLineColor(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_OverrideColor_BOOLINT)
End Property

Property Get OverrideExtensionLineStyle() As Boolean
    OverrideExtensionLineStyle = GetBooleanProperty(DIMSTYLE_PROP_ExtensionLine_OverrideLineStyle_BOOLINT)
End Property
    
Property Let OverrideExtensionLineStyle(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_OverrideLineStyle_BOOLINT)
End Property

Property Get OverrideExtensionLineWeight() As Boolean
    OverrideExtensionLineWeight = GetBooleanProperty(DIMSTYLE_PROP_ExtensionLine_OverrideWeight_BOOLINT)
End Property
    
Property Let OverrideExtensionLineWeight(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_OverrideWeight_BOOLINT)
End Property

Property Get DisplayExtensionLines() As Boolean
    DisplayExtensionLines = GetBooleanProperty(DIMSTYLE_PROP_ExtensionLine_ShowAny_BOOLINT)
End Property
    
Property Let DisplayExtensionLines(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_ShowAny_BOOLINT)
End Property

Property Get OverrideLevelSymbology() As Boolean
    OverrideLevelSymbology = GetBooleanProperty(DIMSTYLE_PROP_General_IgnoreLevelSymbology_BOOLINT)
End Property
    
Property Let OverrideLevelSymbology(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_General_IgnoreLevelSymbology_BOOLINT)
End Property

Property Get OverrideOverallColor() As Boolean
    OverrideOverallColor = GetBooleanProperty(DIMSTYLE_PROP_General_OverrideColor_BOOLINT)
End Property
    
Property Let OverrideOverallColor(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_General_OverrideColor_BOOLINT)
End Property

Property Get OverrideOverallLineStyle() As Boolean
    OverrideOverallLineStyle = GetBooleanProperty(DIMSTYLE_PROP_General_OverrideLineStyle_BOOLINT)
End Property
    
Property Let OverrideOverallLineStyle(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_General_OverrideLineStyle_BOOLINT)
End Property

Property Get OverrideOverallWeight() As Boolean
    OverrideOverallWeight = GetBooleanProperty(DIMSTYLE_PROP_General_OverrideWeight_BOOLINT)
End Property
    
Property Let OverrideOverallWeight(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_General_OverrideWeight_BOOLINT)
End Property

Property Get RelativeDimensionLine() As Boolean
    RelativeDimensionLine = GetBooleanProperty(DIMSTYLE_PROP_General_RelativeDimLine_BOOLINT)
End Property
    
Property Let RelativeDimensionLine(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_General_RelativeDimLine_BOOLINT)
End Property

Property Get DisplayNoteInlineLeader() As Boolean
    DisplayNoteInlineLeader = GetBooleanProperty(DIMSTYLE_PROP_MLNote_ShowLeader_BOOLINT)
End Property
    
Property Let DisplayNoteInlineLeader(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_MLNote_ShowLeader_BOOLINT)
End Property

Property Get NoteLeaderType() As Boolean
    NoteLeaderType = GetBooleanProperty(DIMSTYLE_PROP_MLNote_LeaderType_BOOLINT)
End Property
    
Property Let NoteLeaderType(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_MLNote_LeaderType_BOOLINT)
End Property

Property Get DropDimensionsOnPlacement() As Boolean
    DropDimensionsOnPlacement = GetBooleanProperty(DIMSTYLE_PROP_Placement_CompatibleV3_BOOLINT)
End Property
    
Property Let DropDimensionsOnPlacement(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Placement_CompatibleV3_BOOLINT)
End Property

Property Get OverrideLevel() As Boolean
    OverrideLevel = GetBooleanProperty(DIMSTYLE_PROP_Placement_OverrideLevel_BOOLINT)
End Property
    
Property Let OverrideLevel(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Placement_OverrideLevel_BOOLINT)
End Property

Property Get UseReferenceScale() As Boolean
    UseReferenceScale = GetBooleanProperty(DIMSTYLE_PROP_Placement_UseReferenceScale_BOOLINT)
End Property
    
Property Let UseReferenceScale(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Placement_UseReferenceScale_BOOLINT)
End Property

Property Get OverrideAnnotationScale() As Boolean
    OverrideAnnotationScale = GetBooleanProperty(DIMSTYLE_PROP_Placement_NotUseModelAnnotationScale_BOOLINT)
End Property
    
Property Let OverrideAnnotationScale(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Placement_NotUseModelAnnotationScale_BOOLINT)
End Property

Property Get NoLineThroughArrowTerminator() As Boolean
    NoLineThroughArrowTerminator = GetBooleanProperty(DIMSTYLE_PROP_Terminator_NoLineThruArrow_BOOLINT)
End Property
    
Property Let NoLineThroughArrowTerminator(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_NoLineThruArrow_BOOLINT)
End Property

Property Get NoLineThroughDotTerminator() As Boolean
    NoLineThroughDotTerminator = GetBooleanProperty(DIMSTYLE_PROP_Terminator_NoLineThruDot_BOOLINT)
End Property
    
Property Let NoLineThroughDotTerminator(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_NoLineThruDot_BOOLINT)
End Property

Property Get NoLineThroughOriginTerminator() As Boolean
    NoLineThroughOriginTerminator = GetBooleanProperty(DIMSTYLE_PROP_Terminator_NoLineThruOrigin_BOOLINT)
End Property
    
Property Let NoLineThroughOriginTerminator(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_NoLineThruOrigin_BOOLINT)
End Property

Property Get NoLineThroughStrokeTerminator() As Boolean
    NoLineThroughStrokeTerminator = GetBooleanProperty(DIMSTYLE_PROP_Terminator_NoLineThruStroke_BOOLINT)
End Property
    
Property Let NoLineThroughStrokeTerminator(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_NoLineThruStroke_BOOLINT)
End Property

Property Get OverrideTerminatorColor() As Boolean
    OverrideTerminatorColor = GetBooleanProperty(DIMSTYLE_PROP_Terminator_OverrideColor_BOOLINT)
End Property
    
Property Let OverrideTerminatorColor(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_OverrideColor_BOOLINT)
End Property

Property Get OverrideTerminatorLinestyle() As Boolean
    OverrideTerminatorLinestyle = GetBooleanProperty(DIMSTYLE_PROP_Terminator_OverrideLineStyle_BOOLINT)
End Property
    
Property Let OverrideTerminatorLinestyle(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_OverrideLineStyle_BOOLINT)
End Property

Property Get OverrideTerminatorWeight() As Boolean
    OverrideTerminatorWeight = GetBooleanProperty(DIMSTYLE_PROP_Terminator_OverrideWeight_BOOLINT)
End Property
    
Property Let OverrideTerminatorWeight(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Terminator_OverrideWeight_BOOLINT)
End Property

Property Get AdjustDimensionLine() As Boolean
    AdjustDimensionLine = GetBooleanProperty(DIMSTYLE_PROP_Text_AutoLift_BOOLINT)
End Property
    
Property Let AdjustDimensionLine(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_AutoLift_BOOLINT)
End Property

Property Get DecimalComma() As Boolean
    DecimalComma = GetBooleanProperty(DIMSTYLE_PROP_Text_DecimalComma_BOOLINT)
End Property
    
Property Let DecimalComma(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_DecimalComma_BOOLINT)
End Property

Property Get OverrideFont() As Boolean
    OverrideFont = GetBooleanProperty(DIMSTYLE_PROP_Text_Font_BOOLINT)
End Property
    
Property Let OverrideFont(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_Font_BOOLINT)
End Property

Property Get TextOrientation() As Boolean
    TextOrientation = GetBooleanProperty(DIMSTYLE_PROP_Text_Horizontal_BOOLINT)
End Property
    
Property Let TextOrientation(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_Horizontal_BOOLINT)
End Property

Property Get PrimaryLeadingZero() As Boolean
    PrimaryLeadingZero = GetBooleanProperty(DIMSTYLE_PROP_Text_LeadingZero_BOOLINT)
End Property
    
Property Let PrimaryLeadingZero(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_LeadingZero_BOOLINT)
End Property

Property Get SecondaryLeadingZero() As Boolean
    SecondaryLeadingZero = GetBooleanProperty(DIMSTYLE_PROP_Text_SecLeadingZero_BOOLINT)
End Property
    
Property Let SecondaryLeadingZero(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_SecLeadingZero_BOOLINT)
End Property

Property Get OmitLeadingDelimiter() As Boolean
    OmitLeadingDelimiter = GetBooleanProperty(DIMSTYLE_PROP_Text_OmitLeadingDelimiter_BOOLINT)
End Property
    
Property Let OmitLeadingDelimiter(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OmitLeadingDelimiter_BOOLINT)
End Property

Property Get OverrideTextColor() As Boolean
    OverrideTextColor = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideColor_BOOLINT)
End Property
    
Property Let OverrideTextColor(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideColor_BOOLINT)
End Property

Property Get OverrideTextHeight() As Boolean
    OverrideTextHeight = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideHeight_BOOLINT)
End Property
    
Property Let OverrideTextHeight(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideHeight_BOOLINT)
End Property

Property Get OverrideTextWidth() As Boolean
    OverrideTextWidth = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideWidth_BOOLINT)
End Property
    
Property Let OverrideTextWidth(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideWidth_BOOLINT)
End Property

Property Get OverrideTextWeight() As Boolean
    OverrideTextWeight = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideWeight_BOOLINT)
End Property
    
Property Let OverrideTextWeight(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideWeight_BOOLINT)
End Property

Property Get ShowSecondaryText() As Boolean
    ShowSecondaryText = GetBooleanProperty(DIMSTYLE_PROP_Text_ShowSecondary_BOOLINT)
End Property
    
Property Let ShowSecondaryText(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_ShowSecondary_BOOLINT)
End Property

Property Get OverrideUnderlineText() As Boolean
    OverrideUnderlineText = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideUnderline_BOOLINT)
End Property
    
Property Let OverrideUnderlineText(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideUnderline_BOOLINT)
End Property

Property Get UnderlineText() As Boolean
    UnderlineText = GetBooleanProperty(DIMSTYLE_PROP_Text_Underline_BOOLINT)
End Property
    
Property Let UnderlineText(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_Underline_BOOLINT)
End Property

Property Get OverrideEnableStackedFractions() As Boolean
    OverrideEnableStackedFractions = GetBooleanProperty(DIMSTYLE_PROP_Text_OverrideStackedFractions_BOOLINT)
End Property
    
Property Let OverrideEnableStackedFractions(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_OverrideStackedFractions_BOOLINT)
End Property

Property Get EnableStackedFractions() As Boolean
    EnableStackedFractions = GetBooleanProperty(DIMSTYLE_PROP_Text_StackedFractions_BOOLINT)
End Property
    
Property Let EnableStackedFractions(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Text_StackedFractions_BOOLINT)
End Property

Property Get ToleranceType() As Boolean
    ToleranceType = GetBooleanProperty(DIMSTYLE_PROP_Tolerance_Mode_BOOLINT)
End Property
    
Property Let ToleranceType(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Tolerance_Mode_BOOLINT)
End Property

Property Get EnableTolerance() As Boolean
    EnableTolerance = GetBooleanProperty(DIMSTYLE_PROP_Tolerance_Show_BOOLINT)
End Property
    
Property Let EnableTolerance(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Tolerance_Show_BOOLINT)
End Property

Property Get StackToleranceIfEqual() As Boolean
    StackToleranceIfEqual = GetBooleanProperty(DIMSTYLE_PROP_Tolerance_StackEqual_BOOLINT)
End Property
    
Property Let StackToleranceIfEqual(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Tolerance_StackEqual_BOOLINT)
End Property

Property Get EnablePrimaryAlternateFormat() As Boolean
    EnablePrimaryAlternateFormat = GetBooleanProperty(DIMSTYLE_PROP_Value_AltIsActive_BOOLINT)
End Property
    
Property Let EnablePrimaryAlternateFormat(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltIsActive_BOOLINT)
End Property

Property Get EnableSecondaryAlternateFormat() As Boolean
    EnableSecondaryAlternateFormat = GetBooleanProperty(DIMSTYLE_PROP_Value_AltSecIsActive_BOOLINT)
End Property
    
Property Let EnableSecondaryAlternateFormat(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltSecIsActive_BOOLINT)
End Property

Property Get ShowZeroMasterUnitsInPrimaryAltFormat() As Boolean
    ShowZeroMasterUnitsInPrimaryAltFormat = GetBooleanProperty(DIMSTYLE_PROP_Value_AltShowZeroMasterUnit_BOOLINT)
End Property
    
Property Let ShowZeroMasterUnitsInPrimaryAltFormat(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltShowZeroMasterUnit_BOOLINT)
End Property

Property Get ShowZeroMasterUnitsInSecondaryAltFormat() As Boolean
    ShowZeroMasterUnitsInSecondaryAltFormat = GetBooleanProperty(DIMSTYLE_PROP_Value_AltSecShowZeroMasterUnit_BOOLINT)
End Property
    
Property Let ShowZeroMasterUnitsInSecondaryAltFormat(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltSecShowZeroMasterUnit_BOOLINT)
End Property

Property Get DisplayAngleLeadingZero() As Boolean
    DisplayAngleLeadingZero = GetBooleanProperty(DIMSTYLE_PROP_Value_AngleLeadingZero_BOOLINT)
End Property
    
Property Let DisplayAngleLeadingZero(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AngleLeadingZero_BOOLINT)
End Property

Property Get DisplayAngleTrailingZeros() As Boolean
    DisplayAngleTrailingZeros = GetBooleanProperty(DIMSTYLE_PROP_Value_AngleTrailingZeros_BOOLINT)
End Property
    
Property Let DisplayAngleTrailingZeros(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AngleTrailingZeros_BOOLINT)
End Property

Property Get AngleMeasure() As Boolean
    AngleMeasure = GetBooleanProperty(DIMSTYLE_PROP_Value_AngleMeasure_BOOLINT)
End Property
    
Property Let AngleMeasure(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AngleMeasure_BOOLINT)
End Property

Property Get RoundLeastSignificantDecimal() As Boolean
    RoundLeastSignificantDecimal = GetBooleanProperty(DIMSTYLE_PROP_Value_RoundLSD_BOOLINT)
End Property
    
Property Let RoundLeastSignificantDecimal(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_RoundLSD_BOOLINT)
End Property

Property Get ShowSecondaryTrailingZeros() As Boolean
    ShowSecondaryTrailingZeros = GetBooleanProperty(DIMSTYLE_PROP_Value_SecShowTrailingZeros_BOOLINT)
End Property
    
Property Let ShowSecondaryTrailingZeros(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_SecShowTrailingZeros_BOOLINT)
End Property

Property Get ShowPrimaryZeroMasterUnit() As Boolean
    ShowPrimaryZeroMasterUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_SecShowZeroMasterUnit_BOOLINT)
End Property
    
Property Let ShowPrimaryZeroMasterUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_SecShowZeroMasterUnit_BOOLINT)
End Property

Property Get ShowPrimaryTrailingZeros() As Boolean
    ShowPrimaryTrailingZeros = GetBooleanProperty(DIMSTYLE_PROP_Value_ShowTrailingZeros_BOOLINT)
End Property
    
Property Let ShowPrimaryTrailingZeros(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_ShowTrailingZeros_BOOLINT)
End Property

Property Get ShowSecondaryZeroMasterUnit() As Boolean
    ShowSecondaryZeroMasterUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_ShowZeroMasterUnit_BOOLINT)
End Property
    
Property Let ShowSecondaryZeroMasterUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_ShowZeroMasterUnit_BOOLINT)
End Property

Property Get RetainPrimaryFractionalAccuracy() As Boolean
    RetainPrimaryFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceFraction_BOOLINT)
End Property
    
Property Let RetainPrimaryFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceFraction_BOOLINT)
End Property

Property Get RetainPrimaryAlternateFractionalAccuracy() As Boolean
    RetainPrimaryAlternateFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceAltFraction_BOOLINT)
End Property
    
Property Let RetainPrimaryAlternateFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceAltFraction_BOOLINT)
End Property

Property Get RetainPrimaryToleranceFractionalAccuracy() As Boolean
    RetainPrimaryToleranceFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceTolFraction_BOOLINT)
End Property
    
Property Let RetainPrimaryToleranceFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceTolFraction_BOOLINT)
End Property

Property Get SuperscriptLeastSignificantDecimal() As Boolean
    SuperscriptLeastSignificantDecimal = GetBooleanProperty(DIMSTYLE_PROP_Value_SuperscriptLSD_BOOLINT)
End Property
    
Property Let SuperscriptLeastSignificantDecimal(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_SuperscriptLSD_BOOLINT)
End Property

Property Get UseWorkingUnitsForPrimaryText() As Boolean
    UseWorkingUnitsForPrimaryText = GetBooleanProperty(DIMSTYLE_PROP_Value_UseWorkingUnits_BOOLINT)
End Property
    
Property Let UseWorkingUnitsForPrimaryText(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_UseWorkingUnits_BOOLINT)
End Property

Property Get ReverseDecrementOrdinate() As Boolean
    ReverseDecrementOrdinate = GetBooleanProperty(DIMSTYLE_PROP_Value_OrdDecrementReverse_BOOLINT)
End Property
    
Property Let ReverseDecrementOrdinate(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_OrdDecrementReverse_BOOLINT)
End Property

Property Get UseOrdinateDatumValue() As Boolean
    UseOrdinateDatumValue = GetBooleanProperty(DIMSTYLE_PROP_Value_OrdUseDatumValue_BOOLINT)
End Property
    
Property Let UseOrdinateDatumValue(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_OrdUseDatumValue_BOOLINT)
End Property

Property Get RetainSecondaryFractionalAccuracy() As Boolean
    RetainSecondaryFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceSecFraction_BOOLINT)
End Property
    
Property Let RetainSecondaryFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceSecFraction_BOOLINT)
End Property

Property Get RetainSecondaryAlternateFractionalAccuracy() As Boolean
    RetainSecondaryAlternateFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceAltSecFraction_BOOLINT)
End Property
    
Property Let RetainSecondaryAlternateFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceAltSecFraction_BOOLINT)
End Property

Property Get RetainSecondaryToleranceFractionalAccuracy() As Boolean
    RetainSecondaryToleranceFractionalAccuracy = GetBooleanProperty(DIMSTYLE_PROP_Value_NoReduceTolSecFraction_BOOLINT)
End Property
    
Property Let RetainSecondaryToleranceFractionalAccuracy(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_NoReduceTolSecFraction_BOOLINT)
End Property

Property Get OrdinateFreeLocation() As Boolean
    OrdinateFreeLocation = GetBooleanProperty(DIMSTYLE_PROP_Value_OrdFreeLocation_BOOLINT)
End Property
    
Property Let OrdinateFreeLocation(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_OrdFreeLocation_BOOLINT)
End Property

Property Get DisplayPrimaryZeroSubUnit() As Boolean
    DisplayPrimaryZeroSubUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_ShowZeroSubUnit_BOOLINT)
End Property
    
Property Let DisplayPrimaryZeroSubUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_ShowZeroSubUnit_BOOLINT)
End Property

Property Get DisplayPrimaryAlternateZeroSubUnit() As Boolean
    DisplayPrimaryAlternateZeroSubUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_AltShowZeroSubUnit_BOOLINT)
End Property
    
Property Let DisplayPrimaryAlternateZeroSubUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltShowZeroSubUnit_BOOLINT)
End Property

Property Get DisplaySecondaryZeroSubUnit() As Boolean
    DisplaySecondaryZeroSubUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_SecShowZeroSubUnit_BOOLINT)
End Property
    
Property Let DisplaySecondaryZeroSubUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_SecShowZeroSubUnit_BOOLINT)
End Property

Property Get DisplaySecondaryAlternateZeroSubUnit() As Boolean
    DisplaySecondaryAlternateZeroSubUnit = GetBooleanProperty(DIMSTYLE_PROP_Value_AltSecShowZeroSubUnit_BOOLINT)
End Property

Property Let DisplaySecondaryAlternateZeroSubUnit(NewValue As Boolean)
    Call SetBooleanProperty(NewValue, DIMSTYLE_PROP_Value_AltSecShowZeroSubUnit_BOOLINT)
End Property

'
''   String Properties
'

Property Get Name() As String
    Name = GetStringProperty(DIMSTYLE_PROP_General_DimStyleName_MSWCHAR)
End Property
    
Property Let Name(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_General_DimStyleName_MSWCHAR)
End Property

Property Get Description() As String
    Description = GetStringProperty(DIMSTYLE_PROP_General_DimStyleDescription_MSWCHAR)
End Property
    
Property Let Description(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_General_DimStyleDescription_MSWCHAR)
End Property

Property Get PrefixSymbolCellName() As String
    PrefixSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Symbol_PrefixCellName_MSWCHAR)
End Property
    
Property Let PrefixSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Symbol_PrefixCellName_MSWCHAR)
End Property

Property Get SuffixSymbolCellName() As String
    SuffixSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Symbol_SuffixCellName_MSWCHAR)
End Property
    
Property Let SuffixSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Symbol_SuffixCellName_MSWCHAR)
End Property

Property Get ArrowSymbolCellName() As String
    ArrowSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Terminator_ArrowCellName_MSWCHAR)
End Property
    
Property Let ArrowSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Terminator_ArrowCellName_MSWCHAR)
End Property

Property Get DotSymbolCellName() As String
    DotSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Terminator_DotCellName_MSWCHAR)
End Property
    
Property Let DotSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Terminator_DotCellName_MSWCHAR)
End Property

Property Get OriginSymbolCellName() As String
    OriginSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Terminator_OriginCellName_MSWCHAR)
End Property
    
Property Let OriginSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Terminator_OriginCellName_MSWCHAR)
End Property

Property Get StrokeSymbolCellName() As String
    StrokeSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Terminator_StrokeCellName_MSWCHAR)
End Property
    
Property Let StrokeSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Terminator_StrokeCellName_MSWCHAR)
End Property

Property Get NoteSymbolCellName() As String
    NoteSymbolCellName = GetStringProperty(DIMSTYLE_PROP_Terminator_NoteCellName_MSWCHAR)
End Property
    
Property Let NoteSymbolCellName(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Terminator_NoteCellName_MSWCHAR)
End Property

Property Get PrimaryMasterUnitLabel() As String
    PrimaryMasterUnitLabel = GetStringProperty(DIMSTYLE_PROP_Value_UnitLabelMaster_MSWCHAR)
End Property
    
Property Let PrimaryMasterUnitLabel(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Value_UnitLabelMaster_MSWCHAR)
End Property

Property Get PrimarySubUnitLabel() As String
    PrimarySubUnitLabel = GetStringProperty(DIMSTYLE_PROP_Value_UnitLabelSub_MSWCHAR)
End Property
    
Property Let PrimarySubUnitLabel(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Value_UnitLabelSub_MSWCHAR)
End Property

Property Get SecondaryMasterUnitLabel() As String
    SecondaryMasterUnitLabel = GetStringProperty(DIMSTYLE_PROP_Value_UnitLabelSecMaster_MSWCHAR)
End Property
    
Property Let SecondaryMasterUnitLabel(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Value_UnitLabelSecMaster_MSWCHAR)
End Property

Property Get SecondarySubUnitLabel() As String
    SecondarySubUnitLabel = GetStringProperty(DIMSTYLE_PROP_Value_UnitLabelSecSub_MSWCHAR)
End Property
    
Property Let SecondarySubUnitLabel(NewValue As String)
    Call SetStringProperty(NewValue, DIMSTYLE_PROP_Value_UnitLabelSecSub_MSWCHAR)
End Property

Property Get OverallFont() As Font
    Set OverallFont = GetFontProperty(DIMSTYLE_PROP_General_Font_FONT)
End Property
    
Property Set OverallFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_General_Font_FONT)
End Property

Property Get PrefixFont() As Font
    Set PrefixFont = GetFontProperty(DIMSTYLE_PROP_Symbol_PrefixFont_FONT)
End Property
    
Property Set PrefixFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Symbol_PrefixFont_FONT)
End Property

Property Get SuffixFont() As Font
    Set SuffixFont = GetFontProperty(DIMSTYLE_PROP_Symbol_SuffixFont_FONT)
End Property
    
Property Set SuffixFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Symbol_SuffixFont_FONT)
End Property

Property Get DiameterFont() As Font
    Set DiameterFont = GetFontProperty(DIMSTYLE_PROP_Symbol_DiameterFont_FONT)
End Property
    
Property Set DiameterFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Symbol_DiameterFont_FONT)
End Property

Property Get ArrowTerminatorFont() As Font
    Set ArrowTerminatorFont = GetFontProperty(DIMSTYLE_PROP_Terminator_ArrowFont_FONT)
End Property
    
Property Set ArrowTerminatorFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Terminator_ArrowFont_FONT)
End Property

Property Get DotTerminatorFont() As Font
    Set DotTerminatorFont = GetFontProperty(DIMSTYLE_PROP_Terminator_DotFont_FONT)
End Property
    
Property Set DotTerminatorFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Terminator_DotFont_FONT)
End Property

Property Get OriginTerminatorFont() As Font
    Set OriginTerminatorFont = GetFontProperty(DIMSTYLE_PROP_Terminator_OriginFont_FONT)
End Property
    
Property Set OriginTerminatorFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Terminator_OriginFont_FONT)
End Property

Property Get StrokeTerminatorFont() As Font
    Set StrokeTerminatorFont = GetFontProperty(DIMSTYLE_PROP_Terminator_StrokeFont_FONT)
End Property
    
Property Set StrokeTerminatorFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Terminator_StrokeFont_FONT)
End Property

Property Get NoteTerminatorFont() As Font
    Set NoteTerminatorFont = GetFontProperty(DIMSTYLE_PROP_Terminator_NoteFont_FONT)
End Property
    
Property Set NoteTerminatorFont(NewValue As Font)
    Call SetFontProperty(NewValue, DIMSTYLE_PROP_Terminator_NoteFont_FONT)
End Property

Property Get AnnotationScale() As Double
    AnnotationScale = GetDoubleProperty(DIMSTYLE_PROP_Placement_AnnotationScale_DOUBLE)
End Property
    
Property Let AnnotationScale(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Placement_AnnotationScale_DOUBLE)
End Property

Property Get NoteInlineLeaderLength() As Double
    NoteInlineLeaderLength = GetDoubleProperty(DIMSTYLE_PROP_MLNote_ElbowLength_DOUBLE)
End Property
    
Property Let NoteInlineLeaderLength(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_MLNote_ElbowLength_DOUBLE)
End Property

Property Get ExtensionLineExtend() As Double
    ExtensionLineExtend = GetDoubleProperty(DIMSTYLE_PROP_ExtensionLine_Extend_DOUBLE)
End Property
    
Property Let ExtensionLineExtend(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_Extend_DOUBLE)
End Property

Property Get ExtensionLineOffset() As Double
    ExtensionLineOffset = GetDoubleProperty(DIMSTYLE_PROP_ExtensionLine_Offset_DOUBLE)
End Property
    
Property Let ExtensionLineOffset(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_Offset_DOUBLE)
End Property

Property Get CenterMarkSize() As Double
    CenterMarkSize = GetDoubleProperty(DIMSTYLE_PROP_General_CenterMarkSize_DOUBLE)
End Property
    
Property Let CenterMarkSize(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_General_CenterMarkSize_DOUBLE)
End Property

Property Get DistanceScale() As Double
    DistanceScale = GetDoubleProperty(DIMSTYLE_PROP_General_DimensionScale_DOUBLE)
End Property
    
Property Let DistanceScale(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_General_DimensionScale_DOUBLE)
End Property

Property Get StackOffset() As Double
    StackOffset = GetDoubleProperty(DIMSTYLE_PROP_General_StackOffset_DOUBLE)
End Property
    
Property Let StackOffset(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_General_StackOffset_DOUBLE)
End Property

Property Get NoteLeftMargin() As Double
    NoteLeftMargin = GetDoubleProperty(DIMSTYLE_PROP_MLNote_LeftMargin_DOUBLE)
End Property
    
Property Let NoteLeftMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_MLNote_LeftMargin_DOUBLE)
End Property

Property Get NoteLowerMargin() As Double
    NoteLowerMargin = GetDoubleProperty(DIMSTYLE_PROP_MLNote_LowerMargin_DOUBLE)
End Property
    
Property Let NoteLowerMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_MLNote_LowerMargin_DOUBLE)
End Property

Property Get TerminatorHeight() As Double
    TerminatorHeight = GetDoubleProperty(DIMSTYLE_PROP_Terminator_Height_DOUBLE)
End Property
    
Property Let TerminatorHeight(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Terminator_Height_DOUBLE)
End Property

Property Get TerminatorWidth() As Double
    TerminatorWidth = GetDoubleProperty(DIMSTYLE_PROP_Terminator_Width_DOUBLE)
End Property
    
Property Let TerminatorWidth(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Terminator_Width_DOUBLE)
End Property

Property Get MinLeader() As Double
    MinLeader = GetDoubleProperty(DIMSTYLE_PROP_Terminator_MinLeader_DOUBLE)
End Property
    
Property Let MinLeader(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Terminator_MinLeader_DOUBLE)
End Property

Property Get TextHeight() As Double
    TextHeight = GetDoubleProperty(DIMSTYLE_PROP_Text_Height_DOUBLE)
End Property
    
Property Let TextHeight(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Text_Height_DOUBLE)
End Property

Property Get TextWidth() As Double
    TextWidth = GetDoubleProperty(DIMSTYLE_PROP_Text_Width_DOUBLE)
End Property
    
Property Let TextWidth(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Text_Width_DOUBLE)
End Property

Property Get LeftMargin() As Double
    LeftMargin = GetDoubleProperty(DIMSTYLE_PROP_Text_HorizontalMargin_DOUBLE)
End Property
    
Property Let LeftMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Text_HorizontalMargin_DOUBLE)
End Property

Property Get LowerMargin() As Double
    LowerMargin = GetDoubleProperty(DIMSTYLE_PROP_Text_VerticalMargin_DOUBLE)
End Property
    
Property Let LowerMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Text_VerticalMargin_DOUBLE)
End Property

Property Get StackedFractionScale() As Double
    StackedFractionScale = GetDoubleProperty(DIMSTYLE_PROP_Text_StackedFractionScale_DOUBLE)
End Property
    
Property Let StackedFractionScale(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Text_StackedFractionScale_DOUBLE)
End Property

Property Get LowerTolerance() As Double
    LowerTolerance = GetDoubleProperty(DIMSTYLE_PROP_Tolerance_LowerValue_DOUBLE)
End Property
    
Property Let LowerTolerance(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Tolerance_LowerValue_DOUBLE)
End Property

Property Get UpperTolerance() As Double
    UpperTolerance = GetDoubleProperty(DIMSTYLE_PROP_Tolerance_UpperValue_DOUBLE)
End Property
    
Property Let UpperTolerance(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Tolerance_UpperValue_DOUBLE)
End Property

Property Get ToleranceTextLeftMargin() As Double
    ToleranceTextLeftMargin = GetDoubleProperty(DIMSTYLE_PROP_Tolerance_TextHorizontalMargin_DOUBLE)
End Property
    
Property Let ToleranceTextLeftMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Tolerance_TextHorizontalMargin_DOUBLE)
End Property

Property Get ToleranceTextSeparationMargin() As Double
    ToleranceTextSeparationMargin = GetDoubleProperty(DIMSTYLE_PROP_Tolerance_TextVerticalMargin_DOUBLE)
End Property
    
Property Let ToleranceTextSeparationMargin(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Tolerance_TextVerticalMargin_DOUBLE)
End Property

Property Get ToleranceTextScale() As Double
    ToleranceTextScale = GetDoubleProperty(DIMSTYLE_PROP_Tolerance_TextScale_DOUBLE)
End Property
    
Property Let ToleranceTextScale(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Tolerance_TextScale_DOUBLE)
End Property

Property Get PrimaryAlternateThreshold() As Double
    PrimaryAlternateThreshold = GetDoubleProperty(DIMSTYLE_PROP_Value_AltThreshold_DOUBLE)
End Property
    
Property Let PrimaryAlternateThreshold(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Value_AltThreshold_DOUBLE)
End Property

Property Get SecondaryAlternateThreshold() As Double
    SecondaryAlternateThreshold = GetDoubleProperty(DIMSTYLE_PROP_Value_AltSecThreshold_DOUBLE)
End Property
    
Property Let SecondaryAlternateThreshold(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Value_AltSecThreshold_DOUBLE)
End Property

Property Get OrdinateDatum() As Double
    OrdinateDatum = GetDoubleProperty(DIMSTYLE_PROP_Value_OrdDatumValue_DOUBLE)
End Property
    
Property Let OrdinateDatum(NewValue As Double)
    Call SetDoubleProperty(NewValue, DIMSTYLE_PROP_Value_OrdDatumValue_DOUBLE)
End Property

Property Get PrefixCharSymbol() As String
    PrefixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_PrefixChar_CHAR)
End Property
    
Property Let PrefixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_PrefixChar_CHAR)
End Property

Property Get SuffixCharSymbol() As String
    SuffixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_SuffixChar_CHAR)
End Property
    
Property Let SuffixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_SuffixChar_CHAR)
End Property

Property Get DiameterCharSymbol() As String
    DiameterCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_DiameterChar_CHAR)
End Property
    
Property Let DiameterCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_DiameterChar_CHAR)
End Property

Property Get MainPrefixCharSymbol() As String
    MainPrefixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_MainPrefixChar_CHAR)
End Property
    
Property Let MainPrefixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_MainPrefixChar_CHAR)
End Property

Property Get MainSuffixCharSymbol() As String
    MainSuffixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_MainSuffixChar_CHAR)
End Property
    
Property Let MainSuffixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_MainSuffixChar_CHAR)
End Property

Property Get LowerPrefixCharSymbol() As String
    LowerPrefixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_LowerPrefixChar_CHAR)
End Property
    
Property Let LowerPrefixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_LowerPrefixChar_CHAR)
End Property

Property Get LowerSuffixCharSymbol() As String
    LowerSuffixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_LowerSuffixChar_CHAR)
End Property
    
Property Let LowerSuffixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_LowerSuffixChar_CHAR)
End Property

Property Get UpperPrefixCharSymbol() As String
    UpperPrefixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_UpperPrefixChar_CHAR)
End Property
    
Property Let UpperPrefixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_UpperPrefixChar_CHAR)
End Property

Property Get UpperSuffixCharSymbol() As String
    UpperSuffixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_UpperSuffixChar_CHAR)
End Property
    
Property Let UpperSuffixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_UpperSuffixChar_CHAR)
End Property

Property Get PlusMinusCharSymbol() As String
    PlusMinusCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_PlusMinusChar_CHAR)
End Property
    
Property Let PlusMinusCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_PlusMinusChar_CHAR)
End Property

Property Get TolerancePrefixCharSymbol() As String
    TolerancePrefixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_TolPrefixChar_CHAR)
End Property
    
Property Let TolerancePrefixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_TolPrefixChar_CHAR)
End Property

Property Get ToleranceSuffixCharSymbol() As String
    ToleranceSuffixCharSymbol = GetCharProperty(DIMSTYLE_PROP_Symbol_TolSuffixChar_CHAR)
End Property
    
Property Let ToleranceSuffixCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Symbol_TolSuffixChar_CHAR)
End Property

Property Get ArrowTerminatorCharSymbol() As String
    ArrowTerminatorCharSymbol = GetCharProperty(DIMSTYLE_PROP_Terminator_ArrowChar_CHAR)
End Property
    
Property Let ArrowTerminatorCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Terminator_ArrowChar_CHAR)
End Property

Property Get DotTerminatorCharSymbol() As String
    DotTerminatorCharSymbol = GetCharProperty(DIMSTYLE_PROP_Terminator_DotChar_CHAR)
End Property
    
Property Let DotTerminatorCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Terminator_DotChar_CHAR)
End Property

Property Get OriginTerminatorCharSymbol() As String
    OriginTerminatorCharSymbol = GetCharProperty(DIMSTYLE_PROP_Terminator_OriginChar_CHAR)
End Property
    
Property Let OriginTerminatorCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Terminator_OriginChar_CHAR)
End Property

Property Get StrokeTerminatorCharSymbol() As String
    StrokeTerminatorCharSymbol = GetCharProperty(DIMSTYLE_PROP_Terminator_StrokeChar_CHAR)
End Property
    
Property Let StrokeTerminatorCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Terminator_StrokeChar_CHAR)
End Property

Property Get NoteTerminatorCharSymbol() As String
    NoteTerminatorCharSymbol = GetCharProperty(DIMSTYLE_PROP_Terminator_NoteChar_CHAR)
End Property
    
Property Let NoteTerminatorCharSymbol(NewValue As String)
    Call SetCharProperty(NewValue, DIMSTYLE_PROP_Terminator_NoteChar_CHAR)
End Property

Property Get OverallLineWeight() As Long
    OverallLineWeight = GetWeightProperty(DIMSTYLE_PROP_General_Weight_WEIGHT)
End Property
    
Property Let OverallLineWeight(NewValue As Long)
    Call SetWeightProperty(NewValue, DIMSTYLE_PROP_General_Weight_WEIGHT)
End Property

Property Get ExtensionLineWeight() As Long
    ExtensionLineWeight = GetWeightProperty(DIMSTYLE_PROP_ExtensionLine_Weight_WEIGHT)
End Property
    
Property Let ExtensionLineWeight(NewValue As Long)
    Call SetWeightProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_Weight_WEIGHT)
End Property

Property Get TextLineWeight() As Long
    TextLineWeight = GetWeightProperty(DIMSTYLE_PROP_Text_Weight_WEIGHT)
End Property
    
Property Let TextLineWeight(NewValue As Long)
    Call SetWeightProperty(NewValue, DIMSTYLE_PROP_Text_Weight_WEIGHT)
End Property

Property Get TerminatorLineWeight() As Long
    TerminatorLineWeight = GetWeightProperty(DIMSTYLE_PROP_Terminator_Weight_WEIGHT)
End Property
    
Property Let TerminatorLineWeight(NewValue As Long)
    Call SetWeightProperty(NewValue, DIMSTYLE_PROP_Terminator_Weight_WEIGHT)
End Property

Property Get TextStyleId() As Long
    TextStyleId = GetIntegerProperty(DIMSTYLE_PROP_Text_TextStyleID_INTEGER)
End Property
    
Property Let TextStyleId(NewValue As Long)
    Call SetIntegerProperty(NewValue, DIMSTYLE_PROP_Text_TextStyleID_INTEGER)
End Property

Property Get Level() As Level
    Set Level = GetLevelProperty(DIMSTYLE_PROP_Placement_Level_LEVEL)
End Property
    
Property Set Level(NewValue As Level)
    Call SetLevelProperty(NewValue, DIMSTYLE_PROP_Placement_Level_LEVEL)
End Property

Property Get OverallLineStyle() As LineStyle
    Set OverallLineStyle = GetLineStyleProperty(DIMSTYLE_PROP_General_LineStyle_LINESTYLE)
End Property
    
Property Set OverallLineStyle(NewValue As LineStyle)
    Call SetLineStyleProperty(NewValue, DIMSTYLE_PROP_General_LineStyle_LINESTYLE)
End Property

Property Get ExtensionLineStyle() As LineStyle
    Set ExtensionLineStyle = GetLineStyleProperty(DIMSTYLE_PROP_ExtensionLine_LineStyle_LINESTYLE)
End Property
    
Property Set ExtensionLineStyle(NewValue As LineStyle)
    Call SetLineStyleProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_LineStyle_LINESTYLE)
End Property

Property Get TerminatorLineStyle() As LineStyle
    Set TerminatorLineStyle = GetLineStyleProperty(DIMSTYLE_PROP_Terminator_LineStyle_LINESTYLE)
End Property
    
Property Set TerminatorLineStyle(NewValue As LineStyle)
    Call SetLineStyleProperty(NewValue, DIMSTYLE_PROP_Terminator_LineStyle_LINESTYLE)
End Property

    
Property Get OverallColor() As Long
    OverallColor = GetColorProperty(DIMSTYLE_PROP_General_Color_COLOR)
End Property
    
Property Let OverallColor(NewValue As Long)
    Call SetColorProperty(NewValue, DIMSTYLE_PROP_General_Color_COLOR)
End Property

Property Get ExtensionLineColor() As Long
    ExtensionLineColor = GetColorProperty(DIMSTYLE_PROP_ExtensionLine_Color_COLOR)
End Property

Property Let ExtensionLineColor(NewValue As Long)
    Call SetColorProperty(NewValue, DIMSTYLE_PROP_ExtensionLine_Color_COLOR)
End Property
    
Property Let TerminatorColor(NewValue As Long)
    Call SetColorProperty(NewValue, DIMSTYLE_PROP_Terminator_Color_COLOR)
End Property

Property Get TerminatorColor() As Long
    TerminatorColor = GetColorProperty(DIMSTYLE_PROP_Terminator_Color_COLOR)
End Property
    
Property Let TextColor(NewValue As Long)
    Call SetColorProperty(NewValue, DIMSTYLE_PROP_Text_Color_COLOR)
End Property

Property Get TextColor() As Long
    TextColor = GetColorProperty(DIMSTYLE_PROP_Text_Color_COLOR)
End Property



