VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "placeTerminatorLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------
' PlaceTickCommand
'
' Status: WORKING
'
' Date: 6/07/2002
'
' This example illustrates how to place a line with a teminator.
'
' Author: BSI
'
'----------------------------------------------------------------------------
Implements IPrimitiveCommandEvents

'----------------------------------------------------------------------
'
'           Private Data Members
'
'----------------------------------------------------------------------
Private m_atPoints(0 To 1) As Point3d
Private m_nPoints As Integer
Private cname As String
Public arro As CellElement
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Cleanup
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_DataPoint
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal View As View)
If m_nPoints = 0 Then 'user has entered Startpoint of the line segment
    CommandState.StartDynamics
    m_atPoints(0) = Point
    m_nPoints = 1
    ShowPrompt "Place end point"

ElseIf m_nPoints = 1 Then 'user has entered Endpoint of the line segment
    
    Dim terminator As CellElement
    Dim RotationMatrix As Matrix3d
    Dim oLineEl As LineElement
    Dim Axis As Point3d
    Dim zangle As Double
    
    'Point to rotate about
    Axis.X = 0
    Axis.Y = 0
    Axis.Z = 1
    
    ' If check to see if the active cell was populated
    If setCell(cname) <> 0 Then
        MsgBox "Error Could not locate a cell named: " + cname
    Else
        m_atPoints(1) = Point
                      
        'Calculate angle between the two points
        zangle = Atn2((m_atPoints(1).Y - m_atPoints(0).Y), m_atPoints(1).X - m_atPoints(0).X)
        
        ' Create a rotatio matrix from the angle we just created.
        RotationMatrix = Matrix3dFromVectorAndRotationAngle(Axis, zangle)
        
        'Scale
        Axis.X = 100
        Axis.Y = 100
        Axis.Z = 100
        
        ' Create the cell
        Set arro = CreateCellElement2(cname, Point, Axis, True, RotationMatrix)
    
    ActiveModelReference.AddElement arro
    arro.Redraw
    End If
    
    'draws the line segment
    Set oLineEl = CreateLineElement1(Nothing, m_atPoints)
    ActiveModelReference.AddElement oLineEl
    oLineEl.Redraw

    'set Startpoint for next line segment to the Endpoint of the previous one
    m_atPoints(0) = m_atPoints(1)
End If
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Dynamics
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

If m_nPoints = 1 Then
    
       
    Dim terminator As CellElement
    Dim temElms(0 To 1) As Element
    Dim RotationMatrix As Matrix3d
    Dim Eltrans As Transform3d
    Dim oLineEl As LineElement
    Dim Axis As Point3d
    Dim zangle As Double
    
    'Point to rotate about
    Axis.X = 0
    Axis.Y = 0
    Axis.Z = 1
    
    ' If check to see if the active cell was populated
    If setCell(cname) <> 0 Then
        MsgBox "Error Could not locate a cell named: " + cname
    Else
        m_atPoints(1) = Point
                      
        'Calculate angle between the two points
        zangle = Atn2((m_atPoints(1).Y - m_atPoints(0).Y), m_atPoints(1).X - m_atPoints(0).X)
        
        ' Create a rotatio matrix from the angle we just created.
        RotationMatrix = Matrix3dFromVectorAndRotationAngle(Axis, zangle)
        
        'Scale
        Axis.X = 100
        Axis.Y = 100
        Axis.Z = 100
        
        ' Create the cell
        Set arro = CreateCellElement2(cname, Point, Axis, True, RotationMatrix)
        
        ' Create the line
        Set oLineEl = CreateLineElement1(Nothing, m_atPoints)
        oLineEl.Color = 5 ' color to indicate its a temporary display
            
        ' Draw the elements
        oLineEl.Redraw DrawMode
        arro.Redraw DrawMode
        
      End If
End If
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Keyin
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Keyin(ByVal KeyIn As String)

End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Reset
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Reset()
' method called when the reset event occurs

' On reset, start the command again.
CommandState.StartPrimitive Me
m_nPoints = 0
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Start
'
'   author      BSI                                             06/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Start()
'method called at the start of the command
cname = "LT7"

'Attach a cell library
AttachCellLibrary ("linepa.cel")

ShowCommand "VBA Place Terminator Line"
ShowPrompt "Select start of line"
End Sub

