VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "selectElementCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Accept
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_Accept(ByVal element As element, Point As Point3d, ByVal View As View)

    If processSwitch = "BringToFront" Then
        Call reCreateElement(element)
    End If
    
    If processSwitch = "SendToBack" Then
        Call SendElmToBack(element)
        CadInputQueue.SendCommand "null"
        
        ' Redraw all the View Windows
        RedrawAllViews msdDrawingModeNormal
    
        ' Restart command
        CommandState.StartLocate Me
    End If
    
    If processSwitch = "BringFoward" Then
        If elmCounter = 0 Then
            Set firstElm = element
            elmCounter = 1
            ShowPrompt "Select Element to be in Front of"
            Exit Sub
        End If
            
        If elmCounter = 1 Then
            Set secondElm = element
            elmCounter = 0
            
            If firstElm.ID.Low <> secondElm.ID.Low Then
                Call BringElmFoward
            Else
                ShowError "The Same Element Was Selected Twice!!!"
            End If
        End If
        
        ' Restart command
        CommandState.StartLocate Me
    End If
    
    If processSwitch = "SendBackward" Then
       If elmCounter = 0 Then
            Set firstElm = element
            elmCounter = 1
            ShowPrompt "Select Element to be Behind of"
            Exit Sub
        End If
            
        If elmCounter = 1 Then
            Set secondElm = element
            elmCounter = 0
            
            If firstElm.ID.Low <> secondElm.ID.Low Then
                Call SendElmBackward
            Else
                ShowError "The Same Element Was Selected Twice!!!"
            End If
            
            ' Restart command
            CommandState.StartLocate Me
        End If
    End If
End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Cleanup
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_Cleanup()

End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Dynamics
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateFailed
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_LocateFailed()
    
End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateFilter
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_LocateFilter(ByVal element As element, Point As Point3d, Accepted As Boolean)
    
End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateReset
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_LocateReset()

    CommandState.StartDefaultCommand
    ShowStatus "ChgOrder Tool Exited"

End Sub

'*----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Start
'
'   author      BSI                                         07/08/02
'
'----------------------------------------------------------------------*/
Private Sub ILocateCommandEvents_Start()

    Dim lc As LocateCriteria
      
    If processSwitch = "BringToFront" Then
        ShowCommand "Bring Element to Front"
        ShowPrompt "Select the Element or Reset to Quit"
    End If
    
    If processSwitch = "BringFoward" Then
        ShowCommand "Bring Element Foward"
        ShowPrompt "Select the Element or Reset to Quit"
    End If
    
    If processSwitch = "SendToBack" Then
        ShowCommand "Send Element to Back"
        ShowPrompt "Select the Element or Reset to Quit"
    End If
    
    If processSwitch = "SendBackward" Then
        ShowCommand "Send Element Backward"
        ShowPrompt "Select the Element or Reset to Quit"
    End If
    
    '  Since this command does not modify the original element,
    '  set the locate criteria to allow read-only elements.
    Set lc = CommandState.CreateLocateCriteria(False)
    CommandState.SetLocateCriteria lc
    
End Sub
