VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CopyElementCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim oStartElement As Element
Dim oStartPoint As Point3d
Implements ILocateCommandEvents

Function CreateMovedElement(oBase As Element, oInputPoint As Point3d) As Element
    Dim oDistance As Point3d
    
    'Set oDistance = Point3d
    
    With oDistance
        .x = oInputPoint.x - oStartPoint.x
        .Y = oInputPoint.Y - oStartPoint.Y
        .Z = oInputPoint.Z - oStartPoint.Z
    End With
    
    Set CreateMovedElement = oStartElement.Clone
    CreateMovedElement.Move oDistance
End Function

Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
    Dim oTemp As Element
    Set oTemp = CreateMovedElement(oStartElement, Point)
    
    oTemp.Redraw msdDrawingModeNormal
    'Session.RedrawElement oTemp, msdNormalDraw
    ActiveModelReference.AddElement oTemp
    'Session.ActiveModel.AddElement oTemp
    CommandState.StartLocate New CopyElementCommand

End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub



Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    Dim oTemp As Element
    
    Set oTemp = CreateMovedElement(oStartElement, Point)
    oTemp.Redraw DrawMode
    'Session.RedrawElement oTemp, DrawMode
End Sub

Private Sub ILocateCommandEvents_LocateFailed()
    CommandState.StartLocate New CopyElementCommand
End Sub



Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)
    Set oStartElement = Element
    oStartPoint = Point
    CommandState.StartDynamics
End Sub

Private Sub ILocateCommandEvents_LocateReset()
    CommandState.StartDefaultCommand
    'CommandState.StartLocate New CopyElementCommand
End Sub

Private Sub ILocateCommandEvents_Start()
    ShowCommand "Copy Element"
    ShowPrompt "Select element to Copy"
End Sub

