VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ElementLocateCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents

'----------------------------------------------------------------------+
'
'   Name        ILocateCommandEvents_Accept
'
'   Author      BSI-DEVSPT                                  02/2004
'
'----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)

    Dim oView       As View
    Dim oLevel      As Level
    Dim oLineStyle  As LineStyle
    
    Set oView = CommandState.LastView
    Set oLevel = Element.Level
    
    ' Only use if Level Symbology is enabled in the View Attributes dialog box
    If oView.DisplaysLevelSymbology = True Then
        
        ' Display the selected element's level symbology color
        MsgBox "Level Symbology Element Color Is:" & Element.ApparentColor(oView)
        
        ' Display the selected element's level symbology linestyle
        Set oLineStyle = Element.ApparentLineStyle(oView)
        
        ' Determine if a custom linestyle is being used, if so display it's name
        If oLineStyle.Number < -1 Then
                MsgBox "Element Linestyle Is: " & _
                        elemGetLineStyleName(oLineStyle.Number)
        Else
            MsgBox "Level Symbology Element Linestyle Is: " & oLineStyle.Number
        End If
        
        ' Display the selected element's level symbology weight
        MsgBox "Level Symbology Element Weight Is:" & Element.ApparentLineWeight(oView)
    Else
        ' Display the selected element's bylevel color
        If Element.Color = -1 Then
            MsgBox "ByLevel Color Is: " & oLevel.ElementColor
        Else
            ' Display the selected element's element color
            Debug.Print "Element Color Is: "; Element.Color
            MsgBox "Element Color Is: " & Element.Color
        End If
        
        ' Display the selected element's bylevel linestyle
        If Element.LineStyle.Number = 2147483647 Then
        
            ' Determine if a custom linestyle is being used, if so display it's bylevel name
            If oLevel.ElementLineStyle.Number < -1 Then
                MsgBox "ByLevel Linestyle Is: " & _
                        elemGetLineStyleName(oLevel.ElementLineStyle.Number)
            Else
                MsgBox "ByLevel Linestyle Is: " & oLevel.ElementLineStyle.Number
            End If
            
        Else
            ' Determine if a custom linestyle is being used, if so display it's name
            If Element.LineStyle.Number < -1 Then
                 MsgBox "Element Linestyle Is: " & _
                        elemGetLineStyleName(Element.LineStyle.Number)
            Else
                MsgBox "Element Linestyle Is: " & Element.LineStyle.Number
            End If
        End If
        
        ' Display the selected element's bylevel weight
        If Element.Color = -1 Then
            MsgBox "ByLevel Weight Is: " & oLevel.ElementLineWeight
        Else
            ' Display the selected element's element weight
            MsgBox "Element Weight Is: " & Element.LineWeight
        End If
    End If
    
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)

End Sub

Private Sub ILocateCommandEvents_LocateReset()

End Sub

'----------------------------------------------------------------------+
'
'   Name        ILocateCommandEvents_Start
'
'   Author      BSI-DEVSPT                                  02/2004
'
'----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Start()
    ShowPrompt "Select An Element"
    ShowCommand "Get An Element's Color, Style and Weight Example"
End Sub
