Attribute VB_Name = "moveElements"
'----------------------------------------------------------------------------
' MoveElement2Model
'
' Status: WORKING
'
' Date: 01/22/03
'
' This example illustrates how to move elements from one model to another.
'
' Author: BSI                                                 01/22/03
'
'----------------------------------------------------------------------------
Sub MoveElement2Model()

    Dim oElEnum As ElementEnumerator
    Dim oFence As Fence
    Dim oEl As Element
    Dim modelName As String
    Dim availableModels As String
    Dim i As Integer
    Dim modelFound As Boolean
        
    'Initilize
    i = 1
    modelFound = False
    
    Set oFence = ActiveDesignFile.Fence
    
    'Check to see if a fence is active
    If oFence.IsDefined = True Then
        Set oElEnum = oFence.GetContents
        
    Else
        MsgBox "Define a Fence"
        End
    End If
    
    'Get available model names
     While i <= ActiveDesignFile.Models.count
        availableModels = availableModels + Chr(13) + ActiveDesignFile.Models.Item(i).Name
        i = i + 1
     Wend
     
     i = 1
     
    'Prompt user
    modelName = InputBox("Model to move elements to?" + Chr(13) + availableModels)
     
     'loop through all the models
    While i <= ActiveDesignFile.Models.count
        ' Check if the model is the one the user specified
        If StrComp(ActiveDesignFile.Models.Item(i).Name, modelName, vbTextCompare) = 0 Then
         ' Loop through the elements in the fence
            While oElEnum.MoveNext
                Set oEl = oElEnum.Current
                Dim newElm As Element
                
                Set newElm = oEl.Clone
                ' Add the element to the model
                ActiveDesignFile.Models.Item(i).AddElement newElm
                'Delete the original element
                ActiveModelReference.RemoveElement oEl
                modelFound = True
            Wend
        End If
        i = i + 1
    Wend
    
   If modelFound <> True Then
        Dim status As Integer
        status = MsgBox(modelName + " not found", vbCritical)
    End If
    
End Sub

