VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} CellPicker_UserForm 
   Caption         =   "Pattern Elements"
   ClientHeight    =   4110
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   OleObjectBlob   =   "CellPicker_UserForm.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "CellPicker_UserForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------------+
' CellPicker_UserForm
'
' Status: WORKING
'
' Date: 09/17/03
'
' This example illustrates how get a list of cell in the attached libray
' and pattern all the elements in the design file with a selected cell.
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2003 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+
Option Explicit
'-----------------------------------------------------------------------+
'
'   name        Globals
'
'-----------------------------------------------------------------------+
Dim origin As Point3d
Dim stdPic As StdPicture
Dim oCell As CellElement

'-----------------------------------------------------------------------+
'
'   name        ComboBoxSetCellNames
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Function ComboBoxSetCellNames(cbox As ComboBox) As Integer
    Dim count As Integer
    count = 0

    ' Determines if a cell library is attached
    If IsCellLibraryAttached Then

        Dim oCIE As CellInformationEnumerator
        Dim OCellInfo As CellInformation

        ' Returns information on the cells within a cell library.
        Set oCIE = GetCellInformationEnumerator(True, True)

        ' Enumerate thre cell library
        Do While oCIE.MoveNext

            cbox.AddItem oCIE.Current.Name
            count = count + 1
        Loop

    End If
    ComboBoxSetCellNames = count

End Function

'-----------------------------------------------------------------------+
'
'   name        CellNames_ComboBox_Change
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Private Sub CellNames_ComboBox_Change()

    'Get the cell
    Set oCell = CreateCellElement3(CellNames_ComboBox.Text, origin, True)

    'Add the cells picture to the image object
    Set stdPic = oCell.GetPicture(PointsToPixelsX(CellImage.Width), _
                                  PointsToPixelsY(CellImage.Height), True)

    'Set the image
    Set CellImage.Picture = stdPic

    'Set the active cell to the cell chosen
    ActiveSettings.cellName = oCell.Name

End Sub

'-----------------------------------------------------------------------+
'
'   name        CommandButton1_Click
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Private Sub CommandButton1_Click()

    If IsCellLibraryAttached Then
        ElmPatternAll oCell.Name
        'ActiveSettings.cellName = oCell.Name
        'CadInputQueue.SendCommand "place cell"
    End If

End Sub

'-----------------------------------------------------------------------+
'
'   name        UserForm_Initialize
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Private Sub UserForm_Initialize()

    If ComboBoxSetCellNames(CellNames_ComboBox) = 0 Then
        MsgBox "No Cell Libray Attached"
        End
    End If

    'Set the position of the combobox
    CellNames_ComboBox.ListIndex = 1

    'Get the cell
    Set oCell = CreateCellElement3(CellNames_ComboBox.Text, origin, True)

    'Add the cells picture to the image object
    Set stdPic = oCell.GetPicture(PointsToPixelsX(CellImage.Width), _
                                  PointsToPixelsY(CellImage.Height), True)

    ' Set the image to the first item in the combobox
    Set CellImage.Picture = stdPic

End Sub


