Attribute VB_Name = "ElmPattern"
'----------------------------------------------------------------------+
' PatternElm
'
' Status: WORKING
'
' Date: 09/17/03
'
' This example illustrates how get a list of cell in the attached libray
' and pattern all the elements in the design file with a selected cell.
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2003 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+

Option Explicit
'-----------------------------------------------------------------------+
'
'   Funtion Declarations
'
'-----------------------------------------------------------------------+
Declare Function mdlPattern_linear Lib "stdmdlbltin.dll" (ByRef patternEdPP As Long, ByVal edP As Long, ByVal filePos As Long, ByVal cell As Long, ByVal cellName As Long, ByVal oscale As Double, ByVal patternType As Long) As Long

'-----------------------------------------------------------------------+
'
'   name        ElmPatternAll
'
'   author      BSI                                             09/2003
'
'-----------------------------------------------------------------------+
Sub ElmPatternAll(cellName As String)

    Dim oScanCriteria   As New ElementScanCriteria
    Dim oEnumerator     As ElementEnumerator
    Dim status          As Long

    'Clear out any previous scans
    oScanCriteria.Reset

    'oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeOnlyVisible

    'Set enumerator
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)

    'Step through every element in the file
    Do While oEnumerator.MoveNext
        With oEnumerator.Current
    
        ' Check to see if we have a graphic element and not a
        ' text element
        If .IsGraphical And .Type <> msdElementTypeText Then

           Dim oElm As Long
           Dim cellElm As CellElement
           Dim patternElm As Element
           Dim origin As Point3d
           Dim patternScale As Double

           'Set the pattern's scale to the active text height
           patternScale = ActiveSettings.TextStyle.Height

           'Extract the cell from the library
           Set cellElm = CreateCellElement3(cellName, origin, True)

           'Pattern the element
           status = mdlPattern_linear(oElm, .MdlElementDescrP, _
                                     .FilePosition, cellElm.MdlElementDescrP, 0, patternScale, 0)

          If oElm <> 0 Then
               'Set the new pattern element
               Set patternElm = MdlCreateElementFromElementDescrP(oElm)

               ' Draw and add the pattern
               patternElm.Redraw
               ActiveModelReference.AddElement patternElm
           End If

        End If

        End With
    Loop

End Sub

'-----------------------------------------------------------------------+
'
'   name        main
'
'   author      BSI                                             09/2003
'
'-----------------------------------------------------------------------+
Sub main()

    'Check to see if a cell library is attached
    If IsCellLibraryAttached = False Then
        MsgBox "Please attach a cell library"
        End
    Else
        'Show the form
        CellPicker_UserForm.Show
    End If

End Sub



