VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsLineString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements IPrimitiveCommandEvents

Private m_atPoints() As Point3d
Private m_nPoints As Integer
Private oEl As LineElement

Private Sub IPrimitiveCommandEvents_Cleanup()

    If Not oEl Is Nothing Then ' If there is an element to place
        ActiveModelReference.AddElement oEl ' Add element to file
    End If
    m_nPoints = 0 'Set point to zero

End Sub

Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal View As View)
       
   If m_nPoints = 0 Then
        CommandState.StartDynamics 'If it has one point start dynamics
        ShowPrompt "Place next point" 'Prompt for next point
        ReDim m_atPoints(0) As Point3d 'Redimension your array
        m_atPoints(0) = Point 'Give the point
        m_nPoints = 1
        Exit Sub
   End If
   
   ReDim Preserve m_atPoints(m_nPoints) 'Redimension array
    
    m_atPoints(m_nPoints) = Point ' Pass the point
    m_nPoints = m_nPoints + 1 ' Increment the point
   
   Set oEl = CreateLineElement1(Nothing, m_atPoints) 'Draw the line
    
   oEl.Redraw


End Sub


Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    If m_nPoints > 0 Then
        m_atPoints(m_nPoints) = Point 'give it the point
        
        Set oEl = CreateLineElement1(Nothing, m_atPoints) ' create the line
        
        oEl.Redraw
         
     End If
     
   
End Sub


Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

End Sub

Private Sub IPrimitiveCommandEvents_Reset()
If Not oEl Is Nothing Then ' If there is an element to place

    ActiveModelReference.AddElement oEl ' Add element to file
End If
m_nPoints = 0 ' set points to zero
CommandState.StartPrimitive Me 'Return to start event

End Sub

Private Sub IPrimitiveCommandEvents_Start()
ShowCommand "VBA PlaceLineString Example"
ShowPrompt "Identify the starting point of the line"

End Sub
