VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function mdlCnv_masterToUOR Lib "stdmdlbltin.dll" (ByRef uorsP As Double, ByVal masterUnits As Double, ByVal modelRef As Long) As Long

Implements ILocateCommandEvents
Public oEl As Element 'Shape element that user selects.

'-----------------------------------------------------------------------+
'
'   Name        MasterToUOR
'
'   Author      BSI-DEVSPT                                  02/2004
'
'   Description - Converts Master units to UORs
'
'-----------------------------------------------------------------------+
Sub MasterToUOR(ByRef masterP As Point3d)

'   Convert to UOR units
    mdlCnv_masterToUOR masterP.X, masterP.X, ActiveModelReference.MdlModelRefP
    mdlCnv_masterToUOR masterP.Y, masterP.Y, ActiveModelReference.MdlModelRefP
    mdlCnv_masterToUOR masterP.Z, masterP.Z, ActiveModelReference.MdlModelRefP

End Sub

'-----------------------------------------------------------------------+
'
'   name        pointInPoly
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Function pointInPoly(ByRef point As Point3d, ByRef Elmrange As Long, numberPoints As Long) As Long
    '0  - outside
    '1 - inside
    pointInPoly = GetCExpressionValue("mdlPolygon_pointInsideXY (" & _
                  VarPtr(point) & "," & Elmrange & "," & CStr(numberPoints) & ",-1.0)")
 
End Function


Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, _
        point As Point3d, ByVal View As View)
    
        
    Dim ptStatus As Long
    Dim arrpoint() As Point3d
    Dim Elmrange() As Point3d
    Dim count As Integer
    Dim rCount As Integer
    Dim pCount As Integer
    
    'Initialize counters to 0
    count = 0
    rCount = 0
    pCount = 0
    
    'Get array of points for shape element.
    arrpoint = Element.AsShapeElement.GetVertices()
    
    'Convert values to UORs(which is what MDL functions take them as.
    While count < Element.AsShapeElement.VerticesCount
        MasterToUOR arrpoint(count)
        count = count + 1 'Increment counter.
    Wend
        
    'convert the user's datapoint to UORs as well.
    MasterToUOR point
    
    'Loop through each vertice and assign to appropriate array for range.
    While rCount < ((Element.AsShapeElement.VerticesCount * 2) - 2)
        
        'Dynamically expand array, and save previous values.
        ReDim Preserve Elmrange(rCount)
                
        Elmrange(rCount) = arrpoint(pCount)
        
        'Increment counters.
        rCount = rCount + 1
        pCount = pCount + 1
        
        'If reach last vertice, assign last range array value to first vertice.
        If rCount = ((Element.AsShapeElement.VerticesCount * 2) - 3) Then
            ReDim Preserve Elmrange(rCount)
            Elmrange(rCount) = arrpoint(0)
            rCount = rCount + 1
        'Else assign range value to current vertice.
        Else
            ReDim Preserve Elmrange(rCount)
            Elmrange(rCount) = arrpoint(pCount)
            rCount = rCount + 1
        End If
                        
    Wend
    'Call function to determine if point is inside shape or outside.
    ptStatus = pointInPoly(point, VarPtr(Elmrange(0)), 8)
    
    'Output result to user.
    If ptStatus = 1 Then
        MsgBox "Point is inside shape."
    ElseIf ptStatus = 0 Then
        MsgBox "Point is outside shape."
    End If
    
    'Null out status.
    ptStatus = Null
    
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(point As Point3d, ByVal View As View, _
        ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, _
                point As Point3d, Accepted As Boolean)

    'Accepted defaults to False
    Accepted = False
    'If shape element, assign to oEl object.
    If Element.IsShapeElement Then
        Set oEl = Element
        Accepted = True
        'Ask user for datapoint to compare to shape.
        ShowPrompt "Select a point"
    End If

End Sub

Private Sub ILocateCommandEvents_LocateReset()

End Sub

Private Sub ILocateCommandEvents_Start()
    Dim lc As LocateCriteria
    
    '  Since this command does not modify the original element,
    '  set the locate criteria to allow  read-only elements.
    Set lc = CommandState.CreateLocateCriteria(False)
    CommandState.SetLocateCriteria lc
    'Prompt user to select a shape.
    ShowCommand "PointInShape"
    ShowPrompt "Select a shape"
End Sub



