Attribute VB_Name = "TestPointInPolygonXY"
Option Explicit

Sub TestPointInPolygonXY()
    Dim oShape As ShapeElement, oLine As LineElement
    Dim oView As View
    Dim sRotationSaved As Matrix3d
    Dim sPoint As Point3d, aPoints(0 To 5) As Point3d
    Dim sPointRotated As Point3d, aPointsRotated(0 To 5) As Point3d
    Dim parity As Integer
    Dim i As Long
    
    aPoints(0) = Point3dFromXYZ(0#, 0#, 1#)
    aPoints(1) = Point3dFromXYZ(1#, 0#, 0#)
    aPoints(2) = Point3dFromXYZ(0.2, 0.5, -0.5)
    aPoints(3) = Point3dFromXYZ(1#, 1#, -1#)
    aPoints(4) = Point3dFromXYZ(0#, 1#, 0#)
    aPoints(5) = aPoints(0) ' not necessary, actually
    
    Set oShape = CreateShapeElement1(Nothing, aPoints, msdFillModeNotFilled)
    oShape.color = 1        'blue
    ActiveModelReference.AddElement oShape
    oShape.Redraw
    
    sPoint = Point3dFromXYZ(1#, 0.5, 0#)
    Set oLine = CreateLineElement2(oShape, sPoint, sPoint)
    oLine.LineWeight = 5

    Set oView = ActiveDesignFile.Views(1)
    sRotationSaved = oView.Rotation
        
    ' As seen in Top view... (out)
    oView.SetToTop
    parity = Point3dInPolygonXY(sPoint, aPoints)
    If parity > 0 Then
        oLine.color = 2     'green => in
    ElseIf parity < 0 Then
        oLine.color = 3     'red => out
    Else
        oLine.color = 4     'yellow => on
    End If
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    ' As seen in iso view... (on)
    oView.SetToIsometric
    sPointRotated = Point3dFromMatrix3dTimesPoint3d(oView.Rotation, sPoint)
    For i = LBound(aPoints) To UBound(aPoints)
        aPointsRotated(i) = Point3dFromMatrix3dTimesPoint3d(oView.Rotation, aPoints(i))
    Next
    oView.SetToTop
    Set oShape = CreateShapeElement1(oShape, aPointsRotated, msdFillModeNotFilled)
    ActiveModelReference.AddElement oShape
    oShape.Redraw
    
    parity = Point3dInPolygonXY(sPointRotated, aPointsRotated)
    If parity > 0 Then
        oLine.color = 2     'green => in
    ElseIf parity < 0 Then
        oLine.color = 3     'red => out
    Else
        oLine.color = 4     'yellow => on
    End If
    Set oLine = CreateLineElement2(oLine, sPointRotated, sPointRotated)
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    ' As seen in left view... (in)
    oView.SetToLeft
    sPointRotated = Point3dFromMatrix3dTimesPoint3d(oView.Rotation, sPoint)
    For i = LBound(aPoints) To UBound(aPoints)
        aPointsRotated(i) = Point3dFromMatrix3dTimesPoint3d(oView.Rotation, aPoints(i))
    Next
    oView.SetToTop
    Set oShape = CreateShapeElement1(oShape, aPointsRotated, msdFillModeNotFilled)
    ActiveModelReference.AddElement oShape
    oShape.Redraw
    
    parity = Point3dInPolygonXY(sPointRotated, aPointsRotated)
    If parity > 0 Then
        oLine.color = 2     'green => in
    ElseIf parity < 0 Then
        oLine.color = 3     'red => out
    Else
        oLine.color = 4     'yellow => on
    End If
    Set oLine = CreateLineElement2(oLine, sPointRotated, sPointRotated)
    ActiveModelReference.AddElement oLine
    oLine.Redraw
    
    oView.Rotation = sRotationSaved
End Sub
