Attribute VB_Name = "TestTangentCircles"
Option Explicit

Sub TestTangentCircles()
    Dim oCircle0 As EllipseElement, oCircle1 As EllipseElement, oCircle2 As EllipseElement
    Dim sEllipse As Ellipse3d
    Dim sVec0 As Point3d, sVec90 As Point3d, sCross As Point3d
    Dim axis0 As Double, axis1 As Double
    Dim oTangentCircle As Element
    Dim oEnumerator As ElementEnumerator
    Dim color As Long, weight As Long
    
    color = 2
    
    'Make arbitrary plane for geometry
    sVec0 = Point3dFromXYZ(1, 1, 0)
    sVec90 = Point3dFromXYZ(-1, 1, 1)
    'sVec90 = Point3dFromXYZ(-1, 1, 0)
    sCross = Point3dCrossProduct(sVec0, sVec90)
    sVec90 = Point3dCrossProduct(sCross, sVec0)
    sVec0 = Point3dNormalize(sVec0)
    sVec90 = Point3dNormalize(sVec90)
    
    'Make closed element at origin
    sEllipse.Vector0 = sVec0
    sEllipse.Vector90 = sVec90
    sEllipse.Center = Point3dZero()
    sEllipse.Start = 0#
    sEllipse.Sweep = 2 * Pi
    Set oCircle0 = CreateEllipticalElement1(Nothing, sEllipse)
    oCircle0.color = color
    
    sEllipse.Center = Point3dAddScaled(Point3dZero(), sVec90, 3#)
    sEllipse.Vector90 = Point3dScale(sVec90, 2.5)
    Set oCircle1 = CreateEllipticalElement1(oCircle0, sEllipse)
    
    sEllipse.Center = Point3dAddScaled(Point3dZero(), sVec0, 5#)
    sEllipse.Vector0 = Point3dScale(sVec0, 5#)
    sEllipse.Vector90 = Point3dScale(sVec90, 3#)
    Set oCircle2 = CreateEllipticalElement1(oCircle0, sEllipse)

    'Add ellipses
    ActiveModelReference.AddElement oCircle0
    ActiveModelReference.AddElement oCircle1
    ActiveModelReference.AddElement oCircle2
    oCircle0.Redraw
    oCircle1.Redraw
    oCircle2.Redraw
    
    'Extract circles
    Set oEnumerator = ConstructCirclesTangentToThreeElements(oCircle0, oCircle1, oCircle2, Nothing, msdTangentCircles)
    
    Do While oEnumerator.MoveNext
        Set oTangentCircle = oEnumerator.Current
        oTangentCircle.color = color + 129
        ActiveModelReference.AddElement oTangentCircle
        oTangentCircle.Redraw
    Loop

    'Extract arcs
    Set oEnumerator = ConstructCirclesTangentToThreeElements(oCircle0, oCircle1, oCircle2, Nothing, msdTangentArcs)
    
    Do While oEnumerator.MoveNext
        Set oTangentCircle = oEnumerator.Current
        oTangentCircle.color = color + 129 + 1
        'ActiveModelReference.AddElement oTangentCircle
        oTangentCircle.Redraw
    Loop

    'Extract triangles
    Set oEnumerator = ConstructCirclesTangentToThreeElements(oCircle0, oCircle1, oCircle2, Nothing, msdTangentTriangles)
    
    Do While oEnumerator.MoveNext
        Set oTangentCircle = oEnumerator.Current
        oTangentCircle.color = color + 129 + 5
        'ActiveModelReference.AddElement oTangentCircle
        oTangentCircle.Redraw
    Loop

End Sub
