VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PlaceTickCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------
' PlaceTickCommand
'
' Status: WORKING
'
' Date: 08/07/2001
'
' This example illustrates how to palce a tick mark.
'
' Author: BSI
'
'----------------------------------------------------------------------------

Implements IPrimitiveCommandEvents

Public TICKSIZE As Integer
Private tick As CellElement 'Tick Mark
Private ncount As Integer   'Counter flag for points

'-----------------------------------------------------------------------+
'
'   name        VBAcreateTick
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Public Function VBAcreateTick(Point As Point3d, size As Integer) As CellElement

    Dim TickElm(0 To 1) As Element
    Dim elm As Element
    Dim tickPoint(2) As Point3d
    Dim test As Element
        
    'X Leg 1
    tickPoint(0).X = Point.X + size
    tickPoint(0).Y = Point.Y
    tickPoint(0).Z = Point.Z

    'X Leg 2
    tickPoint(1).X = Point.X - size
    tickPoint(1).Y = Point.Y
    tickPoint(1).Z = Point.Z

    'Create Tick Leg X
    Set TickElm(0) = CreateLineElement2(Nothing, tickPoint(0), tickPoint(1))
    
    
    'Y Leg 1
    tickPoint(0).X = Point.X
    tickPoint(0).Y = Point.Y + size
    tickPoint(0).Z = Point.Z
    
    'Y Leg 2
    tickPoint(1).X = Point.X
    tickPoint(1).Y = Point.Y - size
    tickPoint(1).Z = Point.Z
       
    'Create Tick Leg Y
    Set TickElm(1) = CreateLineElement2(Nothing, tickPoint(0), tickPoint(1))
 
    'return the tick
    Set VBAcreateTick = CreateCellElement1("VBATick", TickElm(), Point, False)
      
End Function

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Cleanup
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_DataPoint
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal View As View)
    
       
    'Create a tick mark
    Set tick = VBAcreateTick(Point, TICKSIZE)
    
    'Add Tick mark to design file
    ActiveModelReference.AddElement tick
    
    'Display tick mark
    tick.Redraw msdDrawingModeNormal
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Dynamics
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Dim oEl As CellElement
                
    Set oEl = VBAcreateTick(Point, TICKSIZE)
               
    oEl.Redraw DrawMode
     
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Keyin
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Reset
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Reset()
    
    'Set Flag to 0
    ncount = 0
    
    CommandState.StartPrimitive Me
  
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Start
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Start()
    
    Dim Point As Point3d
    
    ' Set tick size
    TICKSIZE = MicroStationDGN.ActiveSettings.TextStyle.Height
        
    'Prompt user
    ShowCommand "Place Tick Command"
    ShowPrompt "Place Tick Mark"
  
    'Start dynamics
    CommandState.StartDynamics

End Sub

