Attribute VB_Name = "FencePoints"
'----------------------------------------------------------------------+
' Module:   FencePoints.bas
'
' Status: WORKING
'
' Date:  03/30/04
'
' This example illustrates how to get the fence points from the
' active fence
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+

'-----------------------------------------------------------------------+
'
'   name        Point3dToString
'
'   author      BSI                                             03/2003
'
'-----------------------------------------------------------------------+
Function Point3dToString(thePoint As Point3d)
    With thePoint
        Point3dToString = "(" & .X & ", " & .Y & ", " & .Z & ")"
    End With
End Function

'-----------------------------------------------------------------------+
'
'   name        main
'
'   author      BSI                                             03/2003
'
'-----------------------------------------------------------------------+
Sub main()

If ActiveDesignFile.Fence.IsDefined Then

    Dim oElement As Element
    Dim m_vertexList() As Point3d
    Dim strmsg As String
    Dim count As Integer
    Dim index As Integer

    'Create an element from the fence
    Set oElement = ActiveDesignFile.Fence.CreateElement()

    'Get the vertices from the shape
    m_vertexList = oElement.AsShapeElement.GetVertices()
    count = oElement.AsShapeElement.VerticesCount

    'Print out the points
    For index = 0 To count - 1
        Dim currentPoint As Point3d

        currentPoint = m_vertexList(index)
        strmsg = "Vertex (" & index & "): "
        strmsg = strmsg & Point3dToString(currentPoint)
        Debug.Print strmsg
    Next

    Else
        MsgBox "No Fence Defined"
    End If

End Sub

