Attribute VB_Name = "Module1"
'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2002, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' formPosition
'
' Status: WORKING
'
' This example illustrates how to store the forms left and top position
' values in configuration variables then use those variables so that when
' the form is opened again, it will display at the same location as when
' it was last closed.
'
' Author: BSI                                                   08/09/02
'
'-----------------------------------------------------------------------+
Option Explicit

' Public variables
Public dialogPositionLeft As Double
Public dialogPositionTop As Double

'-----------------------------------------------------------------------+
'
'   name        cfgVarWrite
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Sub cfgVarWrite(cfgVarName As String, cfgVarValue As String)

    ActiveWorkspace.AddConfigurationVariable cfgVarName, cfgVarValue
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        cfgVarGet
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Function cfgVarGet(cfgVarName As String, expand As Boolean) As String
        
    cfgVarGet = ActiveWorkspace.ConfigurationVariableValue(cfgVarName, expand)
    
End Function

'-----------------------------------------------------------------------+
'
'   name        cfgVarIsDefined
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Function cfgVarIsDefined(cfgVarName As String) As Boolean
        
    cfgVarIsDefined = ActiveWorkspace.IsConfigurationVariableDefined(cfgVarName)
    
End Function

'-----------------------------------------------------------------------+
'
'   name        openForm
'
'   author      BSI                                             08/2002
'
'-----------------------------------------------------------------------+
Sub openForm()
    
    If cfgVarIsDefined("FORM_POSITION_LEFT") = True Then
        If cfgVarIsDefined("FORM_POSITION_TOP") = True Then
        
            ' If the config variables exist, extract their values to place the form
            dialogPositionLeft = Val(cfgVarGet("FORM_POSITION_LEFT", True))
            dialogPositionTop = Val(cfgVarGet("FORM_POSITION_TOP", True))
        
            ' Sets the forms StartUpPosition property to Manual
            UserForm1.StartUpPosition = 0
            
            ' Sets the forms left and top properties
            UserForm1.Left = dialogPositionLeft
            UserForm1.Top = dialogPositionTop
        Else
        
            ' If this config variable does not exist, create it
            cfgVarWrite "FORM_POSITION_TOP", CStr(UserForm1.Left)
        End If
    Else
        ' If this config variable does not exist, create it
        cfgVarWrite "FORM_POSITION_LEFT", CStr(UserForm1.Top)
    End If
    
    ' Displays the form
    UserForm1.Show
End Sub


