VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TurnLvlsOff"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents

Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, _
        Point As Point3d, ByVal View As View)
    
    Dim oAtt As Attachment
    
    If Element.IsFromAttachment Then
        Set oAtt = ActiveModelReference.Attachments.FindByLogicalName(Element.Attachment.AttachmentLogicalName)
        oAtt.Levels(Element.Level.Name).IsDisplayed = False
        oAtt.Levels.Rewrite
    Else
        Element.ModelReference.Levels(Element.Level.Name).IsDisplayed = False
        ActiveDesignFile.RewriteLevels
    End If
        
    RedrawAllViews
    
    ' Restarts the command
    CommandState.StartLocate Me

End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, _
        ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()
    ShowStatus "No Element Found"
End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, _
                Point As Point3d, Accepted As Boolean)
    
    Accepted = False
    
    ' Determines what elements pass the filter
    If Element.IsGraphical Then
        Accepted = True
    End If

End Sub

Private Sub ILocateCommandEvents_LocateReset()
    ShowError "Program Exited"
    CommandState.StartDefaultCommand

End Sub

Private Sub ILocateCommandEvents_Start()
    Dim lc As LocateCriteria
    
    '  Since this command does not modify the original element,
    '  set the locate criteria to allow  read-only elements.
    Set lc = CommandState.CreateLocateCriteria(False)
    CommandState.SetLocateCriteria lc
    
    ShowCommand "Turn Off Level By Element"
    ShowPrompt "Select an element"
End Sub


