Attribute VB_Name = "LevDisplay"
Option Explicit
' Turn on/off reference file levels in a view.

' Levels can be turned on or off by view or
' by level_name (this will apply to all views and works like Level Display (Ctl+E))

' By View: oView.ShowLevel lvl /oView.HideLevel lvl, oView.Redraw
' By Level Name: I will do more work on this case .....


' ****************************************
' turn on ref levels in a view (Test Case)
' ****************************************
Sub TurnOnLevels()
    UserForm1.Show
    'turn off all levels in all reference file in view 1
    'refLvlDisplayInView 2, False
End Sub


' ******************************************************************
'
'   Function name:     refLvlDisplayInView
'
'   author          BSI      Version 1.0            07/2002
'
' Ussage: refLvlDisplayInView 1, False, , "ref1.dgn"
'           Turn Off ALL levels in reference File "ref1.dgn" in view1.
'
'       refLvlDisplayInView 1, True
'           Turn ON ALL levels in ALL reference Files in view1.
'
'       refLvlDisplayInView 1, False, "level1"
'           Turn ON level1 in ALL reference Files in view1.
'
' Note: This version can not process nested reference files.
'       and does not validate Level name and reference file Name.
' *******************************************************************
 
Function refLvlDisplayInView(oViewNum As Integer, bDisplay As Boolean, _
                Optional strRefLvlName As String = "ALL", _
                Optional strRefFileName As String = "ALL") As Boolean
                
    ' Validate input
    If (oViewNum > 8 Or oViewNum < 1) Then
        ShowPrompt "Invalid View Number Passed to refLvlDisplayInView"
        refLvlDisplayInView = False ' Return False
        Exit Function
    End If
    
    MsgBox "Total Ref Files " & ActiveModelReference.Attachments.Count
    
    Dim Attach As Attachment
    For Each Attach In ActiveModelReference.Attachments
   
   '     Debug.Print Attach.AttachName
       If Attach.DesignFile.Name = strRefFileName _
                Or strRefFileName = "ALL" Then
                
'        MsgBox "File Name " & Attach.DesignFile.Name
' Looks like attachments include active desigh file, but the level is not off ???


            Dim oView As View
            Set oView = Attach.DesignFile.Views(oViewNum)
                    
            Dim lvl As Level
            For Each lvl In Attach.Levels
            
                ' Make sure level Name is valid
                If lvl.Name = strRefLvlName Or strRefLvlName = "ALL" Then
                    
                    Debug.Print oView.Index
                    If bDisplay Then
                        oView.ShowLevel lvl
                    Else
                        oView.HideLevel lvl
                    End If
                    oView.Redraw
                End If 'Match strRefLvlName
            Next lvl
       End If 'Match strRefFileName
    Next Attach
End Function
 
  
'-----------------------------------------------------------------------+
'
'   name        refDisplay
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Function refDisplay(strFileName As String, bDisplay As Boolean, _
                Optional strModelName As String = "Default") As Boolean
    
    Dim oAttachment      As Attachment
 
    ' Assign File Name if provided
    If (strFileName = "") Then
        ShowPrompt "Invalid fileName Passed to refDisplay"
        refDisplay = False ' Return False
        Exit Function
    End If
        
    For Each oAttachment In ActiveModelReference.Attachments
        If ((strFileName = oAttachment.AttachName) And _
            (oAttachment.Name = strModelName)) Then
           'Turn Display either on or off
           oAttachment.ElementsVisible = bDisplay
           'oAttachment.ElementsLocatable = tmpDisplay
           'oAttachment.ElementsSnappable = tmpDisplay
           'oAttachment.ScaleFactor = tmpScale
        
        End If
    Next
         
    'Show a status to the user
    If (bDisplay) Then
         ShowPrompt "Reference File Display Turned ON"
    Else
         ShowPrompt "Reference File Display turned OFF"
    End If
    
    refDisplay = True 'Return True
End Function
 
