VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} UserForm1 
   Caption         =   "Graphic Group Example"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   OleObjectBlob   =   "UserForm1.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "UserForm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub ExitButton_Click()
'Exit VB app..
End

End Sub

Private Sub OK_Button_Click()
'Determine which function to call based on radio button selected.
If getGG = True Then
    getGraphicGr
Else
    setGraphicGr
End If

End Sub

'Retrieve element name.
Public Function GetElementTypeName(ByVal eType As Integer) As String
    
     
    Select Case eType
    Case 1: GetElementTypeName = "Cell Library Header         "
    Case 2: GetElementTypeName = "Cell Header                 "
    Case 3: GetElementTypeName = "Line                        "
    Case 4: GetElementTypeName = "Line String                 "
    Case 5: GetElementTypeName = "Group Data                  "
    Case 6: GetElementTypeName = "Shape                       "
    Case 7: GetElementTypeName = "Text Node                   "
    Case 8: GetElementTypeName = "Digitizer Setup Data        "
    Case 9: GetElementTypeName = "Design File Header          "
    Case 10: GetElementTypeName = "Level Symbology            "
    Case 11: GetElementTypeName = "Curve                      "
    Case 12: GetElementTypeName = "Complex String             "
    Case 13: GetElementTypeName = "Conic                      "
    Case 14: GetElementTypeName = "Complex Shape              "
    Case 15: GetElementTypeName = "Ellipse                    "
    Case 16: GetElementTypeName = "Arc                        "
    Case 17: GetElementTypeName = "Text                       "
    Case 18: GetElementTypeName = "Surface                    "
    Case 19: GetElementTypeName = "Solid                      "
    Case 21: GetElementTypeName = "BSpline Pole               "
    Case 22: GetElementTypeName = "Point String               "
    Case 23: GetElementTypeName = "Cone                       "
    Case 24: GetElementTypeName = "BSpline Surface            "
    Case 25: GetElementTypeName = "BSpline Boundary           "
    Case 26: GetElementTypeName = "BSpline Knot               "
    Case 27: GetElementTypeName = "BSpline Curve              "
    Case 28: GetElementTypeName = "BSpline Weight             "
    Case 33: GetElementTypeName = "Dimension                  "
    Case 34: GetElementTypeName = "Shared Cell Definition     "
    Case 35: GetElementTypeName = "Shared Cell                "
    Case 36: GetElementTypeName = "MultiLine                  "
    Case 37: GetElementTypeName = "Tag                        "
    Case 38: GetElementTypeName = "DgnStore Component         "
    Case 39: GetElementTypeName = "DgnStore Header            "
    Case 51: GetElementTypeName = " ARCH (Intergraph)         "
    Case 54: GetElementTypeName = "SDS (Intergraph)           "
    Case 56: GetElementTypeName = "LEDS, WMS                  "
    Case 60: GetElementTypeName = "SIS                        "
    Case 61: GetElementTypeName = "EWS SCREMANC               "
    Case 62: GetElementTypeName = "EWS PANEL                  "
    Case 63: GetElementTypeName = "EWS PDS                    "
    Case 66: GetElementTypeName = "MicroStation Application"
    Case 87: GetElementTypeName = "Raster Header              "
    Case 88: GetElementTypeName = "Raster Component           "
    Case 89: GetElementTypeName = "Raster Data                "
    Case 90: GetElementTypeName = "Raster Reference Attachment"
    Case 91: GetElementTypeName = "Raster Reference Component "
    Case 96: GetElementTypeName = "Level Table                "
    Case 97: GetElementTypeName = "View Group Element"
    Case 98: GetElementTypeName = "View Element               "
    Case 99: GetElementTypeName = "Level Mask Element         "
    Case 100: GetElementTypeName = "Reference Attach Element  "
    Case 101: GetElementTypeName = "Matrix Header             "
    Case 102: GetElementTypeName = "Matrix Int Data           "
    Case 103: GetElementTypeName = "Matrix Double Data        "
    Case 105: GetElementTypeName = "Mesh Header               "
    Case Else: GetElementTypeName = "NONE"
    
    
    End Select
End Function

Private Sub getGraphicGr()

    Dim elem As Element
    Dim ggnum As String
    Dim reply As Integer
    Dim Count As Integer
    Dim Msg3, Msg2, Msg, Style, Title
    Dim ScanCriteria As New ElementScanCriteria
    Dim Enumer As ElementEnumerator


    Count = 0
    
    'Clear out last search criteria and set up scanner.
    ScanCriteria.Reset
    
    Set Enumer = Application.ActiveModelReference.Scan(ScanCriteria)
    
    'Uses inputbox to get graphic group number from user.
    ggnum = InputBox("Select number of graphic group elements to display", "Get Graphic Group")
    
    'Loop continues until no more elements are found.
    Do While Enumer.MoveNext
        Set elem = Enumer.Current 'Grab current element
        
        If elem.IsGraphical Then
            If CStr(elem.GraphicGroup) = ggnum Then
                
                Count = Count + 1
                elem.Redraw msdHilite 'Hilite current element
                
                'Function call to get element name
                elemName = GetElementTypeName(elem.Type)
                
                'Display each element found
                Msg = "Element found is " + elemName    ' Define message.
                Style = vbOK    ' Define buttons.
                Title = "Display Graphic Group Elements"    ' Define title.
                reply = MsgBox(Msg, Style, Title)
                
                If reply = vbOK Then
                    
                    'Redraw element without hilite
                    elem.Redraw msdNormalDraw
                
                Else
                    
                    'If cancel button is pressed exits loop
                    elem.Redraw msdNormalDraw
                    Exit Sub
                
                End If
            
                
            End If
        End If
    Loop
    
    If Count < 1 Then
        
            'If no elements match GG#
            Msg3 = "No elements found with this GG#"
            Style = vbOK    ' Define buttons.
            Title = "Display Graphic Group Elements"
            reply = MsgBox(Msg3, Style, Title)
            
    Else
            
        'Display total no. of elements found
        Msg2 = "Total elements found with specified GG# " + CStr(Count)
        Style = vbOK    ' Define buttons.
        Title = "Display Graphic Group Elements"    ' Define title.
        reply = MsgBox(Msg2, Style, Title)
    
    End If
    


End Sub

Private Sub setGraphicGr()


    Dim oElement As Element
    Dim ggnum As String
    Dim oEnumerator As ElementEnumerator
    Dim Count As Integer
    Dim Msg, Style, Title
    Dim reply As Integer
    
    
    
    'Uses inputbox to get graphic group number from user.
    ggnum = InputBox("Select graphic group you wish to set elements to ", "Set Graphic Group")
    If ggnum = "" Then
    
    Else
        If ActiveDesignFile.Fence.IsDefined Then
        
            Set oEnumerator = ActiveDesignFile.Fence.GetContents
            Do While oEnumerator.MoveNext
                Set oElement = oEnumerator.Current
                oElement.GraphicGroup = ggnum
                oElement.Rewrite
                oElement.Redraw msdNormalDraw
                Count = Count + 1
            Loop
    
        
        Else
            Count = 0
            Set oEnumerator = ActiveModelReference.GetSelectedElements
            
                'Moves through each element in selection set.
                Do While oEnumerator.MoveNext
                    Set oElement = oEnumerator.Current
                    oElement.GraphicGroup = ggnum
                    oElement.Rewrite
                    oElement.Redraw msdNormalDraw
                    Count = Count + 1
                Loop
        End If
    
        If Count = 0 Then
        
            'Display each element found
            Msg = "No Selection Set Found. " ' Define message.
            Style = vbOK    ' Define buttons.
            Title = "Information!"    ' Define title.
            reply = MsgBox(Msg, Style, Title)
                
        End If
    End If
End Sub
          

Private Sub UserForm_Click()

End Sub
