VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmModels
   Caption         =   "OpenFileFromProgram"
   ClientHeight    =   3510
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4185
   OleObjectBlob   =   "frmModels.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmModels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------    -----------+
' Module:   frmModels.frm
'
' Status:   WORKING
'
' Date:  04/27/04
'
' Author: BSI-DEVSPT
'
' Copyright: (c) Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+

'*---------------------------------------------------------------------------------**''**
' Globals
'---------------+---------------+---------------+---------------+---------------+------''
Dim oDgnFile As DesignFile
Dim oModels As ModelReferences
Dim strOriginalFile As String
Dim strOriginalModel As String
Dim intButtonState As Integer

'*---------------------------------------------------------------------------------**''**
' @description      Button click event
' @param            void
' @return           void
' @version          1.0
' @dependencies
' @example
'
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      04/04
'---------------+---------------+---------------+---------------+---------------+------''
Private Sub BTN_OPEN_Click()
    UserForm_Initialize
End Sub

'*---------------------------------------------------------------------------------**''**
' @description      Double click event for the list box item
' @param            Cancel
' @return           void
' @version          1.0
' @dependencies
' @example
'
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      04/04
'---------------+---------------+---------------+---------------+---------------+------''
Private Sub ListBoxModels_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    Dim strFileName As String

    If intButtonState = 0 Then

        strFileName = oDgnFile.FullName
        oDgnFile.Close
        Set oDgnFile = Nothing
        OpenDesignFile strFileName
        intButtonState = 1
        ActiveDesignFile.Models(ListBoxModels.Text).Activate
    Else

        ActiveDesignFile.Models(ListBoxModels.Text).Activate
    End If
End Sub

'*---------------------------------------------------------------------------------**''**
' @description      Starting point for the dialog
' @param            void
' @return           void
' @version          1.0
' @dependencies
' @example
'
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      04/04
'---------------+---------------+---------------+---------------+---------------+------''
Private Sub UserForm_Initialize()

    Dim intModelCount As Integer

    'Store the original file and model
    strOriginalFile = ActiveDesignFile.FullName
    strOriginalModel = ActiveModelReference.Name

    'Open the remote design file
    Set oDgnFile = OpenDesignFileForProgram(FileOpenDialog(TXT_DIALOGTITLE, "C:\", "*.dgn", ""))

    'Populate the listbox with the model names
    Set oModels = oDgnFile.Models
    intModelCount = oModels.count
    ListBoxModels.Clear
    For intCount = 1 To intModelCount
        ListBoxModels.AddItem oModels(intCount).Name
    Next

End Sub

'*---------------------------------------------------------------------------------**''**
' @description      Function for the Terminate event
' @param            void
' @return           void
' @version          1.0
' @dependencies
' @example
'
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      04/04
'---------------+---------------+---------------+---------------+---------------+------''
Private Sub UserForm_Terminate()

    If oDgnFile Is Nothing Then
        OpenDesignFile strOriginalFile
        ActiveDesignFile.Models(strOriginalModel).Activate
    Else
        oDgnFile.Close
    End If

End Sub
