Attribute VB_Name = "MultiLine"
'---------------------------------------------------------------------------------------+
'
'   Copyright: (c) Bentley Systems, Incorporated. All rights reserved.
'
'---------------------------------------------------------------------------------------+
'---------------------------------------------------------------------------------------+
' Module:   MultiLine.bas
' Status:   WORKING
' Date:     05/17/04
' Author:   BSI-DEVSPT
' Version:  1.0
'
' This example illustrates how to get the number of lines in the active MultiLine-Style.
'
'---------------------------------------------------------------------------------------+
Option Explicit
'---------------------------------------------------------------------------------------+
'
'   Private declaration imports
'
'---------------------------------------------------------------------------------------+
'---------------------------------------------------------------------------------------+
'
'   Public variable definitions
'
'---------------------------------------------------------------------------------------+
'---------------------------------------------------------------------------------------+
'
'   Public constant definitions
'
'---------------------------------------------------------------------------------------+
'---------------------------------------------------------------------------------------+
'
'   Public type definitions
'
'---------------------------------------------------------------------------------------+
'---------------------------------------------------------------------------------------+
'
'   Public function definitions
'
'---------------------------------------------------------------------------------------+
Public Declare Function mdlMlineStyleP_getActive Lib "stdmdlbltin.dll" () As Long  ' Returns a pointer to a structure
Public Declare Function mdlMlineStyleP_getNumProfiles Lib "stdmdlbltin.dll" (ByVal mlineStyle As Long) As Long

'*---------------------------------------------------------------------------------**''**
' @description      Returns the number of lines in the active MultiLine-Style.
' @param
' @return           Integer - the number of lines in the active MultiLine-Style.
' @version          1.0
' @dependencies
' @example          MsgBox "Number of Line in Active Multiline = " + CStr(MultilineGetNumLines())
'
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      05/04
'---------------+---------------+---------------+---------------+---------------+------''
Function MultilineGetNumLines() As Integer

    MultilineGetNumLines = mdlMlineStyleP_getNumProfiles(mdlMlineStyleP_getActive())

End Function

'*---------------------------------------------------------------------------------**''**
' @description      Main entry point for the example
' @param            void
' @return           Nothing
' @version          1.0
' @dependencies
' @example
' @remarks
' @alinkjoin
' @group
' @bsimethod                                                    BSI-DEVSPT      05/04
'---------------+---------------+---------------+---------------+---------------+------''
Sub main()

    MsgBox "Number of Line in Active Multiline = " + CStr(MultilineGetNumLines())

End Sub
