Attribute VB_Name = "mysettings"
'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2001, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' linePattern.mysettings.setLinePatten
'
' Status: WORKING
'
' Date: 03/04/02
'
' This example illustrates how to set the active cell ARRO  as the
' line pattern.
'
' Author: BSI                                                 03/4/02
'
'-----------------------------------------------------------------------+
'-----------------------------------------------------------------------+
'
'   name        set16SArrow
'
'   author      BSI                                           03/2002
'
'-----------------------------------------------------------------------+
Public Sub set16SArrow()
setLinePattern 1 / 16

End Sub
'-----------------------------------------------------------------------+
'
'   name        set16SArrow
'
'   author      BSI                                           03/2002
'
'-----------------------------------------------------------------------+
Public Sub set12SArrow()
setLinePattern 1 / 2

End Sub

'-----------------------------------------------------------------------+
'
'   name        setLinePattern
'
'   author      BSI                                           03/2002
'
'-----------------------------------------------------------------------+
Private Sub setLinePattern(patternScale As Double)
    Dim startPoint As Point3d
    Dim point As Point3d, point2 As Point3d
    Dim lngTemp As Long
    Dim cellName As String
    
'   Get the cell name from the keyin
    cellName = KeyinArguments
    
    If cellName = nill Then
        cellName = "ARRO"
        
    End If
    
'   Turn on the error trap.
    On Error GoTo errorFlag
    
'   Attach a cell library
    'AttachCellLibrary ("sample2.cel")
    
'   The error trap applies to only the preceding statement, so turn it off now.
    On Error GoTo 0
    
'   Start a command
    CadInputQueue.SendCommand "PATTERN LINE ICON "
    
'   Set the patterns
    patternSettings cellName, patternScale

'   (Target for "Resume afterError" statement, at the end of the error handler.)
afterError:
 
'   Don't let the code just "fall into" the error handler!
'   Error handler code should be encountered ONLY if an error occurs.
    Exit Sub

'   The error handler begins here
errorFlag:
    Dim errMsg As String
    
    errMsg = "Error Cant open Cell library " + cellLib
        
'   Display error
    MsgBox errMsg
        
'   An error handler should always end with one of the "Resume" statements.
    Resume afterError
    
End Sub
'-----------------------------------------------------------------------+
'
'   name        patternSettings
'
'   author      BSI                                           03/2002
'
'-----------------------------------------------------------------------+
Sub patternSettings(cellName As String, patternScale As Double)
    Dim startPoint As Point3d
    Dim point As Point3d, point2 As Point3d
    Dim lngTemp As Long

'   Start a command
    CadInputQueue.SendCommand "PATTERN LINE ICON "
    
    ' Set cell name
    SetCExpressionValue "tcb->activePatternCell", cellName, "PATTERN"

'   Set a variable associated with a dialog box
    SetCExpressionValue "tcb->actpat_scale", patternScale, "PATTERN"

End Sub
