Attribute VB_Name = "RasterExport"
'----------------------------------------------------------------------+
' Module:   RasterExport.bas
'
' Status: WORKING
'
' Date:  02/02/04
'
' This example illustrates how to export a raster.1
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+
Option Explicit

Sub main()
    
    Dim oRaster As Raster
    Dim oBitmap As RasterBitmap
    Dim oFormat As RasterFormat
    Dim oOrigin As Point2d
    Dim oRasterExtent As Point2d
    Dim oRasterScan As Point2d
    Dim i As Integer
    Dim j As Integer

    oRasterExtent = RasterManager.Rasters(1).RasterInformation.Extent
    Set oBitmap = RasterManager.Rasters(1).GetBitmap(oRasterExtent, oOrigin, oRasterExtent)

    'Make black and white
    For i = 1 To oRasterExtent.X
        For j = 1 To oRasterExtent.Y
            If oBitmap.Pixel(i, j) < RGB(128, 128, 128) Then
               oBitmap.Pixel(i, j) = RGB(0, 0, 0)
            Else
               oBitmap.Pixel(i, j) = RGB(255, 255, 255)
            End If
        Next
    Next
    
    'Attach the raster
    Set oFormat = RasterManager.RasterFormats.Find("*TIFF*")
    oBitmap.ExportRaster "c:\bitmapTest.tiff", oFormat, oFormat.ColorModes(1), oFormat.ColorModes(1).CompressionModes(1), oFormat.ColorModes(1).CompressionModes(1).BlockTypes(1)
    Set oRaster = RasterManager.Rasters.Attach("c:\bitmapTest.tiff", msdView1)
    oRaster.GeoReferenceInformation.Origin = RasterManager.Rasters(1).GeoReferenceInformation.Origin
    oRaster.GeoReferenceInformation.Extent = RasterManager.Rasters(1).GeoReferenceInformation.Extent
    
    Application.RedrawAllViews
End Sub

