Attribute VB_Name = "Module1"
'-----------------------------------------------------------------------+
'
'   name        RefCopy
'
'   author      BSI                                             07/2002
'
'   Description: This example illustrates how to copy
'                elements from a reference file into the masterfile
'                then drop the reference file.
'
'-----------------------------------------------------------------------+

'-----------------------------------------------------------------------+
'
'   name        refCopy
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub refCopy(oAttachment As Attachment)

    Dim elType As Integer
    Dim oEnumerator As ElementEnumerator
    Dim oScanCriteria As New ElementScanCriteria
    
    
    oScanCriteria.ExcludeNonGraphical
    
    Set oEnumerator = oAttachment.Scan(oScanCriteria)

    Do While oEnumerator.MoveNext
        Dim oElement As Element

        Set oElement = oEnumerator.Current
        'Copy the element
        oElement.Clone
        'Add element to your file
        ActiveModelReference.AddElement oElement
         
         'Rewrite this object to model
        oElement.Rewrite
         'Redraw the object.
        oElement.Redraw msdDrawingModeNormal
        'Fit the view
        CadInputQueue.SendCommand "fit view"
        
    Loop
    'Remove the reference
    ActiveModelReference.Attachments.Remove oAttachment
        
End Sub

'-----------------------------------------------------------------------+
'
'   name        getRefAttachment
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub getRefAttachment(refName As String)

    Dim testVar As String
    Dim fileName() As String
    Dim fullFileName As String
    Dim oAttachment As Attachment
    Dim oAttachments As Attachments
    Dim attachmentExist As Boolean
    
    Set oAttachments = ActiveModelReference.Attachments
    
    For Each oAttachment In oAttachments
    
        ' Extract the file name. Other values can be extracted at this
        ' point. Instead of name, you could extract the logicalName or
        ' path.
        fullFileName = oAttachment.DesignFile.Name
        
        If refName = fullFileName Then
            attachmentExist = True
            refCopy oAttachment
            
             
        End If
    Next
   
    If attachmentExist = False Then
        ShowError refName + " is not attached"
    End If
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        Main
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub Main()

    Dim refName As String
    
    ' Specify reference file name to find
    refName = "refCopy.dgn"
    
    getRefAttachment refName
    
End Sub


