Attribute VB_Name = "reference"
Declare Function mdlRefFile_writeAttachmentConditionally Lib "stdmdlbltin.dll" (ByVal modelRef As Long) As Long
'-----------------------------------------------------------------------+
'
'   name        refDisplay
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Function refDisplay(strFileName As String, bDisplay As Boolean, Optional strModelName As String = "") As Boolean

    Dim oAttachment      As Attachment
    Dim oAttachments     As Attachments
    Dim tmpfileName      As String
    Dim strTmpModelName  As String
    Dim bModelName       As Boolean
    Dim bfileName        As Boolean
    Dim tmpDisplay       As Boolean
    Dim Success          As Integer
    Dim i As Integer
    Dim status           As Long
    
    'Assign a temporary variable
    tmpDisplay = bDisplay
 
    'Assign model name if provided
    If ("" <> strModelName) Then
        'Assign model name to a variable
        strTmpModelName = strModelName
        ' Set flag on
        bModelName = True
    Else
           'If no model name is provided. assign default model.
        If (strModelName = "") Then
           strModelName = "Default"
           strTmpModelName = strModelName
           bModelName = True
        End If
    End If

    ' Assign File Name if provided
    
    If ("" <> strFileName) Then
        tmpfileName = strFileName
        bfileName = True
    Else
       'If someone passes an empty filename string, print a message and exit.
        If (strFileName = "") Then
            Success = MsgBox("Must enter a filename", vbOKOnly + vbExclamation, "Invalid Filename")
            bfileName = False
            Exit Function
        End If
    End If

    ' If a file name and a model name is provided display info.
  If ((bfileName And bModelName)) Then
        ' Extract a list of all the model ref attachments
        Set oAttachments = ActiveModelReference.Attachments
            For Each oAttachment In oAttachments
              ' Ensure we process only model ref attachments
              If oAttachment.IsAttachment Then
                 
                 'Only process the correct file
                  If ((tmpfileName = oAttachment.AttachName) And (oAttachment.Name = strTmpModelName)) Then
                    
                    'Turn Display either on or off
                    oAttachment.ElementsVisible = tmpDisplay
                    
                    ' Rewite the attachment
                    mdlRefFile_writeAttachmentConditionally oAttachment.MdlModelRefP
                    
                  End If
              End If
            Next
  Else
      If (bfileName) Then
          ' Extract a list of all the model ref attachments
          Set oAttachments = ActiveModelReference.Attachments
              For Each oAttachment In oAttachments
                ' Ensure we process only model ref attachments
                If oAttachment.IsAttachment Then
                   'Only process the correct file
                   If (tmpfileName = oAttachment.AttachName) Then
                      'Turn Display either on or off
                      oAttachment.ElementsVisible = tmpDisplay
                       
                       mdlRefFile_writeAttachmentConditionally oAttachment.MdlModelRefP
                       
                   End If
                End If
              Next
      End If
  End If
         
         'Show a status to the user
        If (tmpDisplay = False) Then
            ShowPrompt "Display Turned off"
        Else
            ShowPrompt "Display turned on"
        End If
            ' set to true
            refDisplay = True
    Exit Function
End Function
'-----------------------------------------------------------------------+
'
'   name        referanceAttachments
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub referanceAttachments()
    Dim oLevel As Level
    Dim oDesignFile As DesignFile
    Dim counter As Integer
    Dim status As Integer
    
    'Get number of attachments
    counter = ActiveModelReference.Attachments.Count
    
On Error GoTo errorFlag
    
    For i = 1 To counter
    
        Set oDesignFile = ActiveModelReference.Attachments(i).DesignFile
        
        ' Turn off the display
        status = refDisplay(oDesignFile.Name, False)
        
        oDesignFile.MdlModelRefP
         
        ActiveModelReference.Attachments(i).IsHidden = True
                  
        'Redaw all the views
        RedrawAllViews
    
    Next i
    
errorFlag:
    
    'Null out GoTo
    On Error GoTo 0
    
End Sub


