Attribute VB_Name = "WorkDgn"
Option Explicit

'-----------------------------------------------------------------------+
'
'   Declare MDL Functions
'
'-----------------------------------------------------------------------+
Declare Function mdlWorkDgn_openFile Lib "stdmdlbltin.dll" (ByRef modelRef As Long, _
    ByRef pFormat As Long, ByRef pThreeD As Long, ByVal strFileName As String, _
    ByVal lngModelName As Long, ByVal lngReadOnly As Long) As Long

Declare Function mdlWorkDgn_closeFile Lib "stdmdlbltin.dll" _
    (ByVal modelRef As Long) As Long

'-----------------------------------------------------------------------+
'
'   name        WorkDgnCloseFile
'
'   author      BSI                                             09/2003
'
'-----------------------------------------------------------------------+
Sub WorkDgnCloseFile(modelRef As Long, oModelReference As ModelReference)

    If modelRef <> -1 Then
        ' Close the design file identified by the given model reference,
        ' saving all changes
        mdlWorkDgn_closeFile (modelRef)
        
        ' Set the ModelReference object to NULL
        Set oModelReference = Nothing
        modelRef = 0
    End If
End Sub

'-----------------------------------------------------------------------+
'
'   name        WorkDgnElementRemove
'
'   author      BSI                                             10/2003
'
'-----------------------------------------------------------------------+
Sub WorkDgnElementRemove(oModelReference As ModelReference, lngElementID As Long)
    
    Dim oElement        As Element
    Dim oEnumerator     As ElementEnumerator
    Dim oScanCriteria   As New ElementScanCriteria
    
    ' Exit if the DGN is read-only
    If oModelReference.IsReadOnly Then
        MsgBox "DGN is found but is read only"
        CommandState.StartDefaultCommand
        End
    End If
    
    ' Only scan for graphic elements
    oScanCriteria.ExcludeNonGraphical
    Set oEnumerator = oModelReference.Scan(oScanCriteria)

    ' Iterate through the model's elements to find the correct one
    While oEnumerator.MoveNext
        If oEnumerator.Current.ID.Low = lngElementID Then
            Set oElement = oEnumerator.Current
        
            ' Delete the element
            oModelReference.RemoveElement oElement
           
           Exit Sub
        End If
    Wend
    
    ' Set the Enumerator object to NULL
    Set oEnumerator = Nothing
    
    ' Set the ElementScanCriteria object to NULL
    Set oScanCriteria = Nothing
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        WorkDgnOpenFile
'
'   author      BSI                                             09/2003
'
'-----------------------------------------------------------------------+
Function WorkDgnOpenFile(strDGNFullPath As String, lngModelName As Long, _
                        lngReadOnly As Long) As ModelReference
    
    Dim lngStatus   As Long
    Dim lngFormat   As Long
    Dim lngIsThreeD As Long

    ' Opens the specified design file as a working file
    lngStatus = mdlWorkDgn_openFile(modelRef, lngFormat, lngIsThreeD, _
                                    strDGNFullPath, lngModelName, lngReadOnly)
    
    If lngStatus = 0 Then
        ' If lngStatus = 0 (SUCCESS) set the ModelReference object
        Set WorkDgnOpenFile = MdlGetModelReferenceFromModelRefP(modelRef)
        Exit Function
    Else
        ' Set the ModelReference object to NULL
        Set WorkDgnOpenFile = Nothing
        
        ' Close the DGN
        WorkDgnCloseFile modelRef, oModelReference
        
        Exit Function
    End If

End Function
