Attribute VB_Name = "Module1"
Option Explicit

'/*----------------------------------------------------------------------+
'|                                                                       |
'| Copyright 1993-2002, Bentley Systems, Incorporated                    |
'| All rights reserved.                                                  |
'|                                                                       |
'| Limited permission is hereby granted to reproduce and modify this     |
'| copyrighted material provided that the resulting code is used only in |
'| conjunction with Bentley Systems products under the terms of the      |
'| license agreement provided therein, and that this notice is retained  |
'| in its entirety in any such reproduction or modification.             |
'|                                                                       |
'+----------------------------------------------------------------------*/

' This VBA example will scan for only elements that are within the
' specified reference file attachment.

'-----------------------------------------------------------------------+
'
'   name        scanFile
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub scanFile(oAttachment As Attachment)

    Dim elType As Integer
    Dim oEnumerator As ElementEnumerator
    Dim oScanCriteria As New ElementScanCriteria
    
    oScanCriteria.ExcludeNonGraphical
    
    Set oEnumerator = oAttachment.Scan(oScanCriteria)

    Do While oEnumerator.MoveNext
        Dim oElement As Element

        Set oElement = oEnumerator.Current
        
        '========================
        'Process elements here!!!
        '========================
    Loop
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        getRefAttachment
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub getRefAttachment(refName As String)

    Dim testVar As String
    Dim fileName() As String
    Dim fullFileName As String
    Dim oAttachment As Attachment
    Dim oAttachments As attachments
    Dim attachmentExist As Boolean
    
    Set oAttachments = ActiveModelReference.attachments
    
    For Each oAttachment In oAttachments
    
        ' Extract the file name. Other values can be extracted at this
        ' point. Instead of name, you could extract the logicalName or
        ' path.
        fullFileName = oAttachment.DesignFile.Name
        
        If refName = fullFileName Then
            attachmentExist = True
            scanFile oAttachment
        End If
    Next
   
    If attachmentExist = False Then
        ShowError refName + " is not attached"
    End If
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        Main
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Sub Main()

    Dim refName As String
    
    ' Specify reference file name to find
    refName = "ref1.dgn"
    
    getRefAttachment refName

End Sub
