VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Extras"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
' This property will return the Element name from the element type integer
Public Property Get ElementTypeName(ByVal eType As Integer) As String
    Select Case eType
    Case 1: ElementTypeName = "Cell Library Header"
    Case 2: ElementTypeName = "Cell Header"
    Case 3: ElementTypeName = "Line"
    Case 4: ElementTypeName = "Line String"
    Case 6: ElementTypeName = "Shape"
    Case 7: ElementTypeName = "Text Node"
    Case 11: ElementTypeName = "Curve"
    Case 12: ElementTypeName = "Complex String"
    Case 14: ElementTypeName = "Complex Shape"
    Case 15: ElementTypeName = "Ellipse"
    Case 16: ElementTypeName = "Arc"
    Case 17: ElementTypeName = "Text"
    Case 18: ElementTypeName = "Surface"
    Case 19: ElementTypeName = "Solid"
    Case 21: ElementTypeName = "BSpline Pole"
    Case 22: ElementTypeName = "Point String"
    Case 23: ElementTypeName = "Cone"
    Case 24: ElementTypeName = "BSpline Surface"
    Case 25: ElementTypeName = "BSpline Boundary"
    Case 26: ElementTypeName = "BSpline Knot"
    Case 27: ElementTypeName = "BSplinr Curve"
    Case 28: ElementTypeName = "BSpline Weight"
    Case 33: ElementTypeName = "Dimension"
    Case 34: ElementTypeName = "Shared Cell Definition"
    Case 35: ElementTypeName = "Shared Cell"
    Case 36: ElementTypeName = "MultiLine"
    Case 37: ElementTypeName = "Tag"
    Case 87: ElementTypeName = "Raster Header"
    Case 88: ElementTypeName = "Raster Comonent"
    Case Else: ElementTypeName = "NOT FOUND: " & eType
    End Select
End Property
' This Property will return the color value from the text color passed
Public Property Get ColorVal(color As String) As Integer

    Select Case color
    Case "White"
        ColorVal = 0
    Case "Blue"
        ColorVal = 1
    Case "Green"
        ColorVal = 2
    Case "Red"
        ColorVal = 3
    Case "Yellow"
        ColorVal = 4
    Case "Magenta"
        ColorVal = 5
    Case "Brown"
        ColorVal = 6
    Case "LBlue"
        ColorVal = 7
    End Select
End Property

Private Function ElementArea(oElement As Element) As Double

    Select Case oElement.Type
    Case 6
        ElementArea = oElement.AsShapeElement.Area
    Case 15
        ElementArea = oElement.AsEllipseElement.Area
    End Select
End Function

' This function checks if an element of the passed type has already been added
' to the TreeView. Returns True if it is already in the tree, False otherwise.
Private Function ChkTree4Dups(elemType As Integer, oTreeView As Object) As Boolean
    Dim oNode As node
    
    ChkTree4Dups = False
    For Each oNode In oTreeView.Nodes
        If oNode.Key = "P" + CStr(elemType) Then
            ChkTree4Dups = True
        End If
    Next
End Function
' This Function checks if the element passed is a Text element.
' If it is then the text string is returned. Otherwise
' a Null string is returned
Private Function TypeChk(typ As Integer, oElement As Element) As String

    If typ = 17 Then
        TypeChk = oElement.AsTextElement.Text + " , "
    Else
        TypeChk = ""
    End If
End Function

' This Property adds the info to the TreeView. In this case it adds
' the Element type by name as the Parent. The children are the elements
' Unique Id number
Public Sub BuildTree(oElement As Element, oTreeView1 As TreeView)
    Dim parentID As String
    Dim cExtras As New Extras
    
    'The variable will have a value of P plus the element type number.
    parentID = "P" & CStr(oElement.Type)
    
    ' If Chktree4Dups returns a True the Else is executed. If a False
    ' is returned the code before the else is executed
    If Not ChkTree4Dups(oElement.Type, oTreeView1) Then
        ' Adds the Element name to the TreeView as the Parent
        oTreeView1.Nodes.Add , , parentID, cExtras.ElementTypeName(oElement.Type) _
                                + " (" + CStr(oElement.Type) + ")"
        ' Adds the Element Unique ID to the parent as a child
        oTreeView1.Nodes.Add parentID, tvwChild, , TypeChk(oElement.Type, oElement) _
                                + DLongToString(oElement.ID)
    Else
        ' If the Parent already exists then this is added as a child
        ' to the existing parent
        oTreeView1.Nodes.Add parentID, tvwChild, , TypeChk(oElement.Type, oElement) _
                                + DLongToString(oElement.ID)
    End If
    Select Case oElement.Type
    Case msdElementTypeShape
        oTreeView1.Nodes.Add oTreeView1.Nodes.Count, tvwChild, , "Area: " & oElement.AsShapeElement.Area
    Case msdElementTypeEllipse
        oTreeView1.Nodes.Add oTreeView1.Nodes.Count, tvwChild, , "Area: " & Format(oElement.AsEllipseElement.Area, "##.###")
    End Select
End Sub

' This Property returns the wheight value from the weight
' name passed.
Public Property Get WeightVal(weight As String) As Integer
    Select Case weight
    Case "Line Weight 0"
        WeightVal = 0
    Case "Line Weight 1"
        WeightVal = 1
    Case "Line Weight 2"
        WeightVal = 2
    Case "Line Weight 3"
        WeightVal = 3
    Case "Line Weight 4"
        WeightVal = 4
    Case "Line Weight 5"
        WeightVal = 5
    Case "Line Weight 6"
        WeightVal = 6
    Case "Line Weight 7"
        WeightVal = 7
    Case "Line Weight 8"
        WeightVal = 8
    End Select
End Property
