VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} TreeChgElem 
   Caption         =   "VBA Demo"
   ClientHeight    =   4305
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6840
   OleObjectBlob   =   "TreeChgElem.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "TreeChgElem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' If the check box is checked the radio buttons are disabled
Private Sub AllElmChk_Click()
    If AllElmChk.Value Then
        EllipseRadio.Enabled = False
        ShapeRadio.Enabled = False
    Else
        EllipseRadio.Enabled = True
        ShapeRadio.Enabled = True
    End If
End Sub
' Exits application
Private Sub ExitBtn_Click()
    End
End Sub



' Sets up the scan criteria and scans the design file
Private Sub ScanBtn_Click()
    Dim oElement As Element
    Dim oScanCriteria As New ElementScanCriteria
    Dim oEnumerator As ElementEnumerator
    Dim cExtras As New Extras
    
    TreeView1.Nodes.Clear
    
    ' If the check box is checked then the oScanCriteria is reset
    ' to select all elements
    If AllElmChk.Value Then
        oScanCriteria.Reset
        oScanCriteria.ExcludeNonGraphical
    Else
        ' If the check box is not checked then depending on which
        ' radio button is selected
        oScanCriteria.ExcludeAllTypes ' Excludes all element types from search
        If EllipseRadio Then
            oScanCriteria.IncludeType (msdElementTypeEllipse)  ' oScanCriteria inclues only Ellipses
        Else
            oScanCriteria.IncludeType (msdElementTypeShape)    ' oScanCriteria includes only Shapes
        End If
    End If
    
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)  ' Scans design file
    
    ' The following Do..While steps through all the elements in the
    ' oEnumerator and calls the BuildTree property in the oExtras class
    Do While oEnumerator.MoveNext
        Set oElement = oEnumerator.Current
        cExtras.BuildTree oElement, TreeView1
    Loop
End Sub
' When a child has been clicked on in the TreeView this Sub
' Gets the Unique ID and selects that element
Private Sub TreeView1_NodeClick(ByVal node As ComctlLib.node)
    Dim elemNum As DLong
    Dim oElement As Element
    Dim typName As New Extras
    
    ' Only selects second node in tree
    If node.Children = 1 Then
        ' Gets the Unique ID of the node selected
        elemNum = DLongFromString((Mid(TreeView1.Nodes(node.Index).Text, InStr(TreeView1.Nodes(node.Index).Text, ",") + 1)))

        ' Select the element
        Set oElement = ActiveDesignFile.GetElementByID(elemNum)
        
        ' Change the elements color and weight
        With oElement
            .color = typName.ColorVal(ListBox1.List(ListBox1.ListIndex))
            .LineWeight = typName.WeightVal(ComboBox1.Text)
            .Rewrite    ' Writes to design file
        End With
        MicroStationDGN.RedrawAllViews msdDrawingModeNormal    ' Redraw views
    End If
End Sub
' The ListBox and ComboBox are loaded with the items to be selected.
Private Sub UserForm_Initialize()
    ListBox1.AddItem "Green"
    ListBox1.AddItem "Red"
    ListBox1.AddItem "White"
    ListBox1.AddItem "Yellow"
    
    ListBox1.Text = "White"
    
    ComboBox1.AddItem "Line Weight 0"
    ComboBox1.AddItem "Line Weight 1"
    ComboBox1.AddItem "Line Weight 2"
    ComboBox1.AddItem "Line Weight 3"
    
    ComboBox1.Text = "Line Weight 0"
End Sub
