VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} UserForm1 
   Caption         =   "Scanner"
   ClientHeight    =   1890
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2145
   OleObjectBlob   =   "UserForm1.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "UserForm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'-----------------------------------------------------------------------+
'                                                                       |
' Copyright: (c) 2003 Bentley Systems, Incorporated. All rights reserved.
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' scantxt2dile
'
' Status: WORKING
'
' Date: 10/30/03
'
' This example scans the DGN for elements, then creates an ASCII text file
'
' Author: BSI                                     10/30/03
'
'-----------------------------------------------------------------------+
'This variable re-populates the comboBox
Private comboLabel As String
'-----------------------------------------------------------------------+
'
'   name        FileGetShortPath
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Function FileGetShortPath(filespec As String) As String
   
    Dim fs As Object
    Dim f  As Object
    
    'File object
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFile(filespec)
    'ShortPath property
    FileGetShortPath = f.ShortPath
    
End Function
'-----------------------------------------------------------------------+
'
'   name        fileSaveAsAscii
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Sub fileSaveAsAscii(elementInfo As String)

    Dim saveas As New CommonDialog

    'Use Common Dialog for a "Save As" dialog box
    saveas.DialogTitle = "Save as an ASCII Text File"
    saveas.Filter = "Text Documents (*.txt)"
    saveas.DefaultExt = "txt"
    saveas.ShowSave
        
    If saveas.FileName <> "" Then
        
        Open saveas.FileName For Output As 1
        Print #1, elementInfo
        Close #1
    
        'Prompt user to view text file in Wordpad
        reply = MsgBox("Would you like to open " & saveas.FileName & " for viewing in Wordpad?", vbInformation + _
                                                   vbOKCancel + vbDefaultButton1, "open Wordpad")
            
    Else
        reply = vbCancel
    End If
    
    If reply = vbOK Then
        
        'Handles spaces and long filenames
        saveas.FileName = FileGetShortPath(saveas.FileName)
                    
        'Run Microsoft Wordpad
        ReturnValue = Shell("notepad " & saveas.FileName, 1)
        
        'Activate Microsoft Wordpad
        AppActivate ReturnValue
   
    End If
            
End Sub
'-----------------------------------------------------------------------+
'
'   name        elemNameFromNumber
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Public Function elemNameFromNumber(ByVal eType As Integer) As String
     
    Select Case eType
    
        Case 1: elemNameFromNumber = "Cell Library Header          "
        Case 2: elemNameFromNumber = "Cell Header                  "
        Case 3: elemNameFromNumber = "Line                         "
        Case 4: elemNameFromNumber = "Line String                  "
        Case 5: elemNameFromNumber = "Group Data                   "
        Case 6: elemNameFromNumber = "Shape                        "
        Case 7: elemNameFromNumber = "Text Node                    "
        Case 8: elemNameFromNumber = "Digitizer Setup Data         "
        Case 9: elemNameFromNumber = "Design File Header           "
        Case 10: elemNameFromNumber = "Level Symbology              "
        Case 11: elemNameFromNumber = "Curve                        "
        Case 12: elemNameFromNumber = "Complex String               "
        Case 13: elemNameFromNumber = "Conic                        "
        Case 14: elemNameFromNumber = "Complex Shape                "
        Case 15: elemNameFromNumber = "Ellipse                      "
        Case 16: elemNameFromNumber = "Arc                          "
        Case 17: elemNameFromNumber = "Text                         "
        Case 18: elemNameFromNumber = "Surface                      "
        Case 19: elemNameFromNumber = "Solid                        "
        Case 21: elemNameFromNumber = "BSpline Pole                 "
        Case 22: elemNameFromNumber = "Point String                 "
        Case 23: elemNameFromNumber = "Cone                         "
        Case 24: elemNameFromNumber = "BSpline Surface              "
        Case 25: elemNameFromNumber = "BSpline Boundary             "
        Case 26: elemNameFromNumber = "BSpline Knot                 "
        Case 27: elemNameFromNumber = "BSplinr Curve                "
        Case 28: elemNameFromNumber = "BSpline Weight               "
        Case 33: elemNameFromNumber = "Dimension                    "
        Case 34: elemNameFromNumber = "Shared Cell Definition       "
        Case 35: elemNameFromNumber = "Shared Cell                  "
        Case 36: elemNameFromNumber = "MultiLine                    "
        Case 37: elemNameFromNumber = "Tag                          "
        Case 38: elemNameFromNumber = "DgnStore Component           "
        Case 39: elemNameFromNumber = "DgnStore Header              "
        Case 51: elemNameFromNumber = " ARCH (Intergraph)           "
        Case 54: elemNameFromNumber = "SDS (Intergraph)             "
        Case 56: elemNameFromNumber = "LEDS, WMS                    "
        Case 60: elemNameFromNumber = "SIS                          "
        Case 61: elemNameFromNumber = "EWS SCREMANC                 "
        Case 62: elemNameFromNumber = "EWS PANEL                    "
        Case 63: elemNameFromNumber = "EWS PDS                      "
        Case 66: elemNameFromNumber = "MicroStation Application     "
        Case 87: elemNameFromNumber = "Raster Header                "
        Case 88: elemNameFromNumber = "Raster Component             "
        Case 89: elemNameFromNumber = "Raster Data                  "
        Case 90: elemNameFromNumber = "Raster Reference Attachment  "
        Case 91: elemNameFromNumber = "Raster Reference Component   "
        Case 96: elemNameFromNumber = "Level Table                  "
        Case 97: elemNameFromNumber = "View Group Element           "
        Case 98: elemNameFromNumber = "View Element                 "
        Case 99: elemNameFromNumber = "Level Mask Element           "
        Case 100: elemNameFromNumber = "Reference Attach Element    "
        Case 101: elemNameFromNumber = "Matrix Header               "
        Case 102: elemNameFromNumber = "Matrix Int Data             "
        Case 103: elemNameFromNumber = "Matrix Double Data          "
        Case 105: elemNameFromNumber = "Mesh Header                 "
        Case Else: elemNameFromNumber = "Type                       " + CStr(eType)
    
    End Select
    
End Function
'-----------------------------------------------------------------------+
'
'   name        scanFile
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Private Function scanFile() As String
    
    Dim oScanCriteria          As New ElementScanCriteria
    Dim oEnumerator            As ElementEnumerator
    Dim count                  As Integer
    Dim message                As String
    Dim elementCount(1 To 127) As Double
    Dim i                      As Integer
    Dim dan
       
    'Counter
    count = 0
        
    'Clear out any previous scans
    oScanCriteria.Reset
                
    'Set enumerator
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)
     
    'Title
    message = message + "Elements Type" + vbTab + vbTab + vbTab + "Element-ID" + vbTab + "Level" + vbTab + vbTab + "Color" + vbTab + "LineStyle" + vbTab + "Weight"
                                                                                                       
    message = message + vbCrLf + "======================================================================================" + vbCrLf
    
    'Step through every element in the file
    Do While oEnumerator.MoveNext
        With oEnumerator.Current
            
            count = count + 1
            If (.Type <> 0) Then
            
            
                'Count element types
                elementCount(.Type) = elementCount(.Type) + 1
                
                ' Create element data
                message = message + elemNameFromNumber(.Type) + vbTab
                message = message + DLongToString(.ID) + vbTab
                
                If (.IsGraphical) Then
                
                    message = message + vbTab + CStr(.Level.Name) + vbTab
               
                    'Determines if the color is byLevel then get's the correct value
                    If .ColorSource = msdValueSourceLevel Then
                        message = message + CStr(.Level.ElementColor) + vbTab
                    Else
                        message = message + CStr(.Color) + vbTab
                    End If
                
                    'Determines if the linestyle is byLevel then get's the correct value
                    If .LineStyle.Name = "ByLevel" Then
                        message = message + CStr(.Level.ElementLineStyle.Name) + "[ByLevel]" + vbTab
                    Else
                        message = message + CStr(.LineStyle.Name) + vbTab + vbTab
                    End If
                    
                    'Determines if the weight is byLevel then get's the correct value
                    If .LineWeight = ByLevelLineWeight Then
                        message = message + CStr(.Level.ElementLineWeight) + "[ByLevel]" + vbTab
                    Else
                        message = message + CStr(.LineWeight) + vbTab
                    End If
                    
                End If
                
                message = message + vbCrLf
            
            End If
            
        End With
    Loop
       
    message = message + "======================================================================================" + vbCrLf
    
    'Report element count
    For i = 1 To 127
        
        If (elementCount(i) <> 0) Then
            message = message + elemNameFromNumber(i) + vbTab + CStr(elementCount(i)) + vbCrLf
        End If
        
    Next i
    
    message = message + "======================================================================================" + vbCrLf
    message = message + "Total Elements = " + CStr(count)
 
    'Return report data
    scanFile = Left$(message, Len(message))
    
End Function
'-----------------------------------------------------------------------+
'
'   name        scanText
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Private Function scanText() As String
    
    Dim oScanCriteria           As New ElementScanCriteria
    Dim oEnumerator             As ElementEnumerator
    Dim count                   As Integer
    Dim message                 As String
    Dim elementCount(1 To 127)  As Integer
    Dim i                       As Integer
    Dim element                 As element
       
    'Counter
    count = 0
        
    'Clear out any previous scans
    oScanCriteria.Reset
    
    'Scanning for type 17 text elements only
    oScanCriteria.IncludeType msdText
                   
    'Set enumerator
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)

    'Title
    message = message + "Type 17 Text Elements" + vbTab + vbTab + "Element-ID" + vbTab + "Level" + vbTab + vbTab + vbTab + "Color" + vbTab + "LineStyle" + vbTab + "Weight" + vbTab + "String Value"
                                                          
    message = message + vbCrLf + "============================================================================================================================================================" + vbCrLf
    
    'Find all type 17 text strings
    Do While oEnumerator.MoveNext
        With oEnumerator.Current
            
            If (.Type <> 0) Then
            
                If .IsTextElement Then
                    
                    count = count + 1
                    
                    UserForm1.ComboBox1.Text = .AsTextElement.Text
                             
                    'Create element data
                    message = message + elemNameFromNumber(.Type) + vbTab
                    message = message + DLongToString(.ID) + vbTab
                    message = message + vbTab + CStr(.Level.Name) + vbTab + vbTab
                    
                    'Determines if the color is byLevel then get's the correct value
                    If .ColorSource = msdValueSourceLevel Then
                        message = message + CStr(.Level.ElementColor) + vbTab
                    Else
                        message = message + CStr(.Color) + vbTab
                    End If
                    
                    'Determines if the linestyle is byLevel then get's the correct value
                    If .LineStyle.Name = "ByLevel" Then
                        message = message + CStr(.Level.ElementLineStyle.Name) + "[ByLevel]" + vbTab
                    Else
                        message = message + CStr(.LineStyle.Name) + vbTab + vbTab
                    End If
                    
                    'Determines if the weight is byLevel then get's the correct value
                    If .LineWeight = ByLevelLineWeight Then
                        message = message + CStr(.Level.ElementLineWeight) + "[ByLevel]" + vbTab
                    Else
                        message = message + CStr(.LineWeight) + vbTab
                    End If
                    
                    message = message + .AsTextElement.Text + vbTab
                    message = message + vbCrLf
                    
                End If
            End If
            
        End With
    Loop
       
    message = message + "============================================================================================================================================================" + vbCrLf
    message = message + "============================================================================================================================================================" + vbCrLf
    message = message + "Total Elements = " + CStr(count)
 
    'Return report data
    scanText = Left$(message, Len(message))
    
    ComboBox1.Text = comboLabel
    
End Function

Private Sub ComboBox1_Change()

End Sub

'-----------------------------------------------------------------------+
'
'   name        CommandButton1_Click
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Private Sub CommandButton1_Click()

    Dim elementInfo As String
    Dim textTest As String
    
    'All elements will process
    If ComboBox1.Text = "All Elements" Then
        comboLabel = "All Elements"
        elementInfo = scanFile
        
    Else
    
        'All text will process
        If ComboBox1.Text = "Text" Then
            comboLabel = "Text"
            elementInfo = scanText
        End If
              
    End If
    
    Call fileSaveAsAscii(elementInfo)
 
End Sub

Private Sub CommonDialog1_Enter()

End Sub

'-----------------------------------------------------------------------+
'
'   name        UserForm_Initialize
'
'   author      BSI                                          10/2001
'
'-----------------------------------------------------------------------+
Private Sub UserForm_Initialize()
    
    'The titles will be added to the combo box
    MyComboBox = Array("All Elements", "Text")
    
    For i = 0 To 1
        ComboBox1.AddItem MyComboBox(i)
    Next

End Sub
