Attribute VB_Name = "SnapModeGetSet"
Option Explicit

'-----------------------------------------------------------------------+
'
'   SnapModeGetSetActive.mvba
'   1.0
'   01.27.2004
'
'   Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
'----------------------------------------------------------------------+
'----------------------------------------------------------------------+
'
'   STATUS: WORKING
'   DATE:   01/27/2004
'
'   This example illustrates how to get and set the snap mode's active
'   and override settings.
'
'----------------------------------------------------------------------+
'----------------------------------------------------------------------+
'
'   Function Declarations
'
'----------------------------------------------------------------------+
Declare Function mdlParams_getActive Lib "stdmdlbltin.dll" (ByVal param _
                                As Long, ByVal paramName As Long) As Long
Declare Function mdlParams_setActive Lib "stdmdlbltin.dll" (ByVal param As _
                                Long, ByVal paramName As Long) As Long

'----------------------------------------------------------------------+
'
'   Constant Variables
'
'----------------------------------------------------------------------+
' Snap Mode Constants
Const SNAP_MODE_NEAREST = 1
Const SNAP_MODE_NEAREST_KEYPOINT = 2
Const SNAP_MODE_MIDPOINT = 4
Const SNAP_MODE_CENTER = 8
Const SNAP_MODE_ORIGIN = 16
Const SNAP_MODE_BISECTOR = 32
Const SNAP_MODE_INTERSECTION = 64
Const SNAP_MODE_TANGENCY = 128
Const SNAP_MODE_PERPENDICULAR = 512

' Active Parameter Constants
Const ACTIVEPARAM_SNAPOVERRIDE = 47
Const ACTIVEPARAM_SNAPMODE = 501

'----------------------------------------------------------------------+
'
'   Name        SnapModeGetActive
'
'   Author      BSI-DEVSPT                                  01/2004
'
'----------------------------------------------------------------------+
Function SnapModeGetActive() As Long
    
    Dim status              As Long
    Dim lngSnapModeActive   As Long

    status = mdlParams_getActive(VarPtr(lngSnapModeActive), ACTIVEPARAM_SNAPMODE)
    SnapModeGetActive = lngSnapModeActive

End Function

'----------------------------------------------------------------------+
'
'   Name        SnapModeGetOverride
'
'   Author      BSI-DEVSPT                                  01/2004
'
'----------------------------------------------------------------------+
Function SnapModeGetOverride() As Long
    
    Dim status              As Long
    Dim lngSnapModeOverride As Long

    status = mdlParams_getActive(VarPtr(lngSnapModeOverride), ACTIVEPARAM_SNAPOVERRIDE)
    SnapModeGetOverride = lngSnapModeOverride

End Function

'----------------------------------------------------------------------+
'
'   Name        SnapModeSetActive
'
'   Author      BSI-DEVSPT                                  01/2004
'
'----------------------------------------------------------------------+
Sub SnapModeSetActive(lngSnapMode As Long)

    Dim status As Long
    status = mdlParams_setActive(VarPtr(lngSnapMode), ACTIVEPARAM_SNAPMODE)

End Sub

'----------------------------------------------------------------------+
'
'   Name        SnapModeSetOverride
'
'   Author      BSI-DEVSPT                                  01/2004
'
'----------------------------------------------------------------------+
Sub SnapModeSetOverride(lngSnapMode As Long)

    Dim status As Long
    status = mdlParams_setActive(VarPtr(lngSnapMode), ACTIVEPARAM_SNAPOVERRIDE)

End Sub

'----------------------------------------------------------------------+
'
'   Name        startApp
'
'   Author      BSI-DEVSPT                                  01/2004
'
'----------------------------------------------------------------------+
Sub startApp()
    
    Dim lngSnapMode As Long
    
    ' Get the active snap mode
    lngSnapMode = SnapModeGetActive
    
    ' Get the override snap mode
    lngSnapMode = SnapModeGetOverride
    
    ' Set the active snap mode
    Call SnapModeSetActive(SNAP_MODE_CENTER)
    
    ' Set the override snap mode
    Call SnapModeSetOverride(SNAP_MODE_MIDPOINT)

End Sub
