Attribute VB_Name = "Module1"
Option Explicit

'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2003, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' SolidGetVolumeProps
'
' Status: WORKING
'
' This example illustrates how to extract a solid's properties by using
' the MDL function mdlMeasure_volumeProperties().
'
' Author: BSI                                                   07/21/03
'
'-----------------------------------------------------------------------+
'-----------------------------------------------------------------------+
'
'   name        PropertiesGet
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Sub PropertiesGet(Element As Element)

    Dim volumeP As Double
    Dim areaP As Double
    Dim closureErrorP As Double
    Dim iXYP As Double
    Dim iXZP As Double
    Dim iYZP As Double
    Dim tol As Double
    Dim pCentroid As Point3d
    Dim pMoment As Point3d
    Dim pPrincipalMoments As Point3d
    Dim pPrincipalDirections As Point3d
    Dim retValue As Long
    
    tol = 0.1
    
    If Element.Type = msdElementTypeSolid Then
    
        retValue = GetCExpressionValue("mdlMeasure_volumeProperties (" & _
        VarPtr(volumeP) & "," & _
        VarPtr(areaP) & "," & _
        VarPtr(closureErrorP) & "," & _
        VarPtr(pCentroid) & "," & _
        VarPtr(pMoment) & "," & _
        VarPtr(iXYP) & "," & _
        VarPtr(iXZP) & "," & _
        VarPtr(iYZP) & "," & _
        VarPtr(pPrincipalMoments) & "," & _
        VarPtr(pPrincipalDirections) & "," & _
        Element.MdlElementDescrP & "," & _
        tol & "," & _
        " 0)")
        
        If retValue = 0 Then
        
            Debug.Print "Volume: " & volumeP
            Debug.Print "Area: " & areaP
            Debug.Print "ClosureError: " & closureErrorP
            Debug.Print "Centroid: "; pCentroid.X; pCentroid.Y; pCentroid.Z
            Debug.Print "Second moments: "; pMoment.X; pMoment.Y; pMoment.Z
            Debug.Print "Inertia(xy): " & iXYP
            Debug.Print "Inertia(xz): " & iXZP
            Debug.Print "Inertia(yz): " & iYZP
            Debug.Print "Principal second moments: "; pPrincipalMoments.X; pPrincipalMoments.Y; pPrincipalMoments.Z
            Debug.Print "Principal axes: "; pPrincipalDirections.X; pPrincipalDirections.Y; pPrincipalDirections.Z
        Else
            Debug.Print "Returned error: " & retValue
        End If
    End If
End Sub

'-----------------------------------------------------------------------+
'
'   name        SolidGetVolProps
'
'   author      BSI                                             07/2003
'
'-----------------------------------------------------------------------+
Sub SolidGetVolProps()
    CommandState.StartLocate New SolidGetVolumeProps
End Sub

