VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PlaceTickCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------
' PlaceTickCommand
'
' Status: WORKING
'
' Date: 5/16/2002
'
' This example illustrates how to palce a parasolid tick mark.
'
' Author: BSI
'
'----------------------------------------------------------------------------
Implements IPrimitiveCommandEvents

Public TICKSIZE As Double
Private tick As CellElement 'Tick Mark
Private ncount As Integer   'Counter flag for points
'-----------------------------------------------------------------------+
'
'   name        VBAcreateTick
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Public Function VBAcreateTick(Point As Point3d, size As Double) As CellElement
    Dim nResult As Integer
    Dim newPTick As CellElement
    Dim elmP As Long

    'create a new tick mark in memory
    nResult = GetCExpressionValue("createPTick (" & VarPtr(elmP) & "," & _
                                  size / 2 & "," & size & "," & size / 2 _
                                  & ")", "solid")
     
    ' Create a cell element that will be the tick mark
    Set newPTick = MdlCreateElementFromElementDescrP(elmP)
    
    ' Return the tick mark
    Set VBAcreateTick = newPTick
 
End Function
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Cleanup
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_DataPoint
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal View As View)
         
    'Create a tick mark
    Set tick = VBAcreateTick(Point, TICKSIZE)
     
    'Move tick to point
    tick.Move Point
    
    ' Invert the matrix and trans form the element
    tick.Transform Transform3dFromMatrix3dAndFixedPoint3d(Matrix3dTranspose(View.Rotation), Point)
         
    'Add Tick mark to design file
    ActiveModelReference.AddElement tick
    
    'Display tick mark
    tick.Redraw msdDrawingModeNormal
    
End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Dynamics
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Dim oEl As CellElement
    Dim pntFixed As Point3d
    Dim pntFixed2 As Point3d
    
    'Create tick mark
    Set oEl = VBAcreateTick(Point, TICKSIZE)
    
    'Move tick to point
    oEl.Move Point
     
    ' Invert the matrix and trans form the element
     oEl.Transform Transform3dFromMatrix3dAndFixedPoint3d(Matrix3dTranspose(View.Rotation), Point)
    
    ' Draw element
    oEl.Redraw DrawMode
     
End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Keyin
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Reset
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Reset()
    
    'Set Flag to 0
    ncount = 0
        
    CommandState.StartPrimitive Me
  
End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Start
'
'   author      BSI                                             05/2002
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Start()
    
    Dim Point As Point3d
    
    ' Size of the tick mark
    TICKSIZE = 1
    
    'Prompt user
    ShowCommand "Place Tick Command"
    ShowPrompt "Place Tick Mark"
  
    'Start dynamics
    CommandState.StartDynamics

End Sub

