Attribute VB_Name = "BrowseFolders"
'----------------------------------------------------------------------------
' BrowseFolders
'
' Status: WORKING
'
' Date: 11/15/01
'
' This example illustrates how brows for Folders, Networks and printers.
'
' Author: BSI                                     11/15/01
'
'----------------------------------------------------------------------------
'*----------------------------------------------------------------------+
'
'   Constants
'
'----------------------------------------------------------------------*/
Private Const SUCCESS As Long = 0
Private Const MAX_PATH As Long = 260
Private Const FILE_MYCOMPUTER As Long = 0

'Device const
Private Const FILE_DEVICE_NETWORK As Long = &H12
Private Const FILE_DEVICE_CD_ROM As Long = &H2
Private Const FILE_DEVICE_DISK_FILE_SYSTEM As Long = &H8
Private Const FILE_DEVICE_PARALLEL_PORT As Long = &H16
Private Const FILE_DEVICE_PRINTER As Long = &H18
Private Const FILE_DEVICE_SERIAL_PORT As Long = &H1B
Private Const FILE_DEVICE_TAPE As Long = &H1F
Private Const FILE_DEVICE_SMARTCARD As Long = &H31
Private Const FILE_DEVICE_VIRTUAL_DISK As Long = &H24

' Browsing for directory Return type.
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_EDITBOX = &H10
Private Const BIF_VALIDATE = &H20

' Browsing for directory.
Private Const BIF_BROWSEFORCOMPUTER As Long = &H1000
Private Const BIF_BROWSEFORPRINTER As Long = &H2000
Private Const BIF_BROWSEINCLUDEFILES As Long = &H4000

'*----------------------------------------------------------------------+
'
'   Types
'
'----------------------------------------------------------------------*/
Private Type BROWSEINFO 'BI
   hOwner As Long
   pidlRoot As Long
   pszDisplayName As String
   lpszTitle As String
   ulFlags As Long
   lpfn As Long
   lParam As Long
   iImage As Long
End Type

'*----------------------------------------------------------------------+
'
'   Function Declarations
'
'----------------------------------------------------------------------*/
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
   Alias "SHBrowseForFolderA" _
  (lpBrowseInfo As BROWSEINFO) As Long

Private Declare Function SHGetSpecialFolderLocation _
   Lib "shell32.dll" _
  (ByVal hwndOwner As Long, _
   ByVal nFolder As Long, _
   pidl As Long) As Long
   
Declare Function SHGetPathFromIDList _
    Lib "shell32" _
    (ByVal pidList As Long, _
    ByVal lpBuffer As String) _
    As Long

Function AsciiZ(text As String) As String

Dim i As Long
i = InStr(text, Chr(0))
If i = 0 Then
    AsciiZ = text
Else
    AsciiZ = Left(text, i - 1)
End If
End Function

'*----------------------------------------------------------------------+
'
'   name        BrowseFolders
'
'   author      BSI                                         11/2001
'
'----------------------------------------------------------------------*/
Private Function BrowseFolders(BIFflags As Long, deviceFlag As Long, title As String) As String
   Dim BI As BROWSEINFO
   Dim pidl As Long
   Dim sPath As String
   Dim pos As Integer
   Dim hWnd As Long
   Dim path As String
   Dim lpIDList As Long
   Dim iNull As Integer

   If BIFflags = BIF_RETURNONLYFSDIRS Then
    SHGetSpecialFolderLocation hWnd, deviceFlag, pidl
   End If
      With BI
         .hOwner = 0
        'Pointer to the item identifier list specifying
        'the location of the "root" folder to browse from.
         .pidlRoot = pidl
         .pszDisplayName = Space$(MAX_PATH)
        'Title to be displayed in the Browse dialog
         .lpszTitle = title
        'The type of folder to return
         .ulFlags = BIFflags
      End With
     
    lpIDList = SHBrowseForFolder(BI)
    If lpIDList Then
        ' Size string
        path = String$(MAX_PATH, 0)
        
        ' Get path
        SHGetPathFromIDList lpIDList, path
                
        'free the block of memory
        CoTaskMemFree lpIDList
                
        ' See if sting is null terminated
        iNull = InStr(path, vbNullChar)
                
        If iNull Then
            path = Left$(path, iNull - 1)
        End If
    
        'Return full path of folder
        BrowseFolders = path
            
        End If
   
End Function
'*----------------------------------------------------------------------+
'
'   name        displayPath
'
'   author      BSI                                         11/2001
'
'----------------------------------------------------------------------*/
Sub displayPath()
    
    'Select a computer
    MsgBox BrowseFolders(BIF_RETURNONLYFSDIRS, FILE_MYCOMPUTER, "*** Select Computer ***")
    
    'Select a network folder
    MsgBox BrowseFolders(BIF_RETURNONLYFSDIRS, FILE_DEVICE_NETWORK, "*** Select Network ***")
      
    'Select a printer
    MsgBox BrowseFolders(BIF_BROWSEFORPRINTER, FILE_DEVICE_PRINTER, "*** Select a Printer ***")

End Sub
