Attribute VB_Name = "Module1"
Option Explicit

'-----------------------------------------------------------------------+
'
'   TagPlaceNonAssoc.mvba
'   1.0
'   05.13.2004
'
'   Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
'
'----------------------------------------------------------------------+
'----------------------------------------------------------------------+
'
'   This example illustrates how to place tags with no association.
'
'----------------------------------------------------------------------+

'----------------------------------------------------------------------+
'
'   Name        ApplicationExit
'
'   Author      BSI-DEVSPT                                  05/2004
'
'----------------------------------------------------------------------+
Sub ApplicationExit()

    ' Redraw all the open view windows
    RedrawAllViews
    
    ' Start the Element Selection command
    CommandState.StartDefaultCommand
    
    ' End the application
    End
End Sub

'----------------------------------------------------------------------+
'
'   Name        ElementDependencyRemove
'
'   Author      BSI-DEVSPT                                  05/2004
'
'----------------------------------------------------------------------+
Function ElementDependencyRemove(oElement As Element) As Boolean

    Dim i               As Integer
    Dim oDataBlock()    As DataBlock
    Const LINKAGEID_Dependency = 22224

On Error GoTo errorHandler

    ' Get the dependency user data linkages
    oDataBlock = oElement.GetUserAttributeData(LINKAGEID_Dependency)

    ' Iterate through each linkage and delete the dependency linkage
    For i = 0 To UBound(oDataBlock)
        oElement.DeleteUserAttributeData LINKAGEID_Dependency, 1
    Next i

    ' Rewrite the element
    oElement.Rewrite
    
    ElementDependencyRemove = True
    Exit Function
    
errorHandler:
    ElementDependencyRemove = False
End Function

'----------------------------------------------------------------------+
'
'   Name        StartApp
'
'   Author      BSI-DEVSPT                                  05/2004
'
'----------------------------------------------------------------------+
Sub StartApp()

    Dim oTagSet     As TagSet
    Dim oTagSets    As TagSets
      
    UserForm1.TextBox1.Value = vbNullChar
        
    ' Get all the tag sets
    Set oTagSets = ActiveDesignFile.TagSets
    
    ' Iterate through each tag set to populate the list box 1
    For Each oTagSet In oTagSets
        UserForm1.ListBox1.AddItem oTagSet.Name
    Next
    
    ' End the app if no tag sets are found
    If oTagSets.Count = 0 Then
        ShowMessage "No Tag Sets Found In The Design File"
        Exit Sub
    End If
    
    ' Display the form
    UserForm1.show
End Sub
