VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TagPlacementCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IPrimitiveCommandEvents

Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub

Private Sub IPrimitiveCommandEvents_DataPoint(point As Point3d, ByVal View As View)

    Dim oLine       As LineElement
    Dim oTagDef     As TagDefinition
    Dim oTag        As TagElement
    Dim oTagSet     As TagSet
    Dim oTagSets    As TagSets

    ' Place a zero length line to allow the placement of the tag
    ' (VBA can't place an un-associated tag in 08.05.00.64)
    Set oLine = CreateLineElement2(Nothing, point, point)
    ActiveModelReference.AddElement oLine
    
    ' Get all the tag sets
    Set oTagSets = ActiveDesignFile.TagSets
    
    ' Get the specific tag set we want
    Set oTagSet = oTagSets(UserForm1.ListBox1.Value)
    
    ' Get the specific tag or tag definition we want
    Set oTagDef = oTagSet.TagDefinitions(UserForm1.ListBox2.Value)
    
    ' Create a new tag element and associate it with the zero
    ' length line
    Set oTag = oLine.AddTag(oTagDef)
    
    ' Add the tag's value
    oTag.Value = UserForm1.TextBox1.Value
    
    ' Remove the Dependency linkage from the tag
    If ElementDependencyRemove(oTag) = True Then
    
        ' Delete the zero length line
        ActiveModelReference.RemoveElement oLine
    End If
    
    oTag.Redraw msdDrawingModeNormal
End Sub

Private Sub IPrimitiveCommandEvents_Dynamics(point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Dim oTextElement As TextElement
    
    ' Display the tag value in dynamics as a text element
    Set oTextElement = CreateTextElement1(Nothing, UserForm1.TextBox1.Value, point, Matrix3dIdentity)
    oTextElement.Redraw DrawMode
    
End Sub

Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)
End Sub

Private Sub IPrimitiveCommandEvents_Reset()
    ApplicationExit
End Sub

Private Sub IPrimitiveCommandEvents_Start()

    ShowCommand "Non Associated Tag Example"
    ShowPrompt "Enter Point"
    
    ' Start the dynamics
    CommandState.StartDynamics
End Sub
