VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsTagSetDefAdd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'this example will demonstrate how to add Tag Sets and Tag Definitions to the Active Model.

Option Explicit

' This function checks if an element of the passed type has already been added
' to the TreeView. Returns True if it is already in the tree, False otherwise.
Private Function ChkTree4Dups(treeText As String, oTreeview As Object) As Boolean
    Dim oNode As Node
    
    ChkTree4Dups = False
    For Each oNode In oTreeview.Nodes
        If oNode.Key = "P" + treeText Then
            ChkTree4Dups = True
        End If
    Next
End Function

' This Property adds the info to the TreeView. In this case it adds
' the Tag Set names with the Tag Defs as children.
Public Sub BuildTree(treeText As String, parentID As String, oTreeView1 As TreeView, _
                        Optional oTagD As TagDefinition)
    'The variable will have a value of P plus the parentID passed in.
    parentID = "P" & parentID
    
    If parentID = "P" Then
        ' Adds the text to the tree as the parent
        oTreeView1.Nodes.Add , , "P" + treeText, treeText, 2
    Else
        ' If the Parent already exists then this is added as a child
        ' to the existing parent
        oTreeView1.Nodes.Add parentID, tvwChild, "C" + treeText, treeText, 5
        oTreeView1.Nodes.Add "C" + treeText, tvwChild, , tagType(oTagD.tagType), oTagD.tagType

    End If
End Sub
' This function returns the tag type as a string
Public Function tagType(ByVal tType As Integer) As String

Select Case tType
    Case 1: tagType = "Character"
    Case 3: tagType = "Integer"
    Case 4: tagType = "Real"
End Select
End Function
