VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "setDisplay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------------------------------------+
' setDisplay
'
' Status: WORKING
'
' Date: 07/10/02
'
' This example illustrates how to use a MicroStations shared library
' in MSVBA.
'
' Author: BSI                                                   07/10/02
'
'-----------------------------------------------------------------------+
Implements ILocateCommandEvents

'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Accept
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
    
    Dim oTagElems() As TagElement
    Dim oTagEl As TagElement
    Dim nResult As Integer
    Dim numTags As Integer
    Dim count As Integer
    
    ' Check to see if the element has any tags
    If Element.HasAnyTags Then
                
        ' Get tags
        oTagElems = Element.GetTags
        
        ' Get number of tags
        numTags = UBound(oTagElems)
        
        ' Loop through all the tags
        For count = 0 To numTags
        
            Set oTagEl = oTagElems(count)
        
           ' Check to see if we have a tag element
            If oTagEl.IsTagElement Then
                                     
                ' Turn on/off the display attribute by calling into my custom library
                nResult = GetCExpressionValue("tagDisplay (" & oTagEl.MdlElementDescrP & "," & ToggleState & ")", "myAPI")
           
            End If
    
            ' Rewrite and redraw the elements.
            Element.Rewrite
            oTagEl.Rewrite
            Element.Redraw msdDrawingModeNormal
            oTagEl.Redraw IIf(ToggleState = 0, msdDrawingModeTemporaryErase, msdDrawingModeNormal)
        Next count
        
        ' Update the view
        ActiveDesignFile.Views.Item(1).Redraw
        
    End If
    
End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Cleanup
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Cleanup()

End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Dynamics
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateFailed
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_LocateFailed()

End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateFilter
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)

Element.Redraw msdDrawingModeHilite

End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_LocateReset
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_LocateReset()

End Sub
'-----------------------------------------------------------------------+
'
'   name        ILocateCommandEvents_Start
'
'   author      BSI                                             07/2002
'
'-----------------------------------------------------------------------+
Private Sub ILocateCommandEvents_Start()

End Sub
