VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsTagElements"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents

' This function checks if an element of the passed type has already been added
' to the TreeView. Returns True if it is already in the tree, False otherwise.
Private Function ChkTree4Dups(treeText As String, oTreeview As Object) As Boolean
    Dim oNode As Node
    
    ChkTree4Dups = False
    For Each oNode In oTreeview.Nodes
        If oNode.Key = "P" + treeText Then
            ChkTree4Dups = True
        End If
    Next
End Function

' This Property adds the info to the TreeView. In this case it adds
' the Tag Set names with the Tag Defs as children.
Public Sub BuildTree(treeText As String, parentID As String, oTreeView1 As TreeView, _
                        Optional oTagD As TagDefinition)
    'The variable will have a value of P plus the parentID passed in.
    parentID = "P" & parentID
    
    If parentID = "P" Then
        ' Adds the text to the tree as the parent
        oTreeView1.Nodes.Add , , "P" + treeText, treeText
    Else
        ' If the Parent already exists then this is added as a child
        ' to the existing parent
        oTreeView1.Nodes.Add parentID, tvwChild, "C" + treeText, treeText
        oTreeView1.Nodes.Add "C" + treeText, tvwChild, , tagType(oTagD.tagType)

    End If
End Sub
' This function returns the tag type as a string
Public Function tagType(ByVal tType As Integer) As String
Select Case tType
    Case 1: tagType = "Character"
    Case 3: tagType = "Integer"
    Case 4: tagType = "Real"
End Select
End Function

Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
'    Dim response As Long
    Dim offSet As Point3d
    Dim oTags() As TagElement
    Dim oTagElem As TagElement
    
    oTagDefinition.IsHidden = False
    
    oTaggedElement.AddTag oTagDefinition
    oTags = oTaggedElement.GetTags
    Set oTagElem = oTags(0)
    If oTagDefinition.tagType = msdTagTypeCharacter Then
        oTagElem.Value = frmTagElements.edtTagValue.Text
    Else
        oTagElem.Value = Val(frmTagElements.edtTagValue.Text)
    End If
    offSet = Point3dSubtract(Point, oTaggedElement.AsEllipseElement.CenterPoint)
    oTagElem.Move offSet
    oTagElem.Rewrite
    oTaggedElement.Rewrite
    RedrawAllViews
    ILocateCommandEvents_LocateReset
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    Dim oTextElement As TextElement
   
    If frmTagElements.edtTagValue.Text <> "" Then
        Set oTextElement = CreateTextElement1(Nothing, frmTagElements.edtTagValue.Text, Point, Matrix3dIdentity)
        oTextElement.Redraw DrawMode
    End If
End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)
    Dim response As Long
    
    If Element.Type = msdElementTypeEllipse Then
        Set oTaggedElement = Element
        CommandState.StartDynamics
    End If
End Sub

Private Sub ILocateCommandEvents_LocateReset()
    CommandState.StopDynamics
    CommandState.StartDefaultCommand
End Sub

Private Sub ILocateCommandEvents_Start()

End Sub
