Attribute VB_Name = "modTagElements"
' ********************************************
' example will add a Tag to a selected element.
' After the element is selected click on the Tag
' Definition you want to add. The value of the Tag
' Definition will be taken from the edit box.
' *********************************************
Option Explicit

Public oTaggedElement As Element
Public oTagElement As TagElement
Public oNode As Node
Public oTagDefinition As TagDefinition

Sub main()
    frmTagElements.Show
End Sub

' Adds all Tag Sets and Tag Defs to Treeview
' The Optional parameter is so the sub does not display
' in the macro list. Only the main() will display.
Sub init(Optional NA As String)
    Dim oTagSets As TagSets
    Dim oTagSet As New TagSet
    Dim oTagDefs As TagDefinitions
    Dim oTagDef As New TagDefinition
    Dim cTree As New clsTagElements
    Dim iSet As Long
    Dim iDef As Long
    
    With frmTagElements
        ' Clears Treeview
        .TreeView1.Nodes.Clear
        
        Set oTagSets = ActiveDesignFile.TagSets
        
        ' Steps through all the Tag Sets
        For iSet = 1 To oTagSets.Count
            Set oTagSet = oTagSets(iSet)
            cTree.BuildTree oTagSet.Name, "", .TreeView1
            Set oTagDefs = oTagSet.TagDefinitions
            ' Steps through all the Tag Definitions.
            For iDef = 1 To oTagSet.TagDefinitions.Count
                Set oTagDef = oTagDefs(iDef)
                cTree.BuildTree oTagDef.Name, oTagSet.Name, .TreeView1, oTagDef
            Next
        Next
    End With
End Sub

