VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "callClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Implement Statement: inform MicroStation that a class is going to provide code for the ILocateCommandEvents interface
Implements ILocateCommandEvents

'----------------------------------------------------------------------
'
'           Private Data Members
'
'----------------------------------------------------------------------
Private lineEl As LineElement
Private oldColor As Long
Private oldWeight As Long
Private oldStyle As LineStyle


Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
    
    Dim acceptPt As Point3d
    
    acceptPt.X = 0
    acceptPt.Y = 0
    acceptPt.Z = 0
    
    'Set active symbology based on elements symbology.
    ActiveSettings.Color = lineEl.Color
    Set ActiveSettings.LineStyle = lineEl.LineStyle
    ActiveSettings.LineWeight = lineEl.LineWeight
    'set terminator.
    ActiveSettings.LineTerminator = "ARRO"
    'call place terminator keyin.
    CadInputQueue.SendKeyin "place terminator"
    'place datapoint to endpoint of line and accept point.
    CadInputQueue.SendDataPoint lineEl.EndPoint
    CadInputQueue.SendDataPoint acceptPt
    'Send reset to stop command.
    'CadInputQueue.SendReset
    'Redraw element as normal.
    lineEl.Redraw msdDrawingModeNormal
    'Change terminator's symbology.
    CadInputQueue.SendKeyin "change symbology"
    CadInputQueue.SendDataPoint lineEl.EndPoint
    CadInputQueue.SendDataPoint acceptPt
    
    'Set back to original settings.
    ActiveSettings.Color = oldColor
    ActiveSettings.LineWeight = oldWeight
    Set ActiveSettings.LineStyle = oldStyle
    
    'Restart events.
    CommandState.StartLocate New callClass
    
End Sub

Private Sub ILocateCommandEvents_Cleanup()
    
End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)
    'Set current element to lineEl object.
    Set lineEl = Element
    'Hilite so user knows it was chosen.
    lineEl.Redraw msdDrawingModeHilite
End Sub

Private Sub ILocateCommandEvents_LocateReset()
 
End Sub

Private Sub ILocateCommandEvents_Start()

    Dim locCriteria As LocateCriteria
    
    'Get current settings.
    oldColor = ActiveSettings.Color
    oldWeight = ActiveSettings.LineWeight
    Set oldStyle = ActiveSettings.LineStyle
    
    Set locCriteria = CommandState.CreateLocateCriteria(True)
    
    'Use the ExcludedAllTypes and IncludeType methods to specify line elements only
    locCriteria.ExcludeAllTypes
    locCriteria.IncludeType msdElementTypeLine
    
    'set the LocateCriteria with the SetLocateCriteria method of the CommandState object
    CommandState.SetLocateCriteria locCriteria
    
    'communicate with the user
    ShowCommand "Add Terminator"
    'prompt the user for the required input
    ShowPrompt "Select line to add Terminator."
        
End Sub
