VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FontConvert 
   Caption         =   "Font Converter"
   ClientHeight    =   4425
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7125
   OleObjectBlob   =   "FontConvert.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FontConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

Private fRecord As FontInfo
Private ar() As FontInfo
Private fileNum As Integer

Public Function FindFonts(ByVal cCollection As Object, toFind As String) As Object
    Dim oFont As Font
    Dim c As New Collection
        
    For Each oFont In cCollection
        If oFont.Type = msdFontTypeWindowsTrueType Then
            If oFont.Name Like toFind Then
                c.Add oFont
            End If
        End If
    Next
    Set FindFonts = c
End Function
            
' Checks if the "Change Color To Red" check box is checked. If it is the
' element is changed to color 3 (Red).
Private Sub ChangeColor(oElement As element)
    If CheckBox1.Value Then
        oElement.Color = 3
    End If
    oElement.Rewrite
End Sub

' This function checks the list of Windows TTF to see if the font name on the
' element selected matches. If it does the font object is returned, else Nothing
Private Function fontFind(font2Find As String, fontA() As FontInfo) As FontInfo
    Dim i As Long
    
    fontFind.MSType = ""
    For i = 0 To UBound(fontA)
        If Trim(fontA(i).MSType) = font2Find Then
            fontFind = fontA(i)
            Exit For
        End If
    Next
End Function

' This function scans the "Fonts not found" treeview and checks if this font name
' has already been found. If the font name is found a True is returned
Private Function Check4Dups(fontName As String) As Boolean
    Dim oNode As Node
    
    Check4Dups = False
    For Each oNode In TreeView1.Nodes
        If oNode.Text = fontName Then
            Check4Dups = True
        End If
    Next
End Function

Private Sub SetKnownFonts(oElement As element, font2Find As String)
    Dim oFont As Font
        
    Set oFont = ActiveDesignFile.Fonts.Find(msdFontTypeWindowsTrueType, font2Find)
    If Not oFont Is Nothing Then
        Set oElement.AsTextElement.TextStyle.Font = oFont
        ChangeColor oElement
    Else
        fRecord = fontFind(font2Find, ar)
        If Trim(fRecord.MSType) <> "" Then
            Set oFont = ActiveDesignFile.Fonts.Find(msdFontTypeWindowsTrueType, Trim(fRecord.WType))
            Set oElement.AsTextElement.TextStyle.Font = oFont
                
            oElement.AsTextElement.TextStyle.IsBold = fRecord.bold
            oElement.AsTextElement.TextStyle.IsItalic = fRecord.italic
            oElement.AsTextElement.TextStyle.IsUnderlined = fRecord.uLine
            ChangeColor oElement
            Else
                If Not Check4Dups(font2Find) Then
                    TreeView1.Nodes.Add , , , font2Find
                End If
            End If
        End If
End Sub

Private Sub cbBold_Click()
    If cbBold Then
        TextBox1.Font.bold = True
    Else
        TextBox1.Font.bold = False
    End If
End Sub

Private Sub cbItalics_Click()
    If cbItalics Then
        TextBox1.Font.italic = True
    Else
        TextBox1.Font.italic = False
    End If
End Sub

Private Sub cbULine_Click()
    If cbULine Then
        TextBox1.Font.Underline = True
    Else
        TextBox1.Font.Underline = False
    End If
End Sub
Private Sub ResetFontStyle(oElement As element)
    oElement.AsTextElement.TextStyle.IsBold = False
    oElement.AsTextElement.TextStyle.IsItalic = False
    oElement.AsTextElement.TextStyle.IsUnderlined = False
End Sub

Private Sub CheckBox1_Click()
    If CheckBox1 Then
        TextBox1.ForeColor = vbRed
    Else
        TextBox1.ForeColor = vbBlack
    End If
End Sub

' This sub will scan the design file looking for Microstation TTF and
' replacing them with Windows TTF.
' If the font is not found it is added to the right treeview.

Private Sub CommandButton1_Click()
    Dim oElement As element
    Dim oTextNodeElements As ElementEnumerator
    Dim font2Find As String
    Dim oFont As Font
    Dim oEnumerator As ElementEnumerator
    Dim oScanCriteria As New ElementScanCriteria
    
    Set oFont = Nothing
    oScanCriteria.Reset
    
    ' Looks for only Text and TextNode elements
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType msdElementTypeText
    oScanCriteria.IncludeType msdElementTypeTextNode
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)
    
    TreeView1.Nodes.Clear
    
    While oEnumerator.MoveNext
        Set oElement = oEnumerator.Current
        If oElement.Type = msdElementTypeText Then
            If oElement.AsTextElement.TextStyle.Font.Type <> msdFontTypeWindowsTrueType Then
                ResetFontStyle oElement
                font2Find = oElement.AsTextElement.TextStyle.Font.Name
                SetKnownFonts oElement, font2Find
            End If
        Else
            Set oTextNodeElements = oElement.AsTextNodeElement.GetSubElements
            While oTextNodeElements.MoveNext
                Set oElement = oTextNodeElements.Current
                If oElement.AsTextElement.TextStyle.Font.Type <> msdFontTypeWindowsTrueType Then
                    ResetFontStyle oElement
                    font2Find = oElement.AsTextElement.TextStyle.Font.Name
                    SetKnownFonts oElement, font2Find
                End If
            Wend
        End If
    Wend
    RedrawAllViews msdDrawingModeNormal
End Sub

' This sub sets the text element to the properties selected
Private Sub SetElementFont(oElement As element, Node As MSComctlLib.Node)
    Dim oFont As Font
    Dim oFonts As Fonts
    
    Set oFonts = Application.ActiveDesignFile.Fonts
    ActiveDesignFile.Fonts.Refresh
            With oElement.AsTextElement.TextStyle
                If .Font.Name = Node.Text Then
                    fRecord.MSType = .Font.Name
                    Set .Font = FindFonts(oFonts, TreeView2.SelectedItem).Item(1)
                    fRecord.WType = .Font.Name
                    If cbBold Then
                        .IsBold = True
                        fRecord.bold = True
                    Else
                        .IsBold = False
                        fRecord.bold = False
                    End If
                    If cbItalics Then
                        .Slant = 0
                        .IsItalic = True
                        fRecord.italic = True
                    Else
                        .Slant = 0
                        .IsItalic = False
                        fRecord.italic = False
                    End If
                    If cbULine Then
                        .IsUnderlined = True
                        fRecord.uLine = True
                    Else
                        .IsUnderlined = False
                        fRecord.uLine = False
                    End If
                    ChangeColor oElement
                    ReDim Preserve ar(UBound(ar) + 1)
                    ar(UBound(ar)) = fRecord
                End If
            End With
End Sub

Private Sub TreeView1_NodeClick(ByVal Node As MSComctlLib.Node)
    Dim oElement As element
    Dim oTextNodeElements As ElementEnumerator
    Dim oScanCriteria As New ElementScanCriteria
    Dim oEnumerator As ElementEnumerator
    
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType msdElementTypeText
    oScanCriteria.IncludeType msdElementTypeTextNode
    
    Set oEnumerator = ActiveModelReference.Scan(oScanCriteria)
    
    If TreeView2.SelectedItem <> "" Then
        While oEnumerator.MoveNext
            Set oElement = oEnumerator.Current
            If oElement.Type = msdElementTypeText Then
                SetElementFont oElement, Node
            Else
                Set oTextNodeElements = oElement.AsTextNodeElement.GetSubElements
                While oTextNodeElements.MoveNext
                    Set oElement = oTextNodeElements.Current
                    SetElementFont oElement, Node
                Wend
            End If
        Wend
        RedrawAllViews msdDrawingModeNormal
    End If
    TreeView1.Nodes.Remove (TreeView1.SelectedItem.Index)
End Sub

Private Sub TreeView2_NodeClick(ByVal Node As MSComctlLib.Node)
    Dim testFont As String
    If Node.Selected Then
        TreeView1.Enabled = True
        If CheckBox1 Then
            TextBox1.Font.Size = 12
            TextBox1.Font.Name = Node.Text
            TextBox1.ForeColor = vbRed
            TextBox1.Text = "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqrRsStTuUvWwXxYyZz"
        Else
            TextBox1.Font.Size = 12
            TextBox1.Font.Name = Node.Text
            TextBox1.ForeColor = vbBlack
            TextBox1.Text = "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqrRsStTuUvWwXxYyZz"
        End If
    End If
End Sub

Private Sub UserForm_Initialize()
    Dim oFont As Font
    Dim oFonts As Fonts
    
    fileNum = FreeFile
    
    Set oFonts = Application.ActiveDesignFile.Fonts
    ActiveDesignFile.Fonts.Refresh
    
    TreeView1.Nodes.Clear
    TreeView2.Nodes.Clear
    For Each oFont In oFonts
        If oFont.Type = msdFontTypeWindowsTrueType Then
            TreeView2.Nodes.Add , , , oFont.Name
        End If
    Next
    
    ReDim ar(0)
    
    Open "c:\font.dat" For Random Access Read Write As fileNum Len = Len(fRecord)
    If LOF(fileNum) <> 0 Then
        Get fileNum, , fRecord
        While Not EOF(fileNum)
            ReDim Preserve ar(UBound(ar) + 1)
            ar(UBound(ar)) = fRecord
            Get fileNum, , fRecord
        Wend
    End If
    Close fileNum
End Sub

Private Sub UserForm_Terminate()
    Dim i As Integer
    
    Open "c:\font.dat" For Random Access Read Write As fileNum Len = Len(fRecord)
    For i = 1 To UBound(ar)
        Put fileNum, , ar(i)
    Next
    Close fileNum
End Sub
