VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PlaceTextCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------
' PlaceTextCommand
'
' Status: WORKING
'
' Date: 08/07/2001
'
' This example illustrates how to palce a text element using
' IPrimitiveCommandEvents.
'
' Author: BSI
'
'----------------------------------------------------------------------------
Implements IPrimitiveCommandEvents

Dim mycolor As Integer

Public TEXTSIZE As Integer
Private MyText As TextElement 'MyText Element
Private ncount As Integer   'Counter flag for points


'-----------------------------------------------------------------------+
'
'   name        VBAcreateMyText
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Public Function VBAcreateText(point As Point3d) As TextElement
 
   'return a Text elemenet
   Set VBAcreateText = CreateTextElement1(Nothing, SetTextSize.TextBox1.Text, point, Matrix3dIdentity)
         
End Function

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Cleanup
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_DataPoint
'
'   author      BSI                                             08/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_DataPoint(point As Point3d, ByVal View As View)
    
    'Dynamics needs to be activated after the first point
    If ncount = 0 Then

        'Start dynamics
        CommandState.StartDynamics
        
        'set flag
        ncount = 1

    Else
        
        'Create a MyText mark
        Set MyText = VBAcreateText(point)
            
        'Set text hight and width
        MyText.TextStyle.TextHeight = CInt(SetTextSize.TXT_HIGHT.Text)
        MyText.TextStyle.TextWidth = CInt(SetTextSize.TXT_WIDTH.Text)
        
        'Add Text to design file
        ActiveModelReference.AddElement MyText
    
        'Display Text
        MyText.Redraw msdDrawingModeXor
            
    End If
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Dynamics
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Dynamics(point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Dim oEl As TextElement
    
    'Create new text element
    Set oEl = VBAcreateText(point)
    
    'Set text hight and width
    oEl.TextStyle.TextHeight = SetTextSize.TXT_HIGHT.Text
    oEl.TextStyle.TextWidth = SetTextSize.TXT_WIDTH.Text
    
    ' *** DEBUGGING STUFF ***
    Debug.Print oEl.TextStyle.TextHeight, oEl.TextStyle.TextWidth
    mycolor = (mycolor + 1) Mod 256
    oEl.Color = mycolor
    
    ' Display the text
    oEl.Redraw DrawMode
    
       
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Keyin
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Reset
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Reset()
    
    'Set Flag to 0
    ncount = 0
    
    'CommandState.StopDynamics
    
    CommandState.StartPrimitive Me
  
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Start
'
'   author      BSI                                             10/2001
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Start()
    
    Dim point As Point3d
          
    'Prompt user
    ShowCommand "Place Text Command"
    ShowPrompt "Place Text"
        
    'Start dynamics
    'CommandState.StartDynamics

    'Send a datapoint to start dynamics
    CadInputQueue.SendDataPoint point
    
End Sub
