Attribute VB_Name = "Module1"
Option Explicit

'*----------------------------------------------------------------------+
'
' Copyright 1993-2003, Bentley Systems, Incorporated
' All rights reserved.
'
' Limited permission is hereby granted to reproduce and modify this
' copyrighted material provided that the resulting code is used only in
' conjunction with Bentley Systems products under the terms of the
' license agreement provided therein, and that this notice is retained
' in its entirety in any such reproduction or modification.
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' TextPlaceAbvBlw
'
' Status: WORKING
'
' This example illustrates how to clone a selected text string, copy it
' above and below itself a specified distance then change the new text
' string values.
'
' Author: BSI                                               07/08/02
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
'
'   name        TextPlace
'
'   author      BSI                                             05/2003
'
'-----------------------------------------------------------------------+
Sub TextPlace()
    CommandState.StartLocate New TextSelect
End Sub

'-----------------------------------------------------------------------+
'
'   name        TextPlaceAboveBelow
'
'   author      BSI                                             05/2003
'
'-----------------------------------------------------------------------+
Sub TextPlaceAboveBelow(TextRadians As Double, otext As TextElement, location As String)
    
    Dim currentRotation As Double
    Dim newRadians      As Double
    Dim distance        As Double
    Dim offset          As Point3d
    Dim newText         As TextElement

    ' Clone the text element
    Set newText = otext.Clone

    ' Convert to degrees
    currentRotation = Degrees(TextRadians)
    
    ' Add 90 degrees to the angle
    currentRotation = currentRotation + 90
    
    ' Convert back to radians
    newRadians = radians(currentRotation)
    
    If location = "above" Then
        ' Calculate the distance for the text being placed above
        distance = (otext.TextStyle.Height + otext.TextStyle.Height / 2)
        
        ' Set the text value
        newText.Text = "Above+Above"
    Else
        ' Calculate the distance for the text being placed below
        distance = "-" & (otext.TextStyle.Height + otext.TextStyle.Height / 2)
        
        ' Set the text value
        newText.Text = "Below+Below"
    End If
    
    ' Get the offset coordinate
    offset = Point3dFromAngleDistance(newRadians, distance, 0)
    
    ' Move the new text element
    newText.Move offset
    
    ' Write the element
    ActiveModelReference.AddElement newText
    
    ' Redraw the element
    newText.Redraw msdDrawingModeNormal

End Sub
