VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TextSelect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ILocateCommandEvents

Private Sub ILocateCommandEvents_Accept(ByVal Element As Element, Point As Point3d, ByVal View As View)
    
    Dim TextRadians As Double
    Dim matrix      As Matrix3d
    Dim otext       As TextElement
    
    Set otext = Element
    
    ' Gets an object's rotation (if applicable)
    matrix = otext.Rotation
    
    ' Analyze a matrix and determine if it is a rotation in the xy plane, with no other effects. If so,
    ' create the text
    If Matrix3dIsXYRotation(matrix, TextRadians) Then
        TextPlaceAboveBelow TextRadians, otext, "above"
        TextPlaceAboveBelow TextRadians, otext, "below"
    End If
End Sub

Private Sub ILocateCommandEvents_Cleanup()

End Sub

Private Sub ILocateCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)

End Sub

Private Sub ILocateCommandEvents_LocateFailed()

End Sub

Private Sub ILocateCommandEvents_LocateFilter(ByVal Element As Element, Point As Point3d, Accepted As Boolean)

    ' Only accept text elements
    If Element.Type <> msdElementTypeText Then
        Beep
        ShowError "Please select a text string ONLY"
        Accepted = False
    Else
        Accepted = True
    End If

End Sub

Private Sub ILocateCommandEvents_LocateReset()

End Sub

Private Sub ILocateCommandEvents_Start()
    ShowCommand "Add Text Example"
    ShowPrompt "Select Text string"
End Sub
