VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TextPlaceCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IPrimitiveCommandEvents

Private Sub IPrimitiveCommandEvents_Cleanup()
End Sub

Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal View As View)

    Dim IsLineRotExtracted  As Boolean
    Dim oText               As TextElement
    
    ' This code will be used when seleting the line element
    If DataPointEnteredIs = 0 Then
    
        ' Get the line element and rotation
        IsLineRotExtracted = IsLineFound(Point, View)
        
        If IsLineRotExtracted = True Then
        
            ShowMessage ""
        
            ' Display the form
            UserForm1.Show
        
            DataPointEnteredIs = 1
            ShowCommand "VBA PlaceText Example"
            ShowPrompt "Place text"
        Else
            ShowMessage "A line has NOT been selected"
        End If
    Else
        ' This code will be used when placing the text element
        DataPointEnteredIs = 0
    
        ' Get the text value type in
        TextValue = UserForm1.TextBox1.Text
    
        ' Create the text element
        Set oText = CreateTextElement1(Nothing, TextValue, Point, Matrix3dIdentity)
        
        ' Rotate the text element according to the line element's rotation
        oText.RotateAboutZ Point, LineAngle
        
        ' Add the text element to the model
        ActiveModelReference.AddElement oText
        
        ' Redraw the text element
        oText.Redraw msdDrawingModeNormal
        
        ' Initialize the form
        UserForm1.TextBox1.Text = ""
        
        ' Hide the form
        UserForm1.Hide
        
        ' Restart the IPrimitiveCommandEvents object
        CommandState.StartPrimitive Me
    End If
End Sub

Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal View As View, ByVal DrawMode As MsdDrawingMode)
    
    Dim oText As TextElement
    
    ' Get the text value type in
    TextValue = UserForm1.TextBox1.Text
    
    ' Create the text element
    Set oText = CreateTextElement1(Nothing, TextValue, Point, Matrix3dIdentity)
    
    ' Rotate the text element according to the line element's rotation
    oText.RotateAboutZ Point, LineAngle
    
    ' Redraw the text element
    oText.Redraw DrawMode
End Sub

Private Sub IPrimitiveCommandEvents_Keyin(ByVal Keyin As String)

End Sub

Private Sub IPrimitiveCommandEvents_Reset()

    ' Hide the form
    UserForm1.Hide
    
    ' Start the Element Selection command
    CommandState.StartDefaultCommand
    
    ShowError "Process Exited"
End Sub

Private Sub IPrimitiveCommandEvents_Start()
    ShowCommand "VBA PlaceText Example"
    ShowPrompt "Select a line"
    
    DataPointEnteredIs = 0
End Sub
