VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "placeBlock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Implement Statement: inform MicroStation that a class is going to provide code for the IPrimitiveCommandEvents interface
Implements IPrimitiveCommandEvents

'----------------------------------------------------------------------
'
'           Private Data Members
'
'----------------------------------------------------------------------
Private m_atPoints(0 To 4) As Point3d
'0 - 1st data point, 1st vertex
'1 - second vertex
'2 - 2nd data point, 3rd vertex
'3 - 4th vertex
'4 - 5th vertex, same as 1st

Const UPPERCASE = 1
Const LOWERCASE = 2
Const CAPITALIZE = 3

Public m_nPoints As Integer

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Cleanup
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Cleanup()

End Sub
'-----------------------------------------------------------------------+
'
'   name        textElementChangeCase
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Sub textElementChangeCase(ByRef textElm As textElement, elmCase As Integer)
    
    textElm.Redraw msdDrawingModeErase
        
    Select Case elmCase
    Case UPPERCASE
        textElm.Text = UCase(textElm.Text)
    Case LOWERCASE
        textElm.Text = LCase(textElm.Text)
    Case CAPITALIZE
        Dim stringLetter As String
           
        stringLetter = UCase$(Left$(textElm.Text, 1))
        textElm.Text = stringLetter + LCase$(Right$(textElm.Text, Len(textElm.Text) - 1))
    End Select
    
    textElm.Rewrite
    textElm.Redraw

End Sub
'-----------------------------------------------------------------------+
'
'   name        textNodeChangeCase
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Sub textNodeChangeCase(ByRef textNodeElm As TextNodeElement, elmCase As Integer)
    Dim eeTextNode As ElementEnumerator
    
    Set eeTextNode = textNodeElm.GetSubElements
    Do While eeTextNode.MoveNext
        With eeTextNode.Current.AsTextElement
            
            .Redraw msdDrawingModeErase

            Select Case elmCase
                Case UPPERCASE
                .Text = UCase(.Text)
            Case LOWERCASE
                .Text = LCase(.Text)
            Case CAPITALIZE
                Dim stringLetter As String
            
                stringLetter = UCase$(Left$(.Text, 1))
                .Text = stringLetter + LCase$(Right$(.Text, Len(.Text) - 1))
            End Select
            .Rewrite
            .Redraw
        
        End With
    Loop

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_DataPoint
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_DataPoint(Point As Point3d, ByVal view As view)
'method called to handle data points

If m_nPoints = 0 Then 'user has entered Startpoint of the line segment

    'After the first data point, start Dynamics
    CommandState.StartDynamics
    
    'Store first data point
    m_atPoints(0) = Point
    
    'set m_nPoints to 1
    m_nPoints = 1
    
    'prompt the user for end point of the VBABLOCK
    ShowPrompt "Enter opposite corner"
    
ElseIf m_nPoints = 1 Then 'user has entered Endpoint of the line segment
    Dim oEnum As ElementEnumerator
    Dim oSC As New ElementScanCriteria
    Dim elmCase As Integer
    
    If UserFormCHCASE.OptionButton1.Value = True Then
        elmCase = UPPERCASE
    End If
    If UserFormCHCASE.OptionButton2.Value = True Then
        elmCase = LOWERCASE
    End If
    If UserFormCHCASE.OptionButton3.Value = True Then
        elmCase = CAPITALIZE
    End If
    
    'Assign m_atPoints(2) to the second data point
    m_atPoints(2) = Point
    
    'Assign the X & Y coordinate values to the 2nd, 4th, &
    '5th vertices of the the block
    m_atPoints(1).X = Point.X
    m_atPoints(1).Y = m_atPoints(0).Y
    m_atPoints(3).X = m_atPoints(0).X
    m_atPoints(3).Y = Point.Y
    m_atPoints(4) = m_atPoints(0)

    'declare oBlock as a ShapeElement
    Dim oBlock As ShapeElement
    
    'Use CreateShapeElement1 Method to create a shape element
    Set oBlock = CreateShapeElement1(Nothing, m_atPoints)
 
    'Set the scan to look for the range
    oSC.IncludeOnlyWithinRange oBlock.Range
     
    'Scan the file
    Set oEnum = ActiveModelReference.Scan(oSC)
        
    'Enumerate through all the object
    Do While oEnum.MoveNext
        'Get the count of elements
        Select Case oEnum.Current.Type
        
        'Text Element
        Case msdElementTypeText
            textElementChangeCase oEnum.Current.AsTextElement, elmCase
       
        'TextNode
        Case msdElementTypeTextNode
            textNodeChangeCase oEnum.Current.AsTextNodeElement, elmCase
                
        'Cell Element
        Case msdElementTypeCellHeader
            Dim eeCell As ElementEnumerator
            
            Set eeCell = oEnum.Current.AsCellElement.GetSubElements
            Do While eeCell.MoveNext
                If eeCell.Current.Type = msdElementTypeText Then
                         textElementChangeCase eeCell.Current.AsTextElement, elmCase
                Else
                If eeCell.Current.Type = msdElementTypeTextNode Then
                    textNodeChangeCase eeCell.Current.AsTextNodeElement, elmCase
                End If
                End If
            Loop
        End Select
    Loop
    
    CommandState.StartPrimitive Me
    
    'Assign m_nPoints to 0
    m_nPoints = 0

End If
End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Dynamics
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Dynamics(Point As Point3d, ByVal view As view, ByVal DrawMode As MsdDrawingMode)
'method called to show dynamics
'Point represents the cursor as it moves = the third vertex of the block, m_nPoints(2)

If m_nPoints = 1 Then 'got the first data point, waiting for the second data point

    'Assign m_atPoints(2) to Point
    m_atPoints(2) = Point
    'Assign the X & Y coordinate values to the 2nd, 4th, &
    '5th vertices of the the block
    m_atPoints(1).X = Point.X
    m_atPoints(1).Y = m_atPoints(0).Y
    m_atPoints(3).X = m_atPoints(0).X
    m_atPoints(3).Y = Point.Y
    m_atPoints(4) = m_atPoints(0)
       
    'display the temporary shape element
    'declare oShape as a ShapeElement
    Dim oShape As ShapeElement
    'Use CreateShapeElement1 Method to create a shape element
    Set oShape = CreateShapeElement1(Nothing, m_atPoints)
    'Color to indicate temporary display
    oShape.Color = 5
    'Display the shape in DrawMode
    oShape.Redraw DrawMode

End If
End Sub

'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Keyin
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Keyin(ByVal KeyIn As String)

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Reset
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Reset()

    ' Reset m_nPoints to 0
    m_nPoints = 0

    ' On reset, start the command again.
    CommandState.StartPrimitive Me

End Sub
'-----------------------------------------------------------------------+
'
'   name        IPrimitiveCommandEvents_Start
'
'   author      BSI                                             1/2003
'
'-----------------------------------------------------------------------+
Private Sub IPrimitiveCommandEvents_Start()

    'Provide command and prompt user for required input
    ShowCommand "Change Case"
    ShowPrompt "Select first Corner"
    
End Sub

