Attribute VB_Name = "Module1"
Option Explicit

'*----------------------------------------------------------------------+
'
' Copyright 1993-2003, Bentley Systems, Incorporated
' All rights reserved.
'
' Limited permission is hereby granted to reproduce and modify this
' copyrighted material provided that the resulting code is used only in
' conjunction with Bentley Systems products under the terms of the
' license agreement provided therein, and that this notice is retained
' in its entirety in any such reproduction or modification.
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' OutlookMsgCreate
'
' Status: WORKING
'
' This example illustrates how create an Outlook email message from the
' keyin window. Here is the keyin that will load/run the example:
'
' vba run [OutLookMsgCreate]Module1.OutlookMessageCreate <subject field text>
'
' Author: BSI                                               07/2003
'
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
'
'   name        argumentsGet
'
'   Author      BSI                                         07/2003
'
'-----------------------------------------------------------------------+
Public Function argumentsGet() As String

    argumentsGet = KeyinArguments
    
End Function

'-----------------------------------------------------------------------+
'
'   name        OutlookMessageCreate
'
'   Author      BSI                                         07/2003
'
'-----------------------------------------------------------------------+
Sub OutlookMessageCreate()
    
    Dim oOutlook As Object
    Dim oMailItem As MailItem
    Dim oRecipient As Recipient
    Dim subjectValue As String
    
    Set oOutlook = CreateObject("Outlook.Application")
    Set oMailItem = oOutlook.CreateItem(olMailItem)
          
    ' If an argument is passed, use it for the Subject else set to ""
    subjectValue = argumentsGet()
        
    If subjectValue <> "" Then
        oMailItem.Subject = subjectValue
    End If
        
    ' Add to the Subject field
    ''oMailItem.Subject = "My Subject"
    
    ' Add to the message text box
    oMailItem.Body = "Here is my body's Line 1" & vbCrLf & "and Line 2."
    
    ' Add Recipient to the To: field
    Set oRecipient = oMailItem.Recipients.Add("email.address@company.com")
    
    ' Add Recipient to the CC: field
    Set oRecipient = oMailItem.Recipients.Add("email.address@company.com")
    
    ' Use the CC (copy): field
    oRecipient.Type = olCC
    
    ' Use the BCC (blind copy): field
    ''oRecipient.Type = olBCC
    
    ' Display the message
    oMailItem.Display
    
    ' Send the email
    ''oMailItem.Send
    
    ' Clean up
    Set oOutlook = Nothing
    Set oMailItem = Nothing
    Set oRecipient = Nothing
    
    ShowMessage "Email Message Created"
    
End Sub


