Attribute VB_Name = "fileType"
'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2002, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'----------------------------------------------------------------------------
' fileType
'
' Status: WORKING
'
' Date: 1/29/02
'
' This example illustrates how to test for design file type.
'   Types:
'   ======
'   CURRENT
'   V7
'   V8
'   DWG
'   DXF
'
'   To run keyin: vba run [fileFormat]displayType c:\testV8.dgn
'
'Author: BSI                                                 1/29/02
'
'----------------------------------------------------------------------------
'Constants
Private Const DGNFILE_FORMAT_INVALID As Integer = -1
Private Const DGNFILE_FORMAT_CURRENT As Integer = 0
Private Const DGNFILE_FORMAT_V7 As Integer = 1
Private Const DGNFILE_FORMAT_V8 As Integer = 2
Private Const DGNFILE_FORMAT_DWG As Integer = 3
Private Const DGNFILE_FORMAT_DXF As Integer = 4

'-----------------------------------------------------------------------+
'
'   name        fileFormat
'
'   author      BSI                                           01/2002
'
'-----------------------------------------------------------------------+
Public Function fileFormat(sFileName As String) As Long
    Dim nFormat As Long
    Dim nResult As Integer
    
    nResult = GetCExpressionValue("mdlFile_validDesignFile(0, " & VarPtr(nFormat) & ", 0, 0, 0, 0, """ & sFileName & """)")
    
    If nResult <> 1 Then Err.Raise 513, , "Error when trying to examine design file """ & sDesignFile & """"
    
    fileFormat = nFormat

End Function

'-----------------------------------------------------------------------+
'
'   name        formatNamebyNumber
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Function formatNamebyNumber(ByVal eType As Integer) As String
     
Select Case eType

    Case DGNFILE_FORMAT_INVALID: formatNamebyNumber = "Invalid formatt"
    Case DGNFILE_FORMAT_CURRENT: formatNamebyNumber = "Current file"
    Case DGNFILE_FORMAT_V7: formatNamebyNumber = "V7 DGN"
    Case DGNFILE_FORMAT_V8: formatNamebyNumber = "V8 DGN"
    Case DGNFILE_FORMAT_DWG: formatNamebyNumber = "DWG"
    Case DGNFILE_FORMAT_DXF: formatNamebyNumber = "DXF"
    Case Else: formatNamebyNumber = "Unknown format"
  
    End Select
End Function
'-----------------------------------------------------------------------+
'
'   name        displayType
'
'   author      BSI                                           01/2002
'
'-----------------------------------------------------------------------+
Sub displayType()
    Dim filename As String
    Dim format As Integer
    
    'vba run <macro> <command line arguments>.
    filename = KeyinArguments
    
    ' Check to see if we have command line arguments
    If filename = "" Then
        MsgBox ("Please Provide a path and DGN file to test " + vbCrLf + "Example:" + vbCrLf + vbclrf + "vba run [fileFormat]displayType c:\testv7.dgn")

    Else
        ' Get the format type
        format = fileFormat(filename)
        
        'Print out type
        MsgBox ("File is a " + formatNamebyNumber(format) + " format")
    
    End If
    
End Sub
