Attribute VB_Name = "modIsV7"
'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2001, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'----------------------------------------------------------------------------
' ivV7
'
' Status: WORKING
'
' Date: 1/29/02
'
' This example illustrates how to test if a file is V7 or V8 format.
'
' Author: BSI                                                 1/29/02
'
'----------------------------------------------------------------------------
'Constants
Private Const DGNFILE_FORMAT_INVALID As Integer = -1
Private Const DGNFILE_FORMAT_CURRENT As Integer = 0
Private Const DGNFILE_FORMAT_V7 As Integer = 1
Private Const DGNFILE_FORMAT_V8 As Integer = 2
Private Const DGNFILE_FORMAT_DWG As Integer = 3
Private Const DGNFILE_FORMAT_DXF As Integer = 4
       
'-----------------------------------------------------------------------+
'
'   name        IsV7File
'
'   author      BSI                                           10/2001
'
'-----------------------------------------------------------------------+
Public Function IsV7File(sFileName As String) As Boolean
    Dim nFormat As Long
    Dim nResult As Integer
    
    nResult = GetCExpressionValue("mdlFile_validDesignFile(0, " & VarPtr(nFormat) & ", 0, 0, 0, 0, """ & sFileName & """)")
    
    If nResult <> 1 Then Err.Raise 513, , "Error when trying to examine design file """ & sDesignFile & """"
    
    IsV7File = nFormat = 1 ' DGNFILE_FORMAT_V7

End Function
'-----------------------------------------------------------------------+
'
'   name        fileFormat
'
'   author      BSI                                           10/2001
'
'-----------------------------------------------------------------------+
Public Function fileFormat(sFileName As String) As Long
    Dim nFormat As Long
    Dim nResult As Integer
    
    nResult = GetCExpressionValue("mdlFile_validDesignFile(0, " & VarPtr(nFormat) & ", 0, 0, 0, 0, """ & sFileName & """)")
    
    If nResult <> 1 Then Err.Raise 513, , "Error when trying to examine design file """ & sDesignFile & """"
    
    fileFormat = nFormat

End Function

'-----------------------------------------------------------------------+
'
'   name        formatNamebyNumber
'
'   author      BSI                                             01/2002
'
'-----------------------------------------------------------------------+
Public Function formatNamebyNumber(ByVal eType As Integer) As String
     
Select Case eType

    Case DGNFILE_FORMAT_INVALID: formatNamebyNumber = "Invalid formatt"
    Case DGNFILE_FORMAT_CURRENT: formatNamebyNumber = "Current file"
    Case DGNFILE_FORMAT_V7: formatNamebyNumber = "V7 DGN"
    Case DGNFILE_FORMAT_V8: formatNamebyNumber = "V8 DGN"
    Case DGNFILE_FORMAT_DWG: formatNamebyNumber = "DWG"
    Case DGNFILE_FORMAT_DXF: formatNamebyNumber = "DXF"
    Case Else: formatNamebyNumber = "Unknown format"
  
    End Select
    
End Function

'-----------------------------------------------------------------------+
'
'   name        UserForm_Initialize
'
'   author      BSI                                           10/2001
'
'-----------------------------------------------------------------------+
Sub versionformat()
    Dim filename As String
    Dim dgnIsV7 As Boolean
    Dim format As Integer
    
    'vba run <macro> <command line arguments>.
    filename = KeyinArguments
    
    If filename = "" Then
        MsgBox ("Please Provide a path and DGN file to test " + vbCrLf + "Example" + vbclrf + "vba run [isV7]versionformat c:\testv7.dgn")

    Else
        dgnIsV7 = IsV7File(filename)
        format = fileFormat(filename)
        MsgBox ("File is a " + formatNamebyNumber(format) + " format")
        'MsgBox (filename + IIf(dgnIsV7 = True, " is a V7", " is a V8 file"))
    
    End If
    
End Sub


