/*-----------------------------------------------------------------------------+
|
|  RunProcedure
|
+-----------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------+
|
|    RunProcedure.mc
|    1.0
|    04.08.2004
|
|    Copyright: (c) 2004 Bentley Systems, Incorporated. All rights reserved.
|
+-----------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------+
|
|   STATUS: WORKING
|   DATE:   04.08.2004
|
|   This example illustrates how to call mdlVBA_runProcedure ().
|
+-----------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------+
|
|   Include Files
|
+-----------------------------------------------------------------------------*/
#include <mdl.h>
#include <mdlerrs.h>
#include <assert.h>
#include <cmdlist.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <tcb.h>

#include <dlogman.fdf>
#include <mscexpr.fdf>
#include <mselemen.fdf>
#include <mselmdsc.fdf>
#include <msfile.fdf>
#include <msinput.fdf>
#include <mslocate.fdf>
#include <msmisc.fdf>
#include <msoutput.fdf>
#include <msparse.fdf>
#include <msrsrc.fdf>
#include <msscan.fdf>
#include <msstate.fdf>
#include <mssystem.fdf>
#include <mstmatrx.fdf>
#include <msvar.fdf>
#include <msvba.fdf>
#include <mswrkdgn.fdf>

/* Macro definitions that enhance portibility or aid with debugging */
#if defined (MSVERSION) && (MSVERSION >= 0x790)
#include <msmodel.fdf>
#else
#endif

#if (DEVSPT_DEBUG_LEVEL == 1)
#elif (DEVSPT_DEBUG_LEVEL == 2)
#else
#endif

/*----------------------------------------------------------------------+
|
|   Public variables
|
+----------------------------------------------------------------------*/
static char THIS_FILE[] = __FILE__;
/*----------------------------------------------------------------------+
|
|   External variables
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   Function Declarations
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   Function Definitions
|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|
|   name        AppExit
|
|   author      BSI-DEVSPT                                  12/2002
|
+----------------------------------------------------------------------*/
Public void AppExit
(
boolean silently /* => Unload this application silently */
)
    {
    /*-----------------------------------------------------------
    Queue a command to unload the application with/without displaying
    a notification message.
    -----------------------------------------------------------*/
    mdlDialog_cmdNumberQueue (FALSE,
                             (silently) ? CMD_MDL_SILENTUNLOAD : CMD_MDL_UNLOAD,
                              mdlSystem_getCurrTaskID (), TRUE);

    /* Start the default command */
    mdlState_startDefaultCommand ();
    }

/*----------------------------------------------------------------------+
|
|   name        AppOpenResources
|
|   author      BSI-DEVSPT                                  12/2002
|
+----------------------------------------------------------------------*/
Public void AppOpenResources
(
void
)
    {
    RscFileHandle rscH;  /* A resource file handle */

    if (mdlResource_openFile (&rscH, NULL, RSC_READONLY) != SUCCESS)
        {
        mdlOutput_error ("Unable to load Resource File.");
        }
    }

/*----------------------------------------------------------------------+
|
|   name        main
|
|   author      BSI-DEVSPT                                  12/1998
|
+----------------------------------------------------------------------*/
Private int main
(
int     argc,   /* => Number of arguments passed in argv */
char    *argv[] /* => Array of pointers to arguments */
)
    {
    char message[MAXFILELENGTH]= {'0l'};
    char result[MAXFILELENGTH] ={'0l'};
    static char *arguments[] = {"My MDL Data"};
    int status = ERROR;

    /* Open our application for use with the Resource Manager */
    AppOpenResources ();

    /* Call the VBA procedure passing data to the function */
    status = mdlVBA_runProcedure (result, MAXFILELENGTH, "RunProcedure", "Module1", "MyProcedure", 1, arguments);
    if (status == SUCCESS)
        {
        sprintf (message, "MDL - VBA results : %s\n", result);
        mdlDialog_openMessageBox (DIALOGID_MsgBoxOK, message, MSGBOX_ICON_INFORMATION);
        }

    /* Exit the current MDL application */
    AppExit (FALSE);
    return SUCCESS;
    }
