Attribute VB_Name = "ViewRotbyACS"
Option Explicit

Declare Function mdlACS_getCurrent Lib "stdmdlbltin.dll" (ByRef _
    originP As Point3d, ByRef rotMatrixP As Matrix3d, ByVal typeP As Long, ByVal _
    nameP As Long, ByVal descriptionP As Long) As Long

Declare Sub mdlView_getStandard Lib "stdmdlbltin.dll" (ByRef _
    rMatrxP As Matrix3d, ByVal stdViewNum As Long)

' This example illustrates how to rotate the 4 standard 3d view windows to the active ACS

Sub viewsRotateByACS()

    Dim status As Long
    Dim pntACSOrigin As Point3d
    Dim acsTop As Matrix3d
    Dim acsFront As Matrix3d
    Dim acsRight As Matrix3d
    Dim acsIso As Matrix3d
    Dim standardIsoAxes As Matrix3d
    
    Dim acsX As Point3d
    Dim acsY As Point3d
    Dim acsZ As Point3d
    Dim acsNegX As Point3d
    Dim acsNegY As Point3d
    Dim acsnegz As Point3d
    
    Dim intType As Integer
    Dim strName As String
    Dim strDescription As String
    Dim oView1 As View
    Dim oView2 As View
    Dim oView3 As View
    Dim oView4 As View
    
    strName = Space(1024)
    strDescription = Space(1024)
    
    ' Gets the current ACS
    status = mdlACS_getCurrent(pntACSOrigin, acsTop, intType, StrPtr(strName), _
                                StrPtr(strDescription))
    
    ' Gets one of the views standard rotation matrices
    Call mdlView_getStandard(standardIsoAxes, 7)
    
    ' Extract and negate ACS directions for later reference (we won't use
    ' all of them)
    acsX = Point3dFromMatrix3dRow(acsTop, 0)
    acsY = Point3dFromMatrix3dRow(acsTop, 1)
    acsZ = Point3dFromMatrix3dRow(acsTop, 2)
    
    acsNegX = Point3dNegate(acsX)
    acsNegY = Point3dNegate(acsY)
    acsnegz = Point3dNegate(acsZ)
    
    ' Reassemble the top view with ACS axis in primary direction
    Set oView1 = ActiveDesignFile.Views(1)
    oView1.Rotation = acsTop
    oView1.Redraw
    
    ' Use standard iso matrix for the isometric view
    acsIso = Matrix3dFromMatrix3dTimesMatrix3d(standardIsoAxes, acsTop)
    Set oView2 = ActiveDesignFile.Views(2)
    oView2.Rotation = acsIso
    oView2.Redraw
    
    ' Reassemble the front view with ACS axis in primary direction
    acsFront = Matrix3dFromPoint3dRows(acsX, acsZ, acsNegY)
    Set oView3 = ActiveDesignFile.Views(3)
    oView3.Rotation = acsFront
    oView3.Redraw

    ' Reassemble the right view with ACS axis in primary direction
    acsRight = Matrix3dFromPoint3dRows(acsY, acsZ, acsX)
    Set oView4 = ActiveDesignFile.Views(4)
    oView4.Rotation = acsRight
    oView4.Redraw
    
End Sub
