Attribute VB_Name = "Functions"

'------------------------------------------------------------------------------------------------
' SQLDataSources Windows API function - needed for ODBCDataSourceExist function
'------------------------------------------------------------------------------------------------
Private Declare Function SQLDataSources Lib "ODBC32.DLL" _
        (ByVal henv&, ByVal fDirection%, ByVal szDSN$, ByVal cbDSNMax%, _
         pcbDSN%, ByVal szDescription$, ByVal cbDescriptionMax%, _
         pcbDescription%) As Integer

Private Declare Function SQLAllocEnv% Lib "ODBC32.DLL" (env&)
Const SQL_FETCH_NEXT As Long = 1
Const SQL_SUCCESS As Long = 0

'------------------------------------------------------------------------------------------------
' SQLConfigDataSource Windows API function - needed for ODBCDataSourceCreate function
'------------------------------------------------------------------------------------------------
Private Declare Function SQLConfigDataSource Lib "ODBCCP32.DLL" _
        (ByVal hwndParent As Long, ByVal fRequest As Long, ByVal lpszDriver As String, _
         ByVal lpszAttributes As String) As Long


'-----------------------------------------------------------------------+
'
'   name        ScanWriteToDataBase
'
'
'
'-----------------------------------------------------------------------+
Public Sub ScanWriteToDataBase()

    'Declarations
    Dim recSet As New ADODB.Recordset
    Dim oScanCriteria As New ElementScanCriteria
    Dim oEnumerator As ElementEnumerator
    Dim lngLong As Long
    
    'Open Recordsets
    recSet.Open "ElementInfo", dbConnection, adOpenStatic, adLockPessimistic
        
    'Set up scan criteria
    oScanCriteria.Reset
    Set oEnumerator = Application.ActiveModelReference.Scan(oScanCriteria)

    'Step through every element in the file
        Do While oEnumerator.MoveNext
            ' Add current element to table
            With oEnumerator.Current
                
                If .IsGraphical Then
                    recSet.AddNew
                    recSet("Element_Type") = .Type
                    
                    ' Convert this elements unique ID from Dlong to Long
                        lngLong = DLongToLong(.ID)
                        recSet("Element_ID") = lngLong
                    
                    recSet("Element_Name") = elemNameFromNumber(.Type)
                    recSet("Color") = .Color
                    recSet("Style") = .LineStyle
                    recSet("Weight") = .LineWeight
                    recSet("Level_Name") = .Level.Name
                    recSet.Update
               End If
            
            End With
        Loop
End Sub


'-----------------------------------------------------------------------+
'
'   Name        dbADOX_DataBaseCreate
'
'   Author      BSI                                         05/2001
'
'   Reference:  Microsoft ADO Ext 2.x for DLL and Security
'
'-----------------------------------------------------------------------+
Public Sub dbADOX_DataBaseCreate(dbFullPath As String)
   'Create and Set Catalog object
    Dim oCat As ADOX.Catalog
    Set oCat = New ADOX.Catalog
    
   'Create MicroSoft Access Database
    oCat.Create "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & dbFullPath & ";Jet OLEDB:Engine Type=4;"
    
   'Release Catalog Object from memory
    Set oCat = Nothing
End Sub
    

'-----------------------------------------------------------------------+
'
'   Name        dbADOX_TableCreate
'
'   Author      BSI                                         05/2001
'
'   Reference:  Microsoft ADO Ext 2.x for DLL and Security
'
'-----------------------------------------------------------------------+
Public Sub dbADOX_TableCreate(oCat As ADOX.Catalog, newTable As String, colName() As String, colType() As ADOX.DataTypeEnum)
   'Create and Set Table object
    Dim tbl As ADOX.Table
    Set tbl = New ADOX.Table
    
   'Set table name
    tbl.Name = newTable
    
   'Loop thru all column names and column data types, add to the table.
    For i = 1 To UBound(colName)
        tbl.Columns.Append colName(i), colType(i)
    Next i
    
   'Add completed table to the existing catalog object
    oCat.Tables.Append tbl
End Sub


'-----------------------------------------------------------------------+
'
'   name        ODBCdataSourceCreate
'
'
'
'-----------------------------------------------------------------------+
Public Sub ODBCdataSourceCreate(DSname As String, DSpath As String)
    Dim status As Long
    Dim sDriver As String
    Dim sAttributes As String
    
    sDriver = "Microsoft Access Driver (*.mdb)"
    sAttributes = sAttributes & "DSN=" & DSname & Chr$(0)
    sAttributes = sAttributes & "DBQ=" & DSpath & Chr$(0)
    status = SQLConfigDataSource(vbAPINull, 1, sDriver, sAttributes)
End Sub


'-----------------------------------------------------------------------+
'
'   name        ODBCdataSourceExist
'
'
'
'-----------------------------------------------------------------------+
Public Function ODBCdataSourceExist(DSname As String) As Boolean
    Dim i As Integer
    Dim sDSNItem As String * 1024
    Dim sDRVItem As String * 1024
    Dim sDSN As String
    Dim lHenv As Long
    Dim iDSNLen As Integer
    Dim stat As Integer
        
    'Loop through the Data Source Names
    If SQLAllocEnv(lHenv) <> -1 Then
        Do Until i <> SQL_SUCCESS
            sDSNItem = Space$(1024)
            sDRVItem = Space$(1024)
            i = SQLDataSources(lHenv, SQL_FETCH_NEXT, sDSNItem, 1024, _
                iDSNLen, sDRVItem, 1024, iDRVLen)
            sDSN = Left$(sDSNItem, iDSNLen)
                            
            If sDSN <> Space(iDSNLen) Then
                'Test to see if the Data Source Name exists
                If sDSN = DSname Then
                    ODBCdataSourceExist = True
                    Exit Function
                End If
            End If
        Loop
    End If

    'If this point is reached, Data Source Name does not exists
    ODBCdataSourceExist = False

End Function


'-----------------------------------------------------------------------+
'
'   name        FileGetShortPath
'
'   author      BSI                                          05/2001
'
'-----------------------------------------------------------------------+
Public Function FileGetShortPath(filespec As String) As String
   
    Dim fs As Object
    Dim f  As Object
    
    'File object
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFile(filespec)
    'ShortPath property
    FileGetShortPath = f.ShortPath
    
End Function

'-----------------------------------------------------------------------+
'
'   name        elemNameFromNumber
'
'   author      BSI                                             03/2001
'
'-----------------------------------------------------------------------+
Public Function elemNameFromNumber(ByVal eType As Integer) As String
     
    Select Case eType
    Case 1: elemNameFromNumber = "Cell Library Header         "
    Case 2: elemNameFromNumber = "Cell Header                 "
    Case 3: elemNameFromNumber = "Line                        "
    Case 4: elemNameFromNumber = "Line String                 "
    Case 5: elemNameFromNumber = "Group Data                  "
    Case 6: elemNameFromNumber = "Shape                       "
    Case 7: elemNameFromNumber = "Text Node                   "
    Case 8: elemNameFromNumber = "Digitizer Setup Data        "
    Case 9: elemNameFromNumber = "Design File Header          "
    Case 10: elemNameFromNumber = "Level Symbology            "
    Case 11: elemNameFromNumber = "Curve                      "
    Case 12: elemNameFromNumber = "Complex String             "
    Case 13: elemNameFromNumber = "Conic                      "
    Case 14: elemNameFromNumber = "Complex Shape              "
    Case 15: elemNameFromNumber = "Ellipse                    "
    Case 16: elemNameFromNumber = "Arc                        "
    Case 17: elemNameFromNumber = "Text                       "
    Case 18: elemNameFromNumber = "Surface                    "
    Case 19: elemNameFromNumber = "Solid                      "
    Case 21: elemNameFromNumber = "BSpline Pole               "
    Case 22: elemNameFromNumber = "Point String               "
    Case 23: elemNameFromNumber = "Cone                       "
    Case 24: elemNameFromNumber = "BSpline Surface            "
    Case 25: elemNameFromNumber = "BSpline Boundary           "
    Case 26: elemNameFromNumber = "BSpline Knot               "
    Case 27: elemNameFromNumber = "BSplinr Curve              "
    Case 28: elemNameFromNumber = "BSpline Weight             "
    Case 33: elemNameFromNumber = "Dimension                  "
    Case 34: elemNameFromNumber = "Shared Cell Definition     "
    Case 35: elemNameFromNumber = "Shared Cell                "
    Case 36: elemNameFromNumber = "MultiLine                  "
    Case 37: elemNameFromNumber = "Tag                        "
    Case 38: elemNameFromNumber = "DgnStore Component         "
    Case 39: elemNameFromNumber = "DgnStore Header            "
    Case 51: elemNameFromNumber = " ARCH (Intergraph)         "
    Case 54: elemNameFromNumber = "SDS (Intergraph)           "
    Case 56: elemNameFromNumber = "LEDS, WMS                  "
    Case 60: elemNameFromNumber = "SIS                        "
    Case 61: elemNameFromNumber = "EWS SCREMANC               "
    Case 62: elemNameFromNumber = "EWS PANEL                  "
    Case 63: elemNameFromNumber = "EWS PDS                    "
    Case 66: elemNameFromNumber = "MicroStation Application   "
    Case 87: elemNameFromNumber = "Raster Header              "
    Case 88: elemNameFromNumber = "Raster Component           "
    Case 89: elemNameFromNumber = "Raster Data                "
    Case 90: elemNameFromNumber = "Raster Reference Attachment"
    Case 91: elemNameFromNumber = "Raster Reference Component "
    Case 96: elemNameFromNumber = "Level Table                "
    Case 97: elemNameFromNumber = "View Group Element         "
    Case 98: elemNameFromNumber = "View Element               "
    Case 99: elemNameFromNumber = "Level Mask Element         "
    Case 100: elemNameFromNumber = "Reference Attach Element  "
    Case 101: elemNameFromNumber = "Matrix Header             "
    Case 102: elemNameFromNumber = "Matrix Int Data           "
    Case 103: elemNameFromNumber = "Matrix Double Data        "
    Case 105: elemNameFromNumber = "Mesh Header               "
    Case Else: elemNameFromNumber = "Unknown Element Type:     " + CStr(eType)
    
    End Select
    
End Function

