Attribute VB_Name = "GenExcelXLS"
Option Explicit

'-----------------------------------------------------------------------+
'
'   Public variables
'
'-----------------------------------------------------------------------+
Public endOfMaterialRows    As Integer ' Determines the last row used for the Material schedule
Public endOfPipeRows        As Integer ' Determines the last row used for the Piping schedule

Public xlsheet          As New Excel.Application ' Excel application
Public wbkWorkbook      As Excel.Workbook  ' Excel workbook
Public wksWorksheet     As Excel.Worksheet ' Excel worksheet
Public rngHeader        As Excel.Range
Public attachmentExist  As Boolean ' Determines if the specified reference is attached
Public response         As Integer

'-----------------------------------------------------------------------+
'
'   name        convertToImperial
'
'   author      BSI                                             03/2003
'
'-----------------------------------------------------------------------+
Function convertToImperial(length As Double) As String
                Dim lengthArray() As String
                Dim inchDbl As Double
                Dim inchStr As String
                Dim inchValue As Integer
                Dim feetValue As Integer
            
                lengthArray() = Split(length, ".")
                
On Error GoTo ErrorHandler
                
                inchStr = "." & lengthArray(1)
                inchDbl = (Val(inchStr) * 12)

                feetValue = lengthArray(0)
                inchValue = inchDbl
                
                If inchValue = 12 Then
                    feetValue = feetValue + 1
                    inchValue = 0
                End If
                
                convertToImperial = CStr(feetValue) & "' - " & CStr(inchValue) & """"
                Exit Function
ErrorHandler:
                feetValue = lengthArray(0)
                inchValue = 0
                
                convertToImperial = CStr(feetValue) & "' - " & CStr(inchValue) & """"
            End Function

'-----------------------------------------------------------------------+
'
'   name        createPipeSchedule
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub createPipeSchedule(wksWorksheet As Excel.Worksheet, rngHeader As Excel.Range, i As Integer)
    
    Dim CWS             As String
    Dim HWS             As String
    Dim displayLength   As String
    Dim CWSCounter      As Integer
    Dim HWSCounter      As Integer
    Dim rowCounter      As Integer
    Dim pipeLengthTotal As Double
    
    ' Widens the columns
     wksWorksheet.Columns("A:A").ColumnWidth = 16
     wksWorksheet.Columns("B:B").ColumnWidth = 12
     wksWorksheet.Columns("D:D").ColumnWidth = 16
     wksWorksheet.Columns("D:D").ColumnWidth = 16
     wksWorksheet.Columns("E:E").ColumnWidth = 12
     wksWorksheet.Columns("F:F").ColumnWidth = 12
     wksWorksheet.Columns("G:G").ColumnWidth = 21
    
    ' Resets the counter
    i = 1

    ' Resets the counter
    rowCounter = 1
     
     ' Changes the title cells color to yellow
     wksWorksheet.Range("D1:G1").Interior.ColorIndex = 6
     
     ' Sets the font to bold for the titles
     wksWorksheet.Range("D1:G1").Font.Bold = True
     
     ' Creates a thicker border around the titles
     wksWorksheet.Range("D1:G1").BorderAround 1, xlThick, xlColorIndexAutomatic, 1
     
     ' Creates the text for the titles
     rngHeader.Cells(1, 4).Value = "Pipe Size"
     rngHeader.Cells(1, 5).Value = "C.W. Supply"
     rngHeader.Cells(1, 6).Value = "H.W. Supply"
     rngHeader.Cells(1, 7).Value = "Pipe Length"
     
     If pipeCountTotal <> 0 Then
         
         For i = 1 To pipeCountTotal
           
            ' Places an "X" in either the Cold Water Supply or Cold Water Supply
            ' column in the Excel Spreadsheet
            If pipeUse(i) = "Cold Water Supply" Then
               CWS = "X"
               HWS = ""
            Else
               CWS = ""
               HWS = "X"
            End If
     
            ' Adds the data for the piping schedule
            rngHeader.Cells(rowCounter + 1, 4).Value = pipeFound(i)
            rngHeader.Cells(rowCounter + 1, 5).Value = CWS
            rngHeader.Cells(rowCounter + 1, 6).Value = HWS
            
            ' Formats the value by converting it to feet and inches
            displayLength = convertToImperial(pipeLength(i))
            
            ' rngHeader.Cells(rowCounter + 1, 7).Value = pipeLength(i)
            rngHeader.Cells(rowCounter + 1, 7).Value = displayLength
            
            rowCounter = rowCounter + 1
            
            If CWS <> "" Then
                CWSCounter = CWSCounter + 1
            Else
                HWSCounter = HWSCounter + 1
            End If
            
            pipeLengthTotal = pipeLengthTotal + pipeLength(i)
         Next i
     End If
     
     ' Add 2 to the counter
     rowCounter = rowCounter + 2
          
     ' Display totals
     rngHeader.Cells(rowCounter, 4).Value = "Total Number: " & CStr(pipeCountTotal)
     rngHeader.Cells(rowCounter, 5).Value = "Total: " & CStr(CWSCounter)
     rngHeader.Cells(rowCounter, 6).Value = "Total: " & CStr(HWSCounter)
     
     ' Formats the value by converting it to feet and inches
     displayLength = convertToImperial(pipeLengthTotal)
     
     ' rngHeader.Cells(rowCounter, 7).Value = "Total Length: " & CStr(pipeLengthTotal)
     rngHeader.Cells(rowCounter, 7).Value = "Total Length: " & CStr(displayLength)
     
     ' Sets the font to bold for the totals
     wksWorksheet.Range("D" & CStr(rowCounter) & ":G" & CStr(rowCounter)).Font.Bold = True
     
     ' Creates a thicker border around the schedule
     wksWorksheet.Range("D1:G" & CStr(rowCounter)).BorderAround 1, xlThick, xlColorIndexAutomatic, 1
     
     ' Gets the last row of pipe info
     endOfPipeRows = i
     
End Sub

'-----------------------------------------------------------------------+
'
'   name        CreateMatSchedule
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub CreateMatSchedule(wksWorksheet As Excel.Worksheet, rngHeader As Excel.Range, i As Integer)

    Dim quanityCounter As Integer
    quanityCounter = 0
     
     ' Changes the title cells color to yellow
     wksWorksheet.Range("A1:B1").Interior.ColorIndex = 6
     
     ' Sets the font to bold for the titles
     wksWorksheet.Range("A1:B1").Font.Bold = True
     
     ' Creates a thicker border around the titles
     wksWorksheet.Range("A1:B1").BorderAround 1, xlThick, xlColorIndexAutomatic, 1
     
     ' Creates the text for the titles
     rngHeader.Cells(1, 1).Value = "Materials"
     rngHeader.Cells(1, 2).Value = "Quanity"
    
     If matCountTotal <> 0 Then
     
         For i = 1 To UBound(materialNames)
             ' Adds the data for the material schedule
             rngHeader.Cells(i + 1, 1).Value = materialNames(i)
             rngHeader.Cells(i + 1, 2).Value = materialCount(i)
             quanityCounter = quanityCounter + materialCount(i)
         Next i
     End If
     
     ' Add 2 to the counter
     i = i + 2
     
     ' Display the total
     rngHeader.Cells(i, 2).Value = "Total: " & CStr(quanityCounter)
     
     ' Sets the font to bold for the total
     wksWorksheet.Range("B" & CStr(i)).Font.Bold = True
     
     ' Creates a thicker border around the schedule
     wksWorksheet.Range("A1:B" & CStr(i)).BorderAround 1, xlThick, xlColorIndexAutomatic, 1
     
    ' Gets the last row of material info
    endOfMaterialRows = i

End Sub

'-----------------------------------------------------------------------+
'
'   name        CreateXLS
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub CreateXLS()
   
    Dim i           As Integer
    Dim FileName    As String
    
    If attachmentExist = True Then
  
        ' Creates a new workbook
        Set wbkWorkbook = xlsheet.Workbooks.Add
    
        ' Return reference to first worksheet.
        Set wksWorksheet = wbkWorkbook.Worksheets(1)
        
        ' Return reference to ranges in this workbook.
        Set rngHeader = wksWorksheet.Rows(1)
        
         ' Creates the Material schedule
        CreateMatSchedule wksWorksheet, rngHeader, i
        
        ' Creates the Piping schedule
        createPipeSchedule wksWorksheet, rngHeader, i
    
         ' Selects all cells in the Materials schedule
        wksWorksheet.Range("A2:B" & CStr(endOfMaterialRows)).Select
    
        ' Sorts column A and B in the Material schedule, Ascending
        Selection.Sort Key1:=Range("A2:B" & CStr(endOfMaterialRows)), Order1:=xlAscending, Header:=xlGuess, _
                            OrderCustom:=1, MatchCase:=False, Orientation:=xlTopToBottom
    
        ' Selects all cells in the Piping schedule
        wksWorksheet.Range("D2:G" & CStr(endOfPipeRows)).Select
    
        ' Sorts column D through G in the Piping schedule, Ascending
        Selection.Sort Key1:=Range("D2:G" & CStr(endOfPipeRows)), _
                                    Order1:=xlAscending, Header:=xlGuess, OrderCustom:=1, MatchCase:=False, _
                                    Orientation:=xlTopToBottom
                                    
        ' Selects a cell thats not being used
        wksWorksheet.Range("I1").Select
        
        ' Opens the Save As dialog
        FileName = FileSaveDialog("Save Excel Spreadsheet data", "c:\", "*.xls", "Excel Spreadsheet")
    
        If FileName = "" Then
            response = vbCancel
            ShowPrompt ""
            ShowStatus "Command Cancelled"
            
            ' Close the spreadsheet without any prompts
            xlsheet.DisplayAlerts = False
            xlsheet.Quit
            xlsheet.DisplayAlerts = True
            
            ' The End statement allows the Excel link to close
            End
        Else
            ' If the spreadsheet already exists, overwrite it without prompting for an Ok or Cancel
            xlsheet.DisplayAlerts = False
            xlsheet.ActiveWorkbook.saveas FileName
            xlsheet.DisplayAlerts = True
            
            ' Display the spreadsheet
            xlsheet.Visible = True
             
            response = vbOK
             
            ShowPrompt ""
            ShowStatus "Spreadsheet Created Successfully!"
        End If
         
        ' Release the object variable.
        Set xlsheet = Nothing
        Set wbkWorkbook = Nothing
        Set wksWorksheet = Nothing
        Set rngHeader = Nothing
    End If
End Sub
