Attribute VB_Name = "SaveAsDialog"
Option Explicit

Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
                        "GetSaveFileNameA" (pOpenFileName As OPENFILENAME) As Long

Public Type OPENFILENAME
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As String
    lpstrCustomFilter   As String
    nMaxCustFilter      As Long
    nFilterIndex        As Long
    lpstrFile           As String
    nMaxFile            As Long
    lpstrFileTitle      As String
    nMaxFileTitle       As Long
    lpstrInitialDir     As String
    lpstrTitle          As String
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As String
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As String
End Type

Public Const OFN_EXPLORER = &H80000
Public Const OFN_FILEMUSTEXIST = &H1000&
Public Const OFN_HIDEREADONLY = &H4&
Public Const OFN_PATHMUSTEXIST = &H800&

'-----------------------------------------------------------------------+
'
'   name        FileSaveDialog
'
'   Author      BSI                                         10/2002
'
'-----------------------------------------------------------------------+

Public Function FileSaveDialog(strTitle As String, strDir As String, strFileExt As String, _
                               strFileExtDescription As String) As String

    ' SAMPLE USAGE:
    '
    ' Dim filename As String
    ' ...
    ' filename = FileSaveDialog("Import Excel Spreadsheet data", "c:\", "*.xls", "Excel Spreadsheet")
    ' MsgBox (filename)
    
    Dim OpenFile    As OPENFILENAME
    Dim status      As Long
    Dim pos         As Long     ' Used for trimming C style string.
    Dim strTmp      As String   ' Used for trimming C style string.
    Dim strFilter   As String
         
    ' Populate the OPENFILENAME data type
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hwndOwner = 0
    OpenFile.hInstance = 0 'App.hInstance
    strFilter = strFileExtDescription & " (" & strFileExt & ")" & Chr(0) & strFileExt & Chr(0)
    OpenFile.lpstrFilter = strFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrInitialDir = strDir
    OpenFile.lpstrTitle = strTitle
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.flags = 0
    
    ' Open the file open dialog box
    status = GetSaveFileName(OpenFile)
             
    ' Return the file selected
    If status = 0 Then
        FileSaveDialog = ""
    Else
        ' Trim C style string for compatibility with VB strings.
        strTmp = Chr$(0)
        pos = InStr(OpenFile.lpstrFile, strTmp)
        FileSaveDialog = Left(OpenFile.lpstrFile, pos - 1)
    End If
    
End Function


