Attribute VB_Name = "ScanForMaterials"
Option Explicit

'-----------------------------------------------------------------------+
'
'   Public variables
'
'-----------------------------------------------------------------------+
Public materialNames()  As String  'Array of material names (cells).
Public materialCount()  As Integer 'Array containing the number of each material found
Public matCountTotal    As Integer 'Total count of all material names.

'-----------------------------------------------------------------------+
'
'   name        MatNameGetPosition
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Public Function MatNameGetPosition(currentMatName As String) As Integer
    Dim i As Integer
    For i = 1 To UBound(materialNames)
        If materialNames(i) = currentMatName Then
            Exit For
        End If
    Next i
    MatNameGetPosition = i
End Function

'-----------------------------------------------------------------------+
'
'   name        MatExistsInArray
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Public Function MatExistsInArray(currentMatName As String) As Boolean
    Dim i As Integer
    
    ' Loop thru possible material names found so far if any are found
    If matCountTotal <> 0 Then
        
        For i = 1 To UBound(materialNames)
            
            ' If material already exists, return True
            If materialNames(i) = currentMatName Then
                MatExistsInArray = True
                Exit Function
            End If
        Next i
    End If

    'Material name does not exist, return False
    MatExistsInArray = False

End Function

'-----------------------------------------------------------------------+
'
'   name        ScanForCellsInRef
'
'   author      BSI                                             10/2002
'
'-----------------------------------------------------------------------+
Sub ScanForCellsInRef(oAttachment As Attachment)
    
    Dim oScanCriteria   As New ElementScanCriteria
    Dim oEnumerator     As ElementEnumerator
    Dim intMatTotal     As Integer
    Dim elType          As Integer
    
    ' Initializes the public variables
    ReDim materialNames(0)
    ReDim materialCount(0)
    matCountTotal = 0
    
    oScanCriteria.ExcludeAllTypes
    oScanCriteria.IncludeType msdElementTypeCellHeader
    
    Set oEnumerator = oAttachment.Scan(oScanCriteria)

    Do While oEnumerator.MoveNext
    
        Dim oCellElement As CellElement
        Set oCellElement = oEnumerator.Current
        
        If oCellElement.HasAnyTags = True Then
                        
            ' Update material totals
            intMatTotal = intMatTotal + 1
            
            Dim currentMatName As String
            currentMatName = oCellElement.Name
            
            If MatExistsInArray(currentMatName) Then
            
                ' Get position of this material type from materialNames array and update the total
                ' count of this material to the materialCount array according to the index
                Dim intPos As Integer
                intPos = MatNameGetPosition(currentMatName)
                
                materialCount(intPos) = materialCount(intPos) + 1
                
                 ' Else this is a new material type found in the design file
            Else
                ' Increment number of possible material types by 1
                matCountTotal = matCountTotal + 1
                
                ' Redimension materialNames array to number of possible element types
                ReDim Preserve materialNames(matCountTotal)
                
                ' Redimension materialCount array to number of possible material types
                ReDim Preserve materialCount(matCountTotal)
                
                ' Populate element name to materialNames array
                materialNames(matCountTotal) = currentMatName
                
                ' Add this material by 1 to elementcount array
                materialCount(matCountTotal) = materialCount(matCountTotal) + 1
            
            End If
        End If
    Loop
    
     ' If materials are found in the design file
    If matCountTotal <> 0 Then
        
        ' Update prompt
        ShowStatus "Scan Complete"
        
    ' No materials were found in the design file
    Else
        ' Update prompt
        ShowStatus "No Materials found"
    End If
    
End Sub
