Attribute VB_Name = "Ppoint"
Option Explicit

'-----------------------------------------------------------------------+
'
'   name        Public Variables
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
    Public oShape As Shape
    Public oSlides As Slides
    Public oSlide As Slide
    Public oPS As Presentations
    Public oP As Presentation
    Public ppt As New PowerPoint.Application
    
    Public invertView As Integer
    Public viewNumber As Integer
    Public slideCounter As Integer
    Public temporaryFolder As String

'-----------------------------------------------------------------------+
'
'   name        savePptAs
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Sub savePptAs()

    Dim reply As Integer
    Dim saveas As New CommonDialog
    
    saveas.DialogTitle = "Save PowerPoint Presentation"
    saveas.Filter = "Presentation(*.ppt);*.ppt"
    saveas.DefaultExt = "ppt"
    saveas.ShowSave
    
    If saveas.FileName <> "" Then
     
        ppt.Visible = msoTrue
            
        'Either create new sheet or overwrite existing one.
        ppt.ActivePresentation.saveas saveas.FileName
    
    Else
        reply = vbCancel
            
    End If
    
End Sub

'-----------------------------------------------------------------------+
'
'   name        PPT_Processing
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Sub PPT_Processing(textBoxText As String, override As String)

    Dim oShapeRange As ShapeRange
    
    Set oPS = ppt.Presentations
    
    If slideCounter = 0 Then
        If override = "no" Then
        
            'Add a new presentation
            Set oP = oPS.Add(msoTrue)
        End If
        
        'Add a new slide
        slideCounter = 1
        Set oSlide = oP.Slides.Add(slideCounter, ppLayoutTitleOnly)
        
        'Add the screen captured image
        Set oShape = oSlide.Shapes.AddPicture(temporaryFolder + "\" + "view" + CStr(viewNumber) + ".jpg", msoTrue, msoTrue, 85, 135, 550, 375)
        
        'Add the title of the slide
        oSlide.Shapes(1).TextFrame.TextRange.Text = textBoxText
    Else
        'Counts how many slides are in the presentation
        slideCounter = oP.Slides.Count + 1
        
        'Add a new slide
        Set oSlide = oP.Slides.Add(slideCounter, ppLayoutTitleOnly)
        
        'Lock the height and width ratio
        oShape.LockAspectRatio = msoTrue
                
        'Add the screen captured image
        Set oShape = oSlide.Shapes.AddPicture(temporaryFolder + "\" + "view" + CStr(viewNumber) + ".jpg", msoTrue, msoTrue, 85, 135, -1, -1)
                       
        'Add the title of the slide
        oSlide.Shapes(1).TextFrame.TextRange.Text = textBoxText
        
    End If
       
End Sub
