Attribute VB_Name = "Ustn"
Option Explicit

Private Declare Function GetEnvironmentVariable Lib "kernel32" Alias "GetEnvironmentVariableA" (ByVal lpName As String, ByVal lpBuffer As String, ByVal nSize As Long) As Long

'-----------------------------------------------------------------------+
'
'   name        SystemVariableGet
'
'   author      BSI                              03/2001
'
'-----------------------------------------------------------------------+
'This function determines if the Window's system variable TEMP or TMP exist. All
'screen captured images are placed into one of these variable's folder.
Function SystemVariableGet(Variable As String) As String

    Dim results As Long
    Dim tmp As String
    
    ' Size tmp
    tmp = Space$(1024)

    ' Make a call into kernel32.dll for GetEnvironmentVariable
    results = GetEnvironmentVariable(Variable, tmp, Len(tmp))
    
    If results = 0 Then
        'Failed returned nothing
    Else
        SystemVariableGet = Left$(tmp, results)
    End If

End Function

'-----------------------------------------------------------------------+
'
'   name        ScrCapture
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Sub ScrCapture()

    Dim oViewWindow As View
    Dim point As Point3d
    Dim getVar As String
    Dim Variable As String
        
    'Initializes the Point3d
    point.X = 0
    point.Y = 0
    point.Z = 0
    
    Variable = "TEMP1"
    
    temporaryFolder = SystemVariableGet(Variable)
    
    If temporaryFolder = "" Then
    
        Variable = "TMP"
        temporaryFolder = SystemVariableGet(Variable)
    
    End If
    
    If temporaryFolder <> "" Then
        
        'Just before a View window is captured, it's turned off then on so
        'it displays as the active window (on top).
        
        Select Case viewNumber
        
        Case 1
            Set oViewWindow = ActiveDesignFile.Views(1)
            CadInputQueue.SendCommand "View off 1"
            CadInputQueue.SendCommand "View on 1"
        
        Case 2
            Set oViewWindow = ActiveDesignFile.Views(2)
            CadInputQueue.SendCommand "View off 2"
            CadInputQueue.SendCommand "View on 2"
            
        Case 3
            Set oViewWindow = ActiveDesignFile.Views(3)
            CadInputQueue.SendCommand "View off 3"
            CadInputQueue.SendCommand "View on 3"
            
        Case 4
            Set oViewWindow = ActiveDesignFile.Views(4)
            CadInputQueue.SendCommand "View off 4"
            CadInputQueue.SendCommand "View on 4"
            
        Case 5
            Set oViewWindow = ActiveDesignFile.Views(5)
            CadInputQueue.SendCommand "View off 5"
            CadInputQueue.SendCommand "View on 5"
            
        Case 6
            Set oViewWindow = ActiveDesignFile.Views(6)
            CadInputQueue.SendCommand "View off 6"
            CadInputQueue.SendCommand "View on 6"
            
        Case 7
            Set oViewWindow = ActiveDesignFile.Views(7)
            CadInputQueue.SendCommand "View off 7"
            CadInputQueue.SendCommand "View on 7"
            
        Case 8
            Set oViewWindow = ActiveDesignFile.Views(8)
            CadInputQueue.SendCommand "View off 8"
            CadInputQueue.SendCommand "View on 8"
       
        End Select
        
        'Registers an event handler to be notified when MicroStation opens
        'or closes a modal dialog box
        Dim modalHandler As New Macro1ModalHandler
        AddModalDialogEventsHandler modalHandler

        'Selects the "Capture View" button
        CadInputQueue.SendCommand "CAPTURE VIEW CONTENTS "
    
        'Send a datapoint to the View Window
        CadInputQueue.SendDataPoint point, oViewWindow

        'Closes the "Screen Capture" dialog box
        CadInputQueue.SendCommand "CAPTURE CLOSE "

        'Unloads the SCRNCAPT MDL application
        CadInputQueue.SendCommand "MDL SILENTUNLOAD SCRNCAPT"

        'Unregisters a handler for modal dialog events
        RemoveModalDialogEventsHandler modalHandler
    End If

    'This method starts MicroStation's default command
    CommandState.StartDefaultCommand

End Sub
