VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmCapture 
   Caption         =   "Capture View(s)"
   ClientHeight    =   3600
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7200
   OleObjectBlob   =   "frmCapture.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmCapture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2001, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' ScrCapturePPT
'
' Status: WORKING
'
' Date: 10/30/01
'
' This example uses V8 to screen capture View Windows then places them
' into a PowerPoint Presentation, one per slide
'
' Author: Dan Tartaglia                          10/30/01
'
'-----------------------------------------------------------------------+
'-----------------------------------------------------------------------+
'
'   name        Timer_Sub
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Sub Timer_Sub(message As String)

    Dim Start As Long
    Dim Finish As Integer
    Dim PauseTime As Integer
    
    'Set duration
    PauseTime = 2
            
    'Set start time
    Start = Timer
            
    Do While Timer < Start + PauseTime
                
        'Yield to other processes
        DoEvents
                
        Label11.Caption = message
    Loop
    
End Sub

Private Sub CheckBox9_Click()

    Dim startPoint As Point3d
    Dim point As Point3d, point2 As Point3d
    
    Dim modalHandler As New Macro2ModalHandler
    AddModalDialogEventsHandler modalHandler
    
    'Determines if the background should be inverted
    Select Case CheckBox9.Value
          
    Case False
        invertView = 0
    
    Case True
        invertView = 1
        
    End Select
 
'   The following statement opens modal dialog "Preferences [examples]"

'   Start a command
    CadInputQueue.SendCommand "MDL SILENTLOAD USERPREF"

    CadInputQueue.SendCommand "MDL SILENTUNLOAD RASTMGR"

    CadInputQueue.SendCommand "MDL SILENTUNLOAD SPELLCHECK"

    RemoveModalDialogEventsHandler modalHandler
    CommandState.StartDefaultCommand

End Sub

'-----------------------------------------------------------------------+
'
'   name        ClearBtn_Click
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub ClearBtn_Click()

    viewNumber = 0
    'Label11.Caption = ""
    'ComboBox2.Text = "View 1"
    'Frame2.Caption = "Messages"
        
    'Disables all check boxes
    CheckBox1 = False
    CheckBox2 = False
    CheckBox3 = False
    CheckBox4 = False
    CheckBox5 = False
    CheckBox6 = False
    CheckBox7 = False
    CheckBox8 = False
        
    'Initializes all text fields to ""
    TextBox1.Text = ""
    TextBox2.Text = ""
    TextBox3.Text = ""
    TextBox4.Text = ""
    TextBox5.Text = ""
    TextBox6.Text = ""
    TextBox7.Text = ""
    TextBox8.Text = ""
End Sub

'-----------------------------------------------------------------------+
'
'   name        ComboBox2_Change
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub ComboBox2_Change()
    
    'Sets the active view
    Select Case ComboBox2.Text
    
    Case "View 1"
        CadInputQueue.SendCommand "View off 1"
        CadInputQueue.SendCommand "View on 1"
    
    Case "View 2"
        CadInputQueue.SendCommand "View off 2"
        CadInputQueue.SendCommand "View on 2"
    
    Case "View 3"
        CadInputQueue.SendCommand "View off 3"
        CadInputQueue.SendCommand "View on 3"
    
    Case "View 4"
        CadInputQueue.SendCommand "View off 4"
        CadInputQueue.SendCommand "View on 4"
    
    Case "View 5"
        CadInputQueue.SendCommand "View off 5"
        CadInputQueue.SendCommand "View on 5"
    
    Case "View 6"
        CadInputQueue.SendCommand "View off 6"
        CadInputQueue.SendCommand "View on 6"
    
    Case "View 7"
        CadInputQueue.SendCommand "View off 7"
        CadInputQueue.SendCommand "View on 7"
    
    Case "View 8"
        CadInputQueue.SendCommand "View off 8"
        CadInputQueue.SendCommand "View on 8"
    
    End Select

End Sub

'-----------------------------------------------------------------------+
'
'   name        ExitBtn_Click
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub ExitBtn_Click()

    Dim reply As Integer
    
    'Set ppt = CreateObject("Powerpoint.Application")
    
    reply = MsgBox("Are you sure?", vbInformation + vbYesNo + vbDefaultButton1)

    If reply = vbYes Then
        If ppt.Visible = msoTrue Then
        
            reply = MsgBox("Would you like to save the presentation?", _
                    vbInformation + vbYesNo + vbDefaultButton1)
                    
            If reply = vbYes Then
                Call savePptAs
            End If
            
            ppt.Quit
        End If
            
            'This example app needs to be unloaded after evey use.
            CadInputQueue.SendCommand "vba unload ScrCapturePPT"
    End If

End Sub

Private Sub Label14_Click()

End Sub

'-----------------------------------------------------------------------+
'
'   name        OpenBtn_Click
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub OpenBtn_Click()
    
    Dim message As String
       
    If slideCounter > 0 Then
    
        If ppt.Visible <> msoTrue Then
            ppt.Visible = msoTrue
            ppt.WindowState = ppWindowMaximized
        Else
        
            message = "PowerPoint is already open."
            Call Timer_Sub(message)
          
        End If
    Else
        message = "No Slides have been created."
        Call Timer_Sub(message)
      
    End If
    
Label11.Caption = "The number of active slides are: " + CStr(slideCounter)
      
End Sub

'-----------------------------------------------------------------------+
'
'   name        ProcessBtn_Click
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub ProcessBtn_Click()
    
    Dim i As Integer
    Dim reply As Integer
    Dim message As String
    Dim override As String
    Dim isChecked As String
    Dim textBoxText As String
    Dim slidesToRemove As String
    
    i = 0
    isChecked = "no"
    
    'Closes the VBA Project Manager.
    CadInputQueue.SendCommand "mdl unload vbapm"
    
    'Hides the Capture View(s) dialog box before the screen capture process begins.
    frmCapture.Hide
    
    'Closes the Tool Settings dialog box.
    CadInputQueue.SendCommand "dmsg closedialog -79"
    
    'If Slide Override is the method, the While statement will
    'remove all existing slides.
    If ComboBox1.Text = "Override Slides" Then
        If slideCounter > 0 Then
            While slideCounter > 0
                Set oSlide = oP.Slides(slideCounter)
                oSlide.Delete
                slideCounter = slideCounter - 1
            Wend
      
            override = "yes"
            slideCounter = 0
        Else
            override = "no"
        End If
    Else
        override = "no"
    End If
        
'========================================================================
'
'   Processes the enabled CheckBoxes
'
'========================================================================
    If CheckBox1 = True Then
    
        textBoxText = TextBox1.Text
        viewNumber = 1
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox2 = True Then
    
        textBoxText = TextBox2.Text
        viewNumber = 2
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox3 = True Then
    
        textBoxText = TextBox3.Text
        viewNumber = 3
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox4 = True Then
    
        textBoxText = TextBox4.Text
        viewNumber = 4
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox5 = True Then
    
        textBoxText = TextBox5.Text
        viewNumber = 5
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
        
    If CheckBox6 = True Then
    
        textBoxText = TextBox6.Text
        viewNumber = 6
        isChecked = "yes"
        
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox7 = True Then
    
        textBoxText = TextBox7.Text
        viewNumber = 7
        isChecked = "yes"
                
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    If CheckBox8 = True Then
    
        textBoxText = TextBox8.Text
        viewNumber = 8
        isChecked = "yes"
                
        Call ScrCapture
        Call PPT_Processing(textBoxText, override)
    End If
    
    'Displays the Capture View(s) dialog box after the screen capture process ends.
    frmCapture.Show
    
    'Handles the condition that no CheckBox is enabled.
    If isChecked = "no" Then
    
        message = "No View Windows have been chosen."
        Call Timer_Sub(message)
        
    End If
    
    Label11.Caption = "The number of active slides are: " + CStr(slideCounter)

End Sub

'-----------------------------------------------------------------------+
'
'   name        SaveBtn_Click
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Private Sub SaveBtn_Click()
    
    Dim message As String
    
    If ppt.Visible = msoTrue Then
        Call savePptAs
            
    Else
    
        message = "PowerPoint is not open."
        Call Timer_Sub(message)
            
        Label11.Caption = "The number of active slides are: " + CStr(slideCounter)
    End If

End Sub

'-----------------------------------------------------------------------+
'
'   name        UserForm_Initialize
'
'   author      BSI                              10/2001
'
'-----------------------------------------------------------------------+
Sub UserForm_Initialize()
        
    Dim i As Integer
    Dim MyComboBox()
    
    slideCounter = 0
    viewNumber = 0
    Label11.Caption = ""
    Frame2.Caption = "Messages"
        
    'Disables all check boxes
    CheckBox1 = False
    CheckBox2 = False
    CheckBox3 = False
    CheckBox4 = False
    CheckBox5 = False
    CheckBox6 = False
    CheckBox7 = False
    CheckBox8 = False
        
    'Initializes all text fields to ""
    TextBox1.Text = ""
    TextBox2.Text = ""
    TextBox3.Text = ""
    TextBox4.Text = ""
    TextBox5.Text = ""
    TextBox6.Text = ""
    TextBox7.Text = ""
    TextBox8.Text = ""
'========================================================================
'
'   Initializing ComboBox1
'
'========================================================================
    ComboBox1.Text = "Append Slides"

    'The titles will be added to ComboBox1
    MyComboBox = Array("Append Slides", "Override Slides")
    
     i = 0
    
    For i = 0 To 1
        ComboBox1.AddItem MyComboBox(i)
    Next
    
'========================================================================
'
'   Initializing ComboBox2
'
'========================================================================
    ComboBox2.Text = "View 1"
    
    'The titles will be added to ComboBox2
    MyComboBox = Array("View 1", "View 2", "View 3", "View 4", "View 5", "View 6", "View 7", "View 8")
    
     i = 0
    
    For i = 0 To 7
        ComboBox2.AddItem MyComboBox(i)
    Next
    
End Sub
