Attribute VB_Name = "nativeCode"
Option Explicit
'----------------------------------------------------------------------+
' Module: nativeCode
'
' Status: WORKING
'
' Date: 12/18/03
'
' This module contains windows API declarations and constants.
'
' Author: BSI-DEVSPT
'
' Copyright: (c) 2003 Bentley Systems, Incorporated. All rights reserved.
'
'-----------------------------------------------------------------------+

'-----------------------------------------------------------------------+
'
'   Public Function Declarations
'
'-----------------------------------------------------------------------+

' ### Window Declarations
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

'-----------------------------------------------------------------------+
'
'   Public Constant Members
'
'-----------------------------------------------------------------------+

' ### General Constants
Public Const MAX_WSTRING = 1024
Public Const SUCCESS = 0
Public Const ERROR As Long = -1
Public Const ERROR_OUT_OF_RANGE As Long = -2

' ### Window Constants
Private Const GWL_EXSTYLE = (-20)
Private Const LWA_ALPHA = &H2
Private Const WS_EX_LAYERED = &H80000

'-----------------------------------------------------------------------+
'
'   name        WindowSetTransparent
'
'   author      BSI-DEVSPT                                  10/2003
'
'-----------------------------------------------------------------------+
'
'   DESCRIPTION:    Returns SUCCESS is successful.
'
'-----------------------------------------------------------------------+
Public Function WindowSetTransparent(ByVal hwnd As Long, percentage As Integer) As Long

    Dim Msg As Long

    On Error Resume Next
    If percentage < 0 Or percentage > 255 Then
        'Return the status
        WindowSetTransparent = ERROR_OUT_OF_RANGE
    Else
        Msg = GetWindowLong(hwnd, GWL_EXSTYLE)
        Msg = Msg Or WS_EX_LAYERED

        SetWindowLong hwnd, GWL_EXSTYLE, Msg
        SetLayeredWindowAttributes hwnd, 0, percentage, LWA_ALPHA

        'Return the status
        WindowSetTransparent = SUCCESS
    End If

    If Err Then
        'Return the status
        WindowSetTransparent = ERROR
    End If

End Function

'-----------------------------------------------------------------------+
'
'   name        GetHandle
'
'   author      BSI-DEVSPT                                  10/2003
'
'-----------------------------------------------------------------------+
'
'   DESCRIPTION:    Returns the User Form's handle
'                   or null for an error
'
'-----------------------------------------------------------------------+
Public Function GetHandle(ByRef Form As UserForm) As Long

    GetHandle = FindWindow("ThunderDFrame", Form.Caption)

End Function

