Attribute VB_Name = "viewChangeWindow"
'----------------------------------------------------------------------------
' viewChangeWindow
'
' Status: WORKING
'
' Date: 12/26/02
'
' This example illustrates how to change the view to an application window.
'
' Author: BSI
'
'----------------------------------------------------------------------------
'-----------------------------------------------------------------------+
'
'   name        ViewChangeWindow
'
'   Author      BSI                                         12/2002
'
'-----------------------------------------------------------------------+
'
'   Description:    This sub will move the view window to the specified
'                   application window.
'
'                   Note: The application window are zero based so
'                   Screen 1 = 0 and Screen 2 = 1.
'
'-----------------------------------------------------------------------+
Sub viewChangeWindow(viewNumber As Integer, newScreenNumber As Integer)

    Dim windowP As Long
    Dim newGlobalOriginP As Point2d
    Dim screenNumber As Integer
    Dim rtn As Integer

    If viewNumber >= 0 And viewNumber < 8 Then
        
        newGlobalOriginP.X = 0
        newGlobalOriginP.Y = 0
    
        'Get the view window pointer
        windowP = GetCExpressionValue("mdlWindow_viewWindowGet (" + CStr(viewNumber) + ")")
    
        'Get the screen number
        screenNumber = GetCExpressionValue("mdlWindow_screenNumGet (" & windowP & ")")
    
        On Error GoTo updateError
        
        'Move the view
        rtn = GetCExpressionValue("mdlWindow_changeScreen (" & windowP & "," & CStr(screenNumber) & "," & _
                                  CStr(newScreenNumber) & "," & VarPtr(newGlobalOriginP) & ", 0, 0)")
    
        'Maximize the view window
        rtn = GetCExpressionValue("mdlWindow_maximize (" & windowP & ")")
    
        Exit Sub
    
updateError:
        rtn = GetCExpressionValue("mdlWindow_maximize (" & windowP & ")")
        On Error GoTo 0
    Else
    
    ShowError "Not a valid view or Window number"
    End If

End Sub
'-----------------------------------------------------------------------+
'
'   name        main
'
'   Author      BSI                                         12/2002
'
'-----------------------------------------------------------------------+
'
'   Description:    This function main entry point for the example.
'
'-----------------------------------------------------------------------+
Sub main()

'Check for keyin arguments
If KeyinArguments <> "" Then
    Dim asArguments() As String
    
    'Parse KeyinArguments into an array of strings
    asArguments = Split(KeyinArguments)
    
    'Change the view's window
    viewChangeWindow Val(asArguments(0) - 1), Val(asArguments(1))
    
    Exit Sub
Else
    'Load the form
    Unload ViewForm
    Load ViewForm

    ViewForm.Show
    
End If

End Sub
