Attribute VB_Name = "window"
Option Explicit
'-----------------------------------------------------------------------+
'
'   name        FileOpenDialog
'
'   author      BSI-DEVSPT                                  7/2001
'
'-----------------------------------------------------------------------+
Public Function FileOpenDialog(strTitle As String, strDir As String, strFileExt As String, _
                               strFileExtDescription As String) As String

    ' SAMPLE USAGE:
    '
    ' Dim filename As String
    ' ...
    ' filename = FileOpenDialog("Import Excel Spreadsheet data", "c:\", "*.xls", "Excel Spreadsheet")
    ' MsgBox (filename)
    
    Dim OpenFile    As OPENFILENAME
    Dim status      As Long
    Dim pos         As Long     ' Used for trimming C style string.
    Dim strTmp      As String   ' Used for trimming C style string.
    Dim strFilter   As String
         
    ' Populate the OPENFILENAME data type
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hwndOwner = 0
    OpenFile.hInstance = 0 'App.hInstance
    strFilter = strFileExtDescription & " (" & strFileExt & ")" & Chr(0) & strFileExt & Chr(0)
    OpenFile.lpstrFilter = strFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrInitialDir = strDir
    OpenFile.lpstrTitle = strTitle
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.flags = 0
    
    ' Open the file open dialog box
    status = GetOpenFileName(OpenFile)
         
    ' Return the file selected
    If status = 0 Then
        FileOpenDialog = ""
    Else
        ' Trim C style string for compatibility with VB strings.
        strTmp = Chr$(0)
        pos = InStr(OpenFile.lpstrFile, strTmp)
        FileOpenDialog = Left(OpenFile.lpstrFile, pos - 1)
    End If
    
End Function
'-----------------------------------------------------------------------+
'
'   name        SetIcon
'
'   author      BSI-SetIcon                                  5/2003
'
'-----------------------------------------------------------------------+
'
'   DESCRIPTION:    Sets the Icon of the given window handl.
'                   Returns SUCCESS or -1 for an error
'
'-----------------------------------------------------------------------+
Public Function SetIcon(hwnd As Long, iconFileName As String) As Long
        
    Dim status As Long
    Dim hIcon As Long
       
    'Load the image
    hIcon = LoadImageA(0, iconFileName, IMAGE_ICON, 0, 0, &H0 Or LR_LOADFROMFILE)
    status = SetWindowLong(hwnd, -14, hIcon)
    
    'Send the message WM_SETICON to the form
    SendMessage hwnd, WM_SETICON, True, hIcon
    SendMessage hwnd, WM_SETICON, False, hIcon
    
    'Send the message WM_PAINT to the form
    SendMessage hwnd, WM_PAINT, True, 0
    SendMessage hwnd, WM_PAINT, False, 0
        
    If status = 0 Then
        SetIcon = -1
    Else
        SetIcon = SUCCESS
    End If
    
End Function

