Attribute VB_Name = "modDgnData"
Option Explicit

'-----------------------------------------------------------------------+
'                                                                       |
' Copyright 1993-2001, Bentley Systems, Incorporated                    |
' All rights reserved.                                                  |
'                                                                       |
' Limited permission is hereby granted to reproduce and modify this     |
' copyrighted material provided that the resulting code is used only in |
' conjunction with Bentley Systems products under the terms of the      |
' license agreement provided therein, and that this notice is retained  |
' in its entirety in any such reproduction or modification.             |
'                                                                       |
'----------------------------------------------------------------------*/
'-----------------------------------------------------------------------+
' dgndata
'
' Status: WORKING
'
' Date: 09/14/01
'
' The example reads an excel spreadsheet for symbology and coordinate data.
' It then generates the specified element type in the dgn.  Currently,
' processes line elements only.
'
' Tools Required:
'   MicroSoft Excel 8.0 Object Library
'
' Author: Mary Hamric
'
'-----------------------------------------------------------------------+
'
'  keyins to execute:
'  vba load dgndata    'loads project if not already loaded
'  vba run [dgndata]main
'
'  can also be executed from the VBA Project Manager
'---------------------------------------------------------------------

'-----------------------------------------------------------------------+
'
'   name        main
'
'   author      BSI                                             03/2001
'
'-----------------------------------------------------------------------+
Sub main()
    Dim myxl          As New Excel.Application
    Dim elmtype       As Integer
    Dim level         As Integer
    Dim weight        As Integer
    Dim style         As Integer
    Dim row           As Integer
    Dim count         As Integer
    Dim openfile      As New CommonDialog
    Dim xlsName       As String
    Dim startpnt      As Point3d
    Dim endpnt        As Point3d
    Dim oEl           As LineElement
    
    ' use Common Dialog for a "File Open" dialog box
    openfile.FileName = ""
    openfile.DialogTitle = "DGNDATA example - Select Data File"
    openfile.Filter = "Microsoft Excel Worbook(*.xls);*.xls"
    openfile.DefaultExt = "xls"
    openfile.ShowOpen
    
    ' if a file was selected, grab the file name
    If openfile.FileName <> "" Then
        ' open specified file
        myxl.Workbooks.Open openfile.FileName
        row = 1
        count = 0
        ' read in each row of info, stop when empty cell is founds..assumes no blanks rows
        Do While myxl.cells(row, 1).Value <> ""
            elmtype = myxl.cells(row, 1).Value
            If 3 = elmtype Then
                startpnt.X = myxl.cells(row, 6).Value
                startpnt.Y = myxl.cells(row, 7).Value
                startpnt.Z = myxl.cells(row, 8).Value
                endpnt.X = myxl.cells(row, 9).Value
                endpnt.Y = myxl.cells(row, 10).Value
                endpnt.Z = myxl.cells(row, 11).Value
                
                ' create line element
                Set oEl = CreateLineElement2(Nothing, startpnt, endpnt)
                
                ' set symbology values
                Set oEl.level = ActiveDesignFile.Levels(myxl.cells(row, 2).Value)
                oEl.Color = myxl.cells(row, 3).Value
                oEl.LineWeight = myxl.cells(row, 4).Value
                oEl.LineStyle = myxl.cells(row, 5).Value
                
                ' add line to design file
                ActiveModelReference.AddElement oEl
                ' display line
                oEl.Redraw
            End If
            count = row
            row = row + 1
        Loop
        ' Close Excel with the Quit method on the Application object.
        myxl.Quit
    
        ' Release the object variable.
        Set myxl = Nothing
        
        ' microstation keyins to place title block cell
        CadInputQueue.SendCommand "as=0.5"
        CadInputQueue.SendCommand "rc=border"
        CadInputQueue.SendCommand "ac=title"
        CadInputQueue.SendCommand ("xy=" & CStr(-0.9) & "," & CStr(10.4))
        CadInputQueue.SendCommand "fit view extended 1"
        CadInputQueue.SendCommand "update all"
        ' Terminate any active commands
        CadInputQueue.SendCommand "NULL"

    
    End If
                    

End Sub

