Attribute VB_Name = "InRoadsTest"
Option Explicit

'-----------------------------------------------------------------------+
'
'   name        CStringTrim
'
'   author      BSI-DEVSPT                                  2/2003
'
'-----------------------------------------------------------------------+
'
'   DESCRIPTION:    Trim C style string trailing null character "chr(0)"
'                   for compatibility with VB strings.
'
'   SAMPLE USAGE:   CStringTrim varName
'
'-----------------------------------------------------------------------+
Public Function CStringTrim(ByRef strCBuffer As String) As Long

    Dim pos As Long 'Position in string of Null character

    ' Trim C style string for compatibility with VB strings
    pos = InStr(strCBuffer, Chr$(0))
    
    ' Only modify a C style string
    If pos < 0 Then CStringTrim = 0
    strCBuffer = Left(strCBuffer, pos - 1)
    CStringTrim = pos

End Function

'-----------------------------------------------------------------------+
'
'   name        main
'
'   author      BSI-DEVSPT                                  2/2003
'
'-----------------------------------------------------------------------+
Sub Main()

    Dim prj     As Long
    Dim cnt     As Integer
    Dim sts     As Integer
    Dim desc    As String
    Dim file    As String
    Dim name    As String
    Dim message As String
    
    ' Try to initialize the InRoads SDK
    sts = scadSDK_initialize()
    If sts <> 0 Then End
    
    ' Initialization
    file = String$(ALGFILSZ, vbNullChar) 'ALGFILSZ = 256
    name = String$(ALGNAMSZ, vbNullChar) 'ALGNAMSZ = 64
    desc = String$(ALGDSCSZ, vbNullChar) 'ALGDSCSZ = 80
    message = String$(ALGFILSZ, vbNullChar)
    
    ' Get the number of projects - there should always be at least one "Default"
    cnt = scadSDK_cogoCountNumberOfProjects()
    If cnt < 1 Then End
    
    ' Display some information about the project
    sts = scadSDK_cogoGetActiveProject(prj)
    sts = scadSDK_cogoProjectInfoGet(file, name, desc, prj)
        
    ' Trim C style string for compatibility with VB strings.
    CStringTrim name
    message = "Project Name: " + name + Chr(13) + "Project Addr: " + Str(prj)
    MsgBox message
    
End Sub
